         PRINT NOGEN
         BEGIN NAME=QM22,IBM=YES,BASE=(R8,R6,R7),AMODE=64
***********************************************************************
*          Licensed Materials - Property of IBM                       *
*          "Restricted Materials of IBM"                              *
*          5748-T15                                                   *
*          Copyright IBM Corp. 2005,2011                              *
*          All Rights Reserved                                        *
*          US Government Users Restricted Rights - Use, duplication   *
*          or disclosure restricted by GSA ADP Schedule Contract      *
*          with IBM Corp.                                             *
***********************************************************************
*  This file is provided on an "as is" basis.  There are no           *
*  warranties, express or implied, including the implied warranties   *
*  of merchantability and fitness for a particular purpose.           *
*  IBM has no obligation to provide service, defect correction, or    *
*  any maintenance for the file.  IBM has no obligation to supply     *
*  any updates or enhancements for the file to you even if such are   *
*  or later become available.                                         *
***********************************************************************
*  Change History                                                     *
*  20041001  Initial Version                                          *
*  20110207  Rename Q111 and Q222 to QM11 and QM22 to resolve         *
*            program name conflicts with libstdc++34. Refer to        *
*            feature/defect 21558 and 21700 for more info.            *
*                                                                     *
*                                                                     *
***********************************************************************
         DRV51
**************************************************************
* QM22 contains the following testcases for the PNAMC macro: *
*   case1   PNAMC FINDNAME,FIELD=NAME,NOTFOUND=PNAMC012      *
*   case1a  PNAMC FINDNAME,FIELD=NAME,FOUND=PNAMC016         *
*   case02  PNAMC NEWTRNAME,NAMETYPE=CALLER,FOUND=PNAMC022   *
*   case03  PNAMC FIELD=NAME,NAMETYPE=CALLER,FOUND=PNAMC032  *
*   case04  PNAMC FIELD=NAME,NAMETYPE=TRACE                  *
*   case05  PNAMC NEWTRNAME,NAMETYPE=PAT                     *
*   case06  PNAMC NEWTRNAME                                  *
*   case07  PNAMC NEWTRNAME,FIELD=NAME                       *
*   case08  PNAMC NEWTRNAME,NAMETYPE=PROGRAM                 *
*   case09  PNAMC FIELD=NAME                                 *
*   case10  PNAMC FIELD=NAME,NAMETYPE=PAT                    *
*   case11  PNAMC FIELD=NAME,NAMETYPE=PROGRAM                *
* The following two testcases are in QMAX:                   *
*           PNAMC NEWTRNAME CALLER NOTFOUND testcase         *
*           PNAMC (SAVENAME)CALLER NOTFOUND testcase         *
* QMAX BSO is composed of program QMAX, QM11 and QM22        *
* The order of the Function Nesting Area for QM22:           *
* CVZZ ->QMAC -ENTDC-> QMAX --ENTRC--> QM11 --ENTRC--> QM22  *
*                       ^-(Pat for QM22) ^-(Caller for QM22) *
**************************************************************
         USING PNAMCRET,R3
         SGR   R1,R1         used for buffers of before registers
         SGR   R2,R2         used for buffer of after registers
         SGR   R3,R3         field for returned info from pnamc
*
* allocate buffers to save registers
         LA    R1,LEN64REG*16
         MALOC SIZE=R1,HEAP=64BIT
         LTGR  R1,R1         address of block is zero if error

         JNZ   PNAMC000      no error, -> continue processing
         PRERR TEXT='QM22: error in set up *** Case Failed ***'
         J     RETPNAMC
*
PNAMC000 DS    0H
         LA    R2,LEN64REG*16
         MALOC SIZE=R2,HEAP=64BIT
         LTGR  R2,R2         address of block is zero if error
         JNZ   PNAMC002      no error, -> continue processing
         PRERR TEXT='QM22: error in set up *** Case Failed ***'
         J     RETPNAMC
*
PNAMC002 DS    0H
         LA    R3,L'RETBUF
         MALOC SIZE=R3,HEAP=64BIT
         LTGR  R3,R3         address of block is zero if error
         JNZ   PNAMC010      no error, -> continue processing
         PRERR TEXT='QM22: error in set up *** Case Failed ***'
         J     RETPNAMC
*
* PNAMC FINDNAME,FIELD=,NOTFOUND testcase
* testcase #1- expected NOTFOUND
PNAMC010 DS    0H
         PRMSG TEXT='QM22: 1-Testing PNAMC FINDNAME,FIELD=,NOTFOUND='
         MVC   NAME,=C'Q???' set the name used by FINDNAME
         STMG  R0,R15,0(R1)  save contents of registers
         PNAMC FINDNAME,FIELD=NAME,NOTFOUND=PNAMC012
         PRERR TEXT='QM22: 1-Found error *** Case Failed ***'
         J     PNAMC015      -> next test case
PNAMC012 DS    0H
         STMG  R0,R15,0(R2)  save contents of registers
         CLC   0(LEN64REG*14,R1),0(R2)  r0-r13 corrupted across macro?
         JE    PNAMC014      no error, -> continue processing
         PRERR TEXT='QM22: 1-Registers corrupted *** Case Failed ***'
         J     PNAMC015      -> next test case
PNAMC014 DS    0H
         PRMSG TEXT='QM22: 1-Test executed successfully'
*
* PNAMC FINDNAME,FIELD=,FOUND testcase
* testcase #1a- expected found
PNAMC015 DS    0H
         PRMSG TEXT='QM22: 1a-Testing PNAMC FINDNAME,FIELD=,FOUND='
         MVC   NAME,=C'QMAX' set the name used by FINDNAME
         STMG  R0,R15,0(R1)  save contents of registers
         PNAMC FINDNAME,FIELD=NAME,FOUND=PNAMC016
         PRERR TEXT='QM22: 1a-Not found error *** Case Failed ***'
         J     PNAMC020      -> next test case
PNAMC016 DS    0H
         STMG  R0,R15,0(R2)  save contents of registers
         CLC   0(LEN64REG*14,R1),0(R2)  r0-r13 corrupted across macro?
         JE    PNAMC018      no error, -> continue processing
         PRERR TEXT='QM22: 1a-Registers corrupted *** Case Failed ***'
         J     PNAMC020      -> next test case
PNAMC018 DS    0H
         PRMSG TEXT='QM22: 1a-Test executed successfully'
*
* PNAMC NEWTRNAME,CALLER,FOUND testcase
* testcase #2- update CE3TRNAME with the CALLER option
*               the content of the FIELD is QMAX and the caller is QM11
PNAMC020 DS    0H
         PRMSG TEXT='QM22: 2-Testing PNAMC NEWTRNAME,CALLER,FOUND='
         STMG  R0,R15,0(R1)  save contents of registers
         PNAMC NEWTRNAME,NAMETYPE=CALLER,FOUND=PNAMC022
         PRERR TEXT='QM22: 2-Not found error *** Case Failed ***'
         J     PNAMC030      -> next test case
PNAMC022 DS    0H
         STMG  R0,R15,0(R2)  save contents of registers
         CLC   0(LEN64REG*14,R1),0(R2)  r0-r13 corrupted across macro?
         JE    PNAMC024      no error, -> continue processing
         PRERR TEXT='QM22: 2-Registers corrupted *** Case Failed ***'
         J     PNAMC030      -> next test case
PNAMC024 DS    0H
         LA    R4,CE3TRNAME(R12,R9)
         CLC   0(L'CE3TRNAME,R4),=C'QM11'
         JE    PNAMC026      no error, -> continue processing
         PRERR TEXT='QM22: 2-Incorrect CE3TRNAME update *Case Failed*'
         J     PNAMC030     continue processing rest of tests
PNAMC026 DS    0H
         PRMSG TEXT='QM22: 2-test executed successfully'
*
* PNAMC SAVENAME,CALLER,FOUND testcase
* testcase #3- update FIELD with the CALLER option
*               the caller is QM11
PNAMC030 DS    0H
         PRMSG TEXT='QM22:  3-Testing PNAMC SAVENAME,CALLER,FOUND='
         STMG  R0,R15,0(R1)  save contents of registers
         PNAMC FIELD=NAME,NAMETYPE=CALLER,FOUND=PNAMC032
         PRERR TEXT='QM22:  3-Not found error *** Case Failed ***'
         J     PNAMC040      -> next test case
PNAMC032 DS    0H
         STMG  R0,R15,0(R2)  save contents of registers
         CLC   0(LEN64REG*14,R1),0(R2)  r0-r13 corrupted across macro?
         JE    PNAMC034      no error, -> continue processing
         PRERR TEXT='QM22:  3-registers corrupted *** Case Failed ***'
         J     PNAMC040      continue processing rest of tests
PNAMC034 DS    0H
         CLC   NAME,=C'QM11'
         JE    PNAMC036      no error, -> continue processing
         PRERR TEXT='QM22: 3-Incorrect FIELD update ** Case Failed **'
         J     PNAMC040      continue processing
PNAMC036 DS    0H
         PRMSG TEXT='QM22:  3-test executed successfully'
*
* PNAMC SAVENAME,TRACE testcase
* testcase #4
*               the content of the CE3TRNAME is QM11
PNAMC040 DS    0H
         PRMSG TEXT='QM22:  4-Testing PNAMC SAVENAME,TRACE'
         XC    RETBUF,RETBUF  nullify name field
         STMG  R0,R15,0(R1)  save contents of registers
         PNAMC FIELD=NAME,NAMETYPE=TRACE
         STMG  R0,R15,0(R2)  save contents of registers
         CLC   0(LEN64REG*14,R1),0(R2)  r0-r13 corrupted across macro?
         JE    PNAMC042      no error, -> continue processing
         PRERR TEXT='QM22: 4-registers corrupted *** Case Failed ***'
         J     PNAMC050      finished with this test case
PNAMC042 DS    0H
         CLC   NAME,=C'QM11'
         JE    PNAMC046      no error, -> continue processing
         PRERR TEXT='QM22: 4-Incorrect FIELD update ** Case Failed **'
         J     PNAMC050      continue processing
PNAMC046 DS    0H
         PRMSG TEXT='QM22:  4-test executed successfully'


*
* PNAMC NEWTRNAME PAT testcase
* testcase #5
*               the content of the PAT is QMAX and the caller is QM11
PNAMC050 DS    0H
         PRMSG TEXT='QM22:  5-Testing  PNAMC NEWTRNAME,PAT'
         STMG  R0,R15,0(R1)  save contents of registers
         PNAMC NEWTRNAME,NAMETYPE=PAT
         STMG  R0,R15,0(R2)  save contents of registers
         CLC   0(LEN64REG*14,R1),0(R2)  r0-r13 corrupted across macro?
         JE    PNAMC052      no error, -> continue processing
         PRERR TEXT='QM22: 5-registers corrupted *** Case Failed ***'
         J     PNAMC060      finished with this test case
PNAMC052 DS    0H
         LA    R4,CE3TRNAME(R12,R9)
         CLC   0(L'CE3TRNAME,R4),=C'QMAX'
         JE    PNAMC056      no error, -> continue processing
         PRERR TEXT='QM22: 5-invalid return value *** Case Failed ***'
         J     PNAMC060      continue processing
PNAMC056 DS    0H
         PRMSG TEXT='QM22:  5-test executed successfully'

*
* PNAMC NEWTRNAME, Default option (ie. NAMETYPE=PROGRAM) testcase
* testcase #6
PNAMC060 DS    0H
         PRMSG TEXT='QM22:  6-Testing  PNAMC NEWTRNAME,default option'
         STMG  R0,R15,0(R1)  save contents of registers
         PNAMC NEWTRNAME
         STMG  R0,R15,0(R2)  save contents of registers
         CLC   0(LEN64REG*14,R1),0(R2)  r0-r13 corrupted across macro?
         JE    PNAMC062      no error, -> continue processing
         PRERR TEXT='QM22: 6-registers corrupted *** Case Failed ***'
         J     PNAMC070      finished with this test case
PNAMC062 DS    0H
         LA    R4,CE3TRNAME(R12,R9)
         CLC   0(L'CE3TRNAME,R4),=C'QM22'
         JE    PNAMC066      no error, -> continue processing
         PRERR TEXT='QM22: 6-Invalid CE3TRNAME update * Case Failed *'
         J     PNAMC070      continue processing
PNAMC066 DS    0H
         PRMSG TEXT='QM22:  6-test executed successfully'
*
* PNAMC NEWTRNAME,FIELD= testcase
* testcase #7
PNAMC070 DS    0H
         PRMSG TEXT='QM22:  7-Testing PNAMC NEWTRNAME,FIELD='
         MVC   NAME,=C'Q??Q' set new trace name
         STMG  R0,R15,0(R1)  save contents of registers
         PNAMC NEWTRNAME,FIELD=NAME
         STMG  R0,R15,0(R2)  save contents of registers
         CLC   0(LEN64REG*14,R1),0(R2)  r0-r13 corrupted across macro?
         JE    PNAMC072      no error, -> continue processing
         PRERR TEXT='QM22: 7-registers corrupted *** Case Failed ***'
         J     PNAMC080      finished with this test case
PNAMC072 DS    0H
         LA    R4,CE3TRNAME(R12,R9)
         CLC   0(L'CE3TRNAME,R4),=C'Q??Q' check the change is correctly
         JE    PNAMC076      no error, -> continue processing
         PRERR TEXT='QM22: 7-change trace name *** Case Failed ***'
         J     PNAMC080      continue processing
PNAMC076 DS    0H
         PRMSG TEXT='QM22:  7-test executed successfully'
*
* restore CE3TRNAME
* PNAMC NEWTRNAME,PROGRAM testcase
* testcase #8
PNAMC080 DS    0H
         PRMSG TEXT='QM22:  8-Testing PNAMC NEWTRNAME,PROGRAM'
         XC    RETBUF,RETBUF  initialize return field
         STMG  R0,R15,0(R1)  save contents of registers
         PNAMC NEWTRNAME,NAMETYPE=PROGRAM
         STMG  R0,R15,0(R2)  save contents of registers
         CLC   0(LEN64REG*14,R1),0(R2)  r0-r13 corrupted across macro?
         JE    PNAMC082      no error, -> continue processing
         PRERR TEXT='QM22: 8-registers corrupted *** Case Failed ***'
         J     PNAMC090      finished with this test case
PNAMC082 DS    0H
         LA    R4,CE3TRNAME(R12,R9)
         CLC   0(L'CE3TRNAME,R4),=C'QM22'
         JE    PNAMC086      no error, -> continue processing
         PRERR TEXT='QM22: 8-Incorrect CE3TRNAME update * Case Failed*'
         J     PNAMC090      continue processing
PNAMC086 DS    0H
         PRMSG TEXT='QM22:  8-test executed successfully'

*
* PNAMC SAVENAME,FIELD= testcase
* test case #9 update FIELD with the default option (ie. PROGRAM)
*              the content of the PROGRAM header is QM22
PNAMC090 DS    0H
         PRMSG TEXT='QM22:  9-Testing PNAMC FIELD='
         STMG  R0,R15,0(R1)  save contents of registers
         PNAMC FIELD=NAME
         STMG  R0,R15,0(R2)  save contents of registers
         CLC   0(LEN64REG*16,R1),0(R2)  r0-r15 corrupted across macro?
         JE    PNAMC092      no error, -> continue processing
         PRERR TEXT='QM22:  9-registers corrupted *** Case Failed ***'
         J     PNAMC100      all testcases completed
PNAMC092 DS    0H
         CLC   NAME,=C'QM22'
         JE    PNAMC096      no error, -> continue processing
         PRERR TEXT='QM22:  9-Incorrect FIELD update * Case Failed *'
         J     PNAMC100      all testcases completed
PNAMC096 DS    0H
         PRMSG TEXT='QM22: 9-test executed successfully'

*
* PNAMC SAVENAME,FIELD=,PAT testcase
* testcase #10- update FIELD with the PAT option
*               the content of the PAT is QMAX
PNAMC100 DS    0H
         PRMSG TEXT='QM22:  10-Testing PNAMC FIELD=,PAT'
         STMG  R0,R15,0(R1)  save contents of registers
         PNAMC FIELD=NAME,NAMETYPE=PAT
         STMG  R0,R15,0(R2)  save contents of registers
         CLC   0(LEN64REG*14,R1),0(R2)  r0-r13 corrupted across macro?
         JE    PNAMC102      no error, -> continue processing
         PRERR TEXT='QM22: 10-registers corrupted *** Case Failed ***'
         J     PNAMC110      continue processing rest of tests
PNAMC102 DS    0H
         CLC   NAME,=C'QMAX'
         JE    PNAMC106      no error, -> continue processing
         PRERR TEXT='QM22:  10-Incorrect FIELD update * Case Failed *'
         J     PNAMC110      continue processing
PNAMC106 DS    0H
         PRMSG TEXT='QM22:  10-test executed successfully'
*
* PNAMC default (ie. SAVENAME),FIELD=,PROGRAM testcase
* test case #11- update FIELD with the PROGRAM option
*               the content of the PROGRAM header is QM22
PNAMC110 DS    0H
         PRMSG TEXT='QM22: 11-Testing PNAMC FIELD=,PROGRAM'
         STMG  R0,R15,0(R1)  save contents of registers
         PNAMC FIELD=NAME,NAMETYPE=PROGRAM
         STMG  R0,R15,0(R2)  save contents of registers
         CLC   0(LEN64REG*16,R1),0(R2)  r0-r15 corrupted across macro?
         JE    PNAMC112      no error, -> continue processing
         PRERR TEXT='QM22: 11-registers corrupted *** Case Failed ***'
         J     RETPNAMC      all testcases completed
PNAMC112 DS    0H
         CLC   NAME,=C'QM22'
         JE    PNAMC116      no error, -> continue processing
         PRERR TEXT='QM22: 11-Incorrect FIELD update * Case Failed *'
         J     RETPNAMC      all testcases completed
PNAMC116 DS    0H
         PRMSG TEXT='QM22: 11-test executed successfully'
*
RETPNAMC DS    0H
         FREEC BLOCK=R1
         FREEC BLOCK=R2
         FREEC BLOCK=R3
*
         PRMSG TEXT='QM22: FREEC BLOCK and BACKC'
         BACKC
         EJECT
         LTORG
         FINIS
*
PNAMCRET DSECT
RETBUF   DS    0CL5
NAME     DS    CL4
SPARE    DS    CL1
*
         END
