#######################################################################
#          Licensed Materials - Property of IBM                       #
#          "Restricted Materials of IBM"                              #
#          5748-T15                                                   #
#          (C) Copyright IBM Corp. 2005, 2006                         #
#          All Rights Reserved                                        #
#          US Government Users Restricted Rights - Use, duplication   #
#          or disclosure restricted by GSA ADP Schedule Contract      #
#          with IBM Corp.                                             #
#######################################################################
#  This file is provided on an "as is" basis.  There are no           #
#  warranties, express or implied, including the implied warranties   #
#  of merchantability and fitness for a particular purpose.           #
#  IBM has no obligation to provide service, defect correction, or    #
#  any maintenance for the file.  IBM has no obligation to supply     #
#  any updates or enhancements for the file to you even if such are   #
#  or later become available.                                         #
#######################################################################
#  Change History                                                     #
#  20041001  Initial Version                                          #
#  20060403  F14109  Add tpf_stpoc to API5 driver (qmac70.cpp).       #
#  20060929  F14494  Add usergroup to API5 driver (qmac99.cpp).       #
#  20070713  F15945  Add drv_zdcrt_func to API5 driver (qmac80.cpp).  #
#                    Add pausc_func(void) to API5 driver (qmac85.cpp) #
#                                                                     #
#                                                                     #
#######################################################################

###############################################################################
# Define the 4 character base name for this shared object or executable
###############################################################################

APP := QMAC
APP_ENTRY := QMAC
APP_EXPORT := ENTRY
TPF_DRIVER := api5

################################################################################
# Define the module is to reside in the 31bit CRPA
# keep the option for the 31 bit mode of errnoc_macro test case in qmac50.asm
################################################################################

LDFLAGS_QMAC := -Xlinker --defsym -Xlinker CGCC_31BIT=0

################################################################################
# Define the envs needed to build this module, in the order of precedence
################################################################################

maketpf_env := drvs
maketpf_env += base_rt
maketpf_env += system

################################################################################
# Define the libs needed to link (-l)
# - how do we handle including a file of all TPF libs?
# - do we have to remove name of lib from "all list" when building name?
################################################################################

#LIBS :=

################################################################################
# Segments to be compiled with gcc compiler
################################################################################

CXX_SRC := qmac00.cpp
CXX_SRC += qmac10.cpp
CXX_SRC += qmac20.cpp
CXX_SRC += qmac21.cpp
CXX_SRC += qmac23.cpp
CXX_SRC += qmac40.cpp
CXX_SRC += qmac60.cpp
CXX_SRC += qmac70.cpp
CXX_SRC += qmac80.cpp
CXX_SRC += qmac85.cpp
CXX_SRC += qmac90.cpp
CXX_SRC += qmac99.cpp

################################################################################
# Segments to be assembled
################################################################################

ASM_SRC := qmac22.asm
ASM_SRC += qmac30.asm
ASM_SRC += qmac41.asm
ASM_SRC += qmac42.asm
ASM_SRC += qmac50.asm
ASM_SRC += qmac55.asm

#ASMFLAGS_MAK =

################################################################################
# Include the maketpf.rules
################################################################################

include maketpf.rules
