         PRINT NOGEN
         BEGIN NAME=QMAC22,IBM=YES,TPFISOC=YES,EREGSAVE=ENABLE
***********************************************************************
*          Licensed Materials - Property of IBM                       *
*          "Restricted Materials of IBM"                              *
*          5748-T15                                                   *
*          (C) Copyright IBM Corp. 2005                               *
*          All Rights Reserved                                        *
*          US Government Users Restricted Rights - Use, duplication   *
*          or disclosure restricted by GSA ADP Schedule Contract      *
*          with IBM Corp.                                             *
***********************************************************************
*  This file is provided on an "as is" basis.  There are no           *
*  warranties, express or implied, including the implied warranties   *
*  of merchantability and fitness for a particular purpose.           *
*  IBM has no obligation to provide service, defect correction, or    *
*  any maintenance for the file.  IBM has no obligation to supply     *
*  any updates or enhancements for the file to you even if such are   *
*  or later become available.                                         *
***********************************************************************
*  Change History                                                     *
*  20041001  Initial Version                                          *
*                                                                     *
*                                                                     *
*                                                                     *
***********************************************************************
*                                                                     *
* GENERAL INFORMATION:                                                *
* CSO name:       QMAC                                                *
* Members:        qmac22.asm                                          *
* Called by:      qmac00.cpp                                          *
* Purpose: Test cases for Extended Register Save capability           *
*                                                                     *
***********************************************************************
         DRV51
         CLHEQ
*
         PRLGC ENAME=defbc_macro,BASE=R8,STACK=R13
******************************************
* This function executes the defbc macro *
******************************************
         CLI   EBX000,X'00'  Error cases requested ?
         JNE   DEFBCERR      Branch if yes
         SGR   R1,R1         Used for buffers of before registers
         SGR   R2,R2         Used for buffer of after registers
*
* allocate buffers to save registers
         LA    R1,LEN64REG*16
         MALOC SIZE=R1,HEAP=64BIT
         LTGR  R1,R1         Address of block is zero if error
         JNZ   DEFBC000      No error, -> continue processing
         PRERR TEXT='QMAC: error in MALOC set up *** Case Failed ***'
         J     RETDEFBC
*
DEFBC000 DS    0H
         PRMSG TEXT='QMAC: Test BEGIN ..,TPFISOC=YES,EREGSAVE=ENABLE'
         STMG  R10,R15,0(R1)  Save contents of registers
         LA    R2,LEN64REG*16
         MALOC SIZE=R2,HEAP=64BIT
         LTGR  R2,R2         Address of block is zero if error
         JNZ   DEFBC006      No error-> check the r10-r13
         PRERR TEXT='QMAC: error in MALOC set up *** Case Failed ***'
         J     RETDEFBC
*
DEFBC006 DS    0H
         STMG  R10,R15,0(R2)  Save contents of registers
         CLC   0(LEN64REG*4,R1),0(R2)  r10-r13 corrupted across macro?
         JNE   DEFBC008      Corrupted, no error-> test next macro
         PRERR TEXT='QMAC: 1- Registers did not corrupt by MALOC error'
         J     DEFBC010      -> Next test case
*
* local constants for this function
         DS    0D
CTOKEN   DC    C'apicorhc'
DEFBCID  DC    C'DEFBC'
*
DEFBC008 DS    0H
         PRMSG TEXT='QMAC: 1- Call MALLOC, r10-r13 corrupted'
*
* Without DEFBC EREGSAVE=YES, r10-r13 should be corrupted
DEFBC010 DS    0H
         STMG  R10,R15,0(R1)  Save contents of registers
         CORHC CTOKEN,SIZE=64BIT
         STMG  R10,R15,0(R2)  Save contents of registers
         CLC   0(LEN64REG*4,R1),0(R2)  r10-r13 corrupted across macro?
         JNE   DEFBC016      Corrupted, no error -> continue processing
         PRERR TEXT='QMAC: 2- Registers did not corrupt'
         J     DEFBC020      -> Next test case
DEFBC016 DS    0H
         PRMSG TEXT='QMAC: 2- Call CORHC, r10-r13 corrupted'
DEFBC020 DS    0H
         STMG  R10,R15,0(R1)  Save contents of registers
         CORUC CTOKEN,SIZE=64BIT
         STMG  R10,R15,0(R2)  Save contents of registers
         CLC   0(LEN64REG*4,R1),0(R2)  r10-r13 corrupted across macro?
         JNE   DEFBC026      Corrupted, no error -> continue processing
         PRERR TEXT='QMAC: 3- Registers did not corrupt'
         J     DEFBC030      -> Next test case
DEFBC026 DS    0H
         PRMSG TEXT='QMAC: 3- Call CORUC, r10-r13 corrupted'
*
* testcase1- Call DEFBC EREGSAVE=YES
* Now r10-r13 should be saved between the two DEFBC macro calls.
DEFBC030 DS    0H
         DEFBC EREGSAVE=YES
*
         PRMSG TEXT='QMAC: Call DEFBC EREGSAVE=YES'
         STMG  R0,R15,0(R1)  Save contents of registers
         CORHC CTOKEN,SIZE=64BIT
         STMG  R0,R15,0(R2)  Save contents of registers
         CLC   0(LEN64REG*14,R1),0(R2)  r0-r13 corrupted across macro?
         JE    DEFBC036      No error, -> continue processing
         PRERR TEXT='QMAC: 4- Registers corrupted *** Case Failed ***'
         J     DEFBC040      -> Next test case
DEFBC036 DS    0H
         PRMSG TEXT='QMAC: 4- Call CORHC, r10-r13 saved successfully'
*
DEFBC040 DS    0H
         STMG  R0,R15,0(R1)  Save contents of registers
         CORUC CTOKEN,SIZE=64BIT
         STMG  R0,R15,0(R2)  Save contents of registers
         CLC   0(LEN64REG*14,R1),0(R2)  r0-r13 corrupted across macro?
         JE    DEFBC046      No error, -> continue processing
         PRERR TEXT='QMAC: 5- Registers corrupted *** Case Failed ***'
         J     DEFBC050      -> Next test case
DEFBC046 DS    0H
         PRMSG TEXT='QMAC: 5- Call CORUC, r10-r13 saved successfully'
DEFBC050 DS    0H
* Test ENTRC macro
         PRMSG TEXT='QMAC: Call ENTRC QMAX'
         STMG  R10,R15,0(R1)  Save contents of registers
         MVC   EBX020,DEFBCID Set up the case id
         ENTRC QMAX,SAVEREGS=YES   Test EREGSAVE option in BSO
         STMG  R10,R15,0(R2)  Save contents of registers after return
         CLC   0(LEN64REG*4,R1),0(R2)  r10-r13 corrupted across macro?
         JE    DEFBC056      No error -> continue processing
         PRERR TEXT='QMAC: 6- Registers corrupted  *ENTRC Case Failed*'
         J     DEFBC060
DEFBC056 DS    0H
         PRMSG TEXT='QMAC: 6- Call ENTRC, r10-r13 saved successfully'
DEFBC060 DS    0H
*
* Call DEFBC EREGSAVE=NO, r10-r13 should be corrupted
         PRMSG TEXT='QMAC: Call DEFBC EREGSAVE=NO'
         DEFBC EREGSAVE=NO
         STMG  R10,R15,0(R1)  Save contents of registers
         MVC   EBX020,DEFBCID Set up the case id
         LA    R6,LSWB        check available swb's in system
         NUMBC TYPE=R6
         STMG  R10,R15,0(R2)  Save contents of registers after return
         CLC   0(LEN64REG*4,R1),0(R2)  r10-r13 corrupted across macro?
         JNE   DEFBC066      No error -> continue processing
         PRERR TEXT='QMAC: 7- Registers did not corrupt by NUMBC error'
         J     RETDEFBC
DEFBC066 DS    0H
         PRMSG TEXT='QMAC: 7- Call NUMBC, r10-r13 corrupted'
         J     RETDEFBC
DEFBCERR DS    0F
         PRMSG TEXT='QMAC: Error case for Assembler not provided'
RETDEFBC DS    0H
         EPLGC RC=NONE
         LTORG
         EJECT
         FINIS ,
         END   ,
