/*********************************************************************/
/*      Licensed Materials - Property of IBM                         */
/*      "Restricted Materials of IBM"                                */
/*      5748-T15                                                     */
/*      (C) Copyright IBM Corp. 2005                                 */
/*      All Rights Reserved                                          */
/*      US Government Users Restricted Rights - Use, duplication     */
/*      or dislosure restricted by GSA ADP Schedule Contract         */
/*      with IBM Corp.                                               */
/*********************************************************************/
/* This file is provided on an "as is" basis.  There are no          */
/* warranties, express or implied, including the implied warranties  */
/* of merchantability and fitness for a particular purpose.          */
/* IBM has no obligation to provide service, defect correction, or   */
/* any maintenance for the file.  IBM has no obligation to supply    */
/* any updates or enhancements for the file to you even if such are  */
/* or later become available.                                        */
/*********************************************************************/
/* Change History                                                    */
/* 20041001  Initial Version                                         */
/*                                                                   */
/*                                                                   */
/*                                                                   */
/*********************************************************************/
/* GENERAL INFORMATION:                                              */
/*                                                                   */
/* Header Name:   qmac23.h                                           */
/*                                                                   */
/* Description:   Header file used by API-movcr segments.            */
/*                It contains prototypes and various #defines.       */
/*                                                                   */
/*********************************************************************/
#ifndef __qmac23_h__
#define __qmac23_h__

#define MSG_SIZE                     120
#define MALLOC_SIZE                  800
#define TEXT_SIZE                    40
#define FRAME_SIZE                   4096
#define SIZE_PASSED                  70000

#define PARENT_STR_LENGTH            17
#define TPF_MOVEC_EVM_RETURN_CASE_NO 10

#define INVALID_EVM  0x8FFFFFFF
#define INVALID_SVM  0x8FFFFFFF

struct parms_passed {
   char              is_errorCase;
   char              printmsg;
   void*             parent_addr_eheap;
   void*             parent_addr_stack;
   void*             parent_addr_private;
   void*             parent_addr2;
   void*             parent_addr3;
   void*             ECB_SVA_addr;
   char              text[TEXT_SIZE];
} *parameters;

#endif /* ndef __qmac23_h__ */
