         PRINT NOGEN
         BEGIN NAME=QMAC30,IBM=YES,TPFISOC=YES
***********************************************************************
*          Licensed Materials - Property of IBM                       *
*          "Restricted Materials of IBM"                              *
*          5748-T15                                                   *
*          (C) Copyright IBM Corp. 2005                               *
*          All Rights Reserved                                        *
*          US Government Users Restricted Rights - Use, duplication   *
*          or disclosure restricted by GSA ADP Schedule Contract      *
*          with IBM Corp.                                             *
***********************************************************************
*  This file is provided on an "as is" basis.  There are no           *
*  warranties, express or implied, including the implied warranties   *
*  of merchantability and fitness for a particular purpose.           *
*  IBM has no obligation to provide service, defect correction, or    *
*  any maintenance for the file.  IBM has no obligation to supply     *
*  any updates or enhancements for the file to you even if such are   *
*  or later become available.                                         *
***********************************************************************
*  Change History                                                     *
*  20041001  Initial Version                                          *
*                                                                     *
*                                                                     *
*                                                                     *
***********************************************************************
*                                                                     *
*  Segment Name:  qmac30.asm                                          *
*                                                                     *
*  Related Segments:                                                  *
*                                                                     *
*  Abstract:  member of macro driver                                  *
*                                                                     *
*                                                                     *
*  Description: This segment is part of the macro driver.             *
*               It tests the SONIC macro                              *
*                                                                     *
*                                                                     *
***********************************************************************
*                                                                     *
*  INTERFACE REQUIREMENTS:                                            *
*                                                                     *
*  Dependencies:  None                                                *
*                                                                     *
*  Restrictions:  None                                                *
*                                                                     *
* ------------------------------------------------------------------- *
*                                                                     *
*  Input:                                                             *
*                                                                     *
*  Output:                                                            *
*                                                                     *
*                                                                     *
*  ECB WORKAREA USAGE                                                 *
*                                                                     *
*  EBW008-EBW011    --  Returns from SONIC macro                      *
*                                                                     *
*                                                                     *
*                                                                     *
*---------------------------------------------------------------------*
*                                                                     *
*   INTERNAL:                                                         *
*                                                                     *
*   Register conventions:                                             *
*                                                                     *
*   R2 -- Base Register as specified by PRLGC                         *
*                                                                     *
*                                                                     *
*---------------------------------------------------------------------*
*---------------------------------------------------------------------*
              PRLGC ENAME=sonic_macro,BASE=R8,STACK=R13
              PRMSG TEXT='STARTING THE SONIC MACRO TEST'
              CLI   EBX000,X'00'              error cases requested ?
              BNZ    SONIC2                   branch if yes
*---------------------------------------------------------------------*
***                VALID  CASES                                     ***
*---------------------------------------------------------------------*
*
SONIC1        DS    0H
              PRMSG TEXT='SONIC:  PROCESSING VALID CASES'
***********************************************************************
*                                                                     *
*        A SONIC macro is issued to obtain the record                 *
*        attributes.  The SONIC attributes are then checked           *
*        against the appropriate file address indicators (based       *
*        on address format) to make sure the address indicators       *
*        provided by the user are an accurate reflection of the       *
*        actual record.                                               *
***********************************************************************
*
*---------------------------------------------------------------------*
***                  VALID CASES  -- #1 & #2                        ***
*---------------------------------------------------------------------*
* CASE#1 -- Testing the SONIC macro with the HOTREC record type       *
*            D1 contains the file address passed to SONIC             *
* Attributes Returned in R15 -- 10004007                              *
* ATTRIBUTE TRANSLATION: Subsystem shared (not unique),               *
*                        Fixed record type,Duplicated, Large record   *
*---------------------------------------------------------------------*
CASE1          DS      0H
               PRMSG   TEXT='SONIC: CASE#1-SSU SHARED, FIXED, DUPE, LG'
               SPACE   1
               CRUSA   S0=1                        clear data level 1
               LA      R0,1                        ordinal number
               LA      R6,=CL8'#HOTREC'            record  type
               LA      R7,CE1FA1             get file address -- D1
               ENTRC   FACS                   compute file address
               LTR     R0,R0
               BZ      QSON_ERR1         error from FACE -- unexpected
               SONIC   D1,MCHR=N                get record attributes
               BNZ     QSON_ERR2       file unsuccessfully decoded --
*                                      unexpected result
               SPACE   1
               LR      R7,R15                      SONIC output
               ST      R7,EBW008               save output in workarea
               SPACE   1
               N       R7,MASKUNQ           isolate unique bits
               C       R7,IS_UNQ            is this record unique
               BE      QSON_UNQ             yes --  unexpected result
               SPACE   1
QSON_CHKTYPE   DS      0H
               L       R7,EBW008                get SONIC output
               N       R7,MASKTID             isolate type ID bits
               C       R7,IS_TYPE             is this a pool address?
               BE      QSON_POOL             yes --unexpected result
               SPACE   1
QSON_CHKDUPE   DS      0H
               L       R7,EBW008               get SONIC output
               N       R7,MASKDUPE            isolate DUPE bits
               C       R7,IS_DUPE          is this record duplicated?
               BNE     QSON_NODUPE         no - unexpected result
               B       QSON_CHKSIZE
               SPACE   1
QSON_POOL      DS      0H
               PRERR   TEXT='SONIC: UNEXPECTED RESULT -- POOL RECORD'
               B       QSON_CHKDUPE          continue
               SPACE   1
QSON_CHKSIZE   DS      0H
               L       R7,EBW008               get SONIC output
               N       R7,MASKLRG            isolate DUPE bits
               C       R7,IS_LARGE
               BNE     QSON_CHKSMALL         yes - continue
               B       QSON_END2
               SPACE   1
QSON_CHKSMALL  DS      0H
               PRERR   TEXT='SONIC:  UNEXPECTED RESULT - SMALL RECORD'
               B       QSON_END2              issue error message
               SPACE   1
QSON_ERR1      EQU     *                   unexpected result
               PRERR   TEXT='SONIC: INVALID FILE ADDRESS'
               B       QSON_END1
               SPACE   1
QSON_ERR2      EQU     *
               PRMSG   TEXT='SONIC: FILE UNSUCCESSFULLY DECODED'
               B       QSON_END1
               SPACE   1
QSON_NODUPE    EQU     *
               PRERR   TEXT='SONIC: UNEXPECTED RESULT-RECORD NOT DUPE'
               B       QSON_CHKSIZE
               SPACE   1
QSON_UNQ       EQU     *
               PRERR   TEXT='SONIC: UNEXPECTED RESULT - RECORD UNIQUE'
               B       QSON_CHKTYPE
               SPACE   1
QSON_END1      DS      0H
               PRERR   TEXT='SONIC: UNEXPECTED RESULT-CASE#1 COMPLETED'
               B       CASE2
QSON_END2      EQU     *
               PRMSG   TEXT='SONIC: EXPECTED RESULT- CASE#1 SUCCESSFUL'
               B       CASE2
               EJECT   ,
*---------------------------------------------------------------------*
* CASE#2 -- Testing the SONIC macro with the 'OM' record type         *
*           R6 contains the location of 8-byte file address passed    *
*           to SONIC                                                  *
* Attributes Returned in R15 -- D000000B                              *
* ATTRIBUTE TRANSLATION:   Short term pool record type,               *
*                          not Duplicated, Large record               *
*---------------------------------------------------------------------*
CASE2          DS      0H
               PRMSG   TEXT='SONIC: CASE#2- SHORT TERM POOL, NO DUPE'
               SPACE   1
               CRUSA   S0=7,S1=2                    clear data level 7
               GETFC   D7,ID=X'D6D4'          get storage block on D7
               LA      R6,CE1FA8
               FA4X4C  ACTION=4TO8,FA4=CE1FA7+4,FA8=CE1FA8
               SONIC   ADDR=(R6)
               BNZ     QSON_ERR4
               SPACE   1
               LR      R7,R15                     SONIC output
               ST      R7,EBW008              save output in workarea
               SPACE   1
QSON_CHKTYPE2  DS      0H
               L       R7,EBW008               get SONIC output
               N       R7,MASKTID           isolate type ID bits
               C       R7,IS_TYPE           is this a pool address?
               BE      QSON_POOL2          yes -- evaluate
               BAS     R3,QSON_FIX         no -- unexpected result
               SPACE   1
QSON_CHKDUPE2  DS      0H
               L       R7,EBW008                   get SONIC attributes
               N       R7,MASKDUPE                isolate DUPE bits
               C       R7,IS_DUPE            is this record duplicated?
               BE      QSON_DUPE               no - unexpected result
               B       QSON_CHKSIZE2
               SPACE   1
QSON_FIX       DS      0H
               PRERR   TEXT='SONIC: UNEXPECTED RESULT - FIXED RECORD'
               BR      R3
               SPACE   1
QSON_POOL2     DS      0H
               L       R7,EBW008              get SONIC output
               N       R7,MASKPOOL           isolate pool bits
               C       R7,IS_SHRTTERM      is this short term pool
               BNE     QSON_CHKTERM        no -- unexpected result
               B       QSON_CHKDUPE2
               SPACE   1
QSON_CHKTERM   DS      0H
               L       R7,EBW008              get SONIC output
               N       R7,MASKPOOL            isolate pool bits
               C       R7,IS_SHRTTERM      is this short term pool ?
               BE      QSON_ERR3           yes -- an error has occured
               SPACE   1
QSON_CHKSIZE2  DS      0H
               L       R7,EBW008               get SONIC output
               N       R7,MASKLRG            isolate DUPE bits
               C       R7,IS_LARGE
               BNE     QSON_CHKSMALL2         yes - continue
               B       QSON_END4
               SPACE   1
QSON_CHKSMALL2 DS      0H
               PRERR   TEXT='SONIC:  UNEXPECTED RESULT - SMALL RECORD'
               B       QSON_END4                   unexpected result
               SPACE   1
QSON_DUPE      EQU     *
               PRERR   TEXT='SONIC: UNEXPECTED RESULT - DUPE RECORD'
               B       QSON_CHKSIZE2
               SPACE   1
QSON_ERR3      EQU     *
               PRERR   TEXT='SONIC: UNEXPECTED RESULT-PROCESSING ERROR'
               B       QSON_END3                   unexpected result
               SPACE   1
QSON_ERR4      EQU     *
               PRMSG  TEXT='SONIC: FILE UNSUCCESSFULLY DECODED'
               B       QSON_END3
               SPACE   1

QSON_END3      DS      0H
               PRERR   TEXT='SONIC: UNEXPECTED RESULT- CASE#2 COMPLETE'
               B       RETSONIC
QSON_END4      EQU     *
               PRMSG   TEXT='SONIC: EXPECTED RESULT- CASE#2 SUCCESSFUL'
               B       RETSONIC
*---------------------------------------------------------------------*
*---------------------------------------------------------------------*
***                     ERROR CASES -- #3 & #4                      ***
*---------------------------------------------------------------------*
SONIC2         DS      0H
               PRMSG   TEXT='SONIC:  PROCESSING ERROR CASES'

*---------------------------------------------------------------------*
*---------------------------------------------------------------------*
* CASE#3 -- Testing the SONIC macro with the XZ1AT record type        *
*           Passing SONIC a 4-byte file address in R6                 *
* Attributes Returned in R15 -- 10000006                              *
* ATTRIBUTE TRANSLATION: Subsystem shared (not unique),               *
*                        Fixed record type, Duplicated                *
*                        Small record                                 *
*---------------------------------------------------------------------*
CASE3          DS      0H
               PRMSG   TEXT='SONIC: CASE#3 ERROR CASE'
               CRUSA   S0=1
               LA      R0,1                             ordinal number
               LA      R6,=CL8'#XZ1AT'                get record  type
               LA      R7,CE1FA1                get file address -- D1
               ENTRC   FACS                       compute file address
               LTR     R0,R0
               BZ      QSON_ERR7                    error from FACE
               SONIC   ADDR=(R7)                get record attributes
               BNZ     QSON_END5           file unsuccessfully decoded
               B       QSON_ERR8                    unexpected results
               SPACE   1
QSON_ERR7      EQU     *
               PRERR   TEXT='SONIC: INVALID FILE ADDRESS'
               B       CASE4
               SPACE   1
QSON_END5      EQU     *
               PRMSG   TEXT='SONIC: CASE#3 SUCCESSFUL'
               B       CASE4
               SPACE   1
QSON_ERR8      EQU     *                             unexpected result
               PRERR   TEXT='SONIC: UNEXPECTED RESULT-CASE#3 COMPLETED'
               B       CASE4
               EJECT  1
*---------------------------------------------------------------------*
*CASE#4 -- Testing the SONIC macro with an invalid file address       *
*          passed in a register.                                      *
*                                                                     *
*---------------------------------------------------------------------*
CASE4          DS     0H
               PRMSG  TEXT='SONIC: CASE#4 ERROR CASE'
               LA     R1,=X'00000001'
               SONIC  ADDR=(R1)
               BNZ   QSON_END6
               B     QSON_ERR9
QSON_END6      EQU   *
               PRMSG TEXT='SONIC: EXPECTED RESULT - CASE#4 SUCCESSFUL'
               B     RETSONIC
QSON_ERR9      EQU   *
               PRERR TEXT='SONIC: UNEXPECTED RESULT - CASE#4 COMPLETED'
               B     RETSONIC
*---------------------------------------------------------------------*
*        Constants and Equates                                        *
*---------------------------------------------------------------------*
*           Bit masks for SONIC attributes
            SPACE  1
            DS     0H
MASKTID     DC     A(SONIC_TYPE_INDICATOR) mask for type indicator bits
MASKPOOL    DC     A(SONIC_POOL_LONGEVITY) mask for pool longevity
*                                                        indicator bits
MASKUNQ     DC     A(SONIC_RECORD_UNIQUE)     mask for record ownership
*                                                        indicator bits
MASKDUPE    DC     A(SONIC_DUPLICATED)        mask for duplication bits
MASKLRG     DC     A(SONIC_REC_SIZE)                 mask for size bits
            SPACE  1
*---------------------------------------------------------------------*
*         Bit patterns for SONIC attributes                           *
*---------------------------------------------------------------------*
            SPACE  1
IS_TYPE     DC     X'80000000'                             POOL address
IS_SHRTTERM DC     X'40000000'                  SHORT TERM POOL address
IS_UNQ      DC     X'00008000'                    UNIQUE record address
IS_DUPE     DC     X'00000004'                DUPLICATED record address
IS_LARGE    DC     X'00000001'                     LARGE record address
*---------------------------------------------------------------------*
*                   Error Case Constants                              *
*---------------------------------------------------------------------*
            SPACE  1
RETSONIC    EQU    *
            CRUSA   S0=1,S1=2
            PRMSG   TEXT='COMPLETING THE SONIC MACRO TEST'
            EPLGC   RC=NONE
*
            LTORG
            FINIS   QMAC30
            END
