         PRINT NOGEN
         BEGIN NAME=QMAC41,IBM=YES,TPFISOC=YES
***********************************************************************
*          Licensed Materials - Property of IBM                       *
*          "Restricted Materials of IBM"                              *
*          5748-T15                                                   *
*          (C) Copyright IBM Corp. 2005                               *
*          All Rights Reserved                                        *
*          US Government Users Restricted Rights - Use, duplication   *
*          or disclosure restricted by GSA ADP Schedule Contract      *
*          with IBM Corp.                                             *
***********************************************************************
*  This file is provided on an "as is" basis.  There are no           *
*  warranties, express or implied, including the implied warranties   *
*  of merchantability and fitness for a particular purpose.           *
*  IBM has no obligation to provide service, defect correction, or    *
*  any maintenance for the file.  IBM has no obligation to supply     *
*  any updates or enhancements for the file to you even if such are   *
*  or later become available.                                         *
***********************************************************************
*  Change History                                                     *
*  20041001  Initial Version                                          *
*                                                                     *
*                                                                     *
*                                                                     *
***********************************************************************
*                                                                     *
*  Segment Name:  qmac30.asm                                          *
*                                                                     *
*  Related Segments:                                                  *
*                                                                     *
*  Abstract:  member of macro driver                                  *
*                                                                     *
*                                                                     *
*  Description: This segment is part of the macro driver.             *
*               It tests the PROGC macro                              *
*                                                                     *
*                                                                     *
***********************************************************************
*                                                                     *
*  INTERFACE REQUIREMENTS:                                            *
*                                                                     *
*  Dependencies:  None                                                *
*                                                                     *
*  Restrictions:  None                                                *
*                                                                     *
* ------------------------------------------------------------------- *
*                                                                     *
*  Input:                                                             *
*                                                                     *
*  Output:                                                            *
*                                                                     *
*                                                                     *
*  ECB WORKAREA USAGE                                                 *
*                                                                     *
*                                                                     *
*                                                                     *
*                                                                     *
*---------------------------------------------------------------------*
*                                                                     *
*   INTERNAL:                                                         *
*                                                                     *
*   Register conventions:                                             *
*                                                                     *
*   R7 -- Base Register as specified by PRLGC                        *
*                                                                     *
*                                                                     *
*---------------------------------------------------------------------*
*---------------------------------------------------------------------*
         IDSPAT REG=R0
         MACRO
         INPUT_PARMS
INPUT_PARMS DSECT
ICASE        DS  XL4
SNAP         DS  XL2
BSO_NAME     DS  XL4
LSET_NAME    DS  CL8
BSO          DS  XL1
CSO          DS  XL1
&SYSECT    CSECT
         MEND
         INPUT_PARMS
         SPACE
         PRLGC ENAME=progc_macro,BASE=R7                                C64CK
              PRMSG TEXT='STARTING THE PROGC MACRO TEST'
              USING INPUT_PARMS,R3
              LG    R3,EBX008
              CLI   EBX000,X'00'              error cases requested ?
              JNZ    PROGC2                   branch if yes             64MODE
*---------------------------------------------------------------------*
***                VALID  CASES                                     ***
*---------------------------------------------------------------------*
*
PROGC1        DS    0H
              PRMSG TEXT='PROGC:  PROCESSING VALID CASES'
***********************************************************************
*                                                                     *
*        A PROGC macro is issued to ......                            *
***********************************************************************
*
*---------------------------------------------------------------------*
***                  VALID CASES  -- #1-#4                        ***
*---------------------------------------------------------------------*
* CASE#1 -- Testing the PROGC macro                                   *
*                                                                     *
* Attributes Returned:                                                *
* ATTRIBUTE TRANSLATION:                                              *
*                                                                     *
*---------------------------------------------------------------------*
CASE1          DS      0H
               CLC     ICASE,=F'0'
               JE      CASE1_DO
               CLC     ICASE,=F'1'
               JNE     CASE2
CASE1_DO       DS      0H
               PRMSG   TEXT='PROGC: CASE#1-Default parms, NAME=....',  +D11980
               CHARA=BSO_NAME
               XGR     R5,R5
               ICM     R5,B'1111',BSO_NAME
               PROGC   NAME=(R5),PAT=R6,ERROR=PROGCE1
               PRMSG   TEXT='PROGC: EXPECTED RESULT- CASE#1 SUCCESSFUL'
               LLGH    R1,SNAP
               LTGR    R1,R1
               JZ      SKIPSNAP1
               STG     R6,EBW000
               SNAPC   R,000001,PREFIX=I,MSG=MSG1,LIST=LIST1
SKIPSNAP1      DS      0H
               J       CASE2
PROGCE1        DS      0H
               PRMSG   TEXT='PROGC: UNEXPECTED RESULT- CASE#1 FAILED'
               J       CASE2
               EJECT   ,
*---------------------------------------------------------------------*
* CASE#2 -- Testing the PROGC                                         *
*                                                                     *
*                                                                     *
* Attributes Returned:                                                *
* ATTRIBUTE TRANSLATION:                                              *
*                                                                     *
*---------------------------------------------------------------------*
CASE2          DS      0H
               CLC     ICASE,=F'0'
               JE      CASE2_DO
               CLC     ICASE,=F'2'
               JNE     CASE3
CASE2_DO       DS      0H
               PRMSG   TEXT='PROGC: CASE#2-NAME=....,DBI',             +D11980
               CHARA=BSO_NAME
               XGR     R5,R5
               ICM     R5,B'1111',BSO_NAME
               PROGC   NAME=(R5),PAT=R6,ERROR=PROGCE2,IDLOC=DBI
               PRMSG   TEXT='PROGC: EXPECTED RESULT- CASE#2 SUCCESSFUL'
               LLGH    R1,SNAP
               LTGR    R1,R1
               JZ      SKIPSNAP2
               STG     R6,EBW000
               SNAPC   R,000002,PREFIX=I,MSG=MSG1,LIST=LIST1
SKIPSNAP2      DS      0H
               J       CASE3
PROGCE2        DS      0H
               PRMSG   TEXT='PROGC: UNEXPECTED RESULT- CASE#2 FAILED'
               J       CASE3
***                  VALID CASES  -- #1 & #2                        ***
*---------------------------------------------------------------------*
* CASE#3 -- Testing the PROGC macro                                   *
*                                                                     *
* Attributes Returned:                                                *
* ATTRIBUTE TRANSLATION:                                              *
*                                                                     *
*---------------------------------------------------------------------*
CASE3          DS      0H
               CLC     ICASE,=F'0'
               JE      CASE3_DO
               CLC     ICASE,=F'3'
               JNE     CASE4
CASE3_DO       DS      0H
               PRMSG   TEXT='PROGC: CASE#3-NAME=....,PBI',             +D11980
               CHARA=BSO_NAME
               XGR     R5,R5
               ICM     R5,B'1111',BSO_NAME
               PROGC   NAME=(R5),PAT=R6,ERROR=PROGCE3,IDLOC=PBI
               PRMSG   TEXT='PROGC: EXPECTED RESULT- CASE#3 SUCCESSFUL'
               LLGH    R1,SNAP
               LTGR    R1,R1
               JZ      SKIPSNAP3
               STG     R6,EBW000
               SNAPC   R,000003,PREFIX=I,MSG=MSG1,LIST=LIST1
SKIPSNAP3      DS      0H
               J       CASE4
PROGCE3        DS      0H
               PRMSG   TEXT='PROGC: UNEXPECTED RESULT- CASE#3 FAILED'
               J       CASE4
               EJECT   ,
*---------------------------------------------------------------------*
* CASE#4 -- Testing the PROGC macro                                   *
*                                                                     *
* Attributes Returned:                                                *
* ATTRIBUTE TRANSLATION:                                              *
*                                                                     *
*---------------------------------------------------------------------*
CASE4          DS      0H
               CLC     ICASE,=F'0'
               JE      CASE4_DO
               CLC     ICASE,=F'4'
               JNE     CASE5
CASE4_DO       DS      0H
               PRMSG   TEXT='PROGC: CASE#4-NAME=CVZZ'
               PROGC   NAME=CVZZ,PAT=R6,ERROR=PROGCE4
               PRMSG   TEXT='PROGC: EXPECTED RESULT- CASE#4 SUCCESSFUL'
               LLGH    R1,SNAP
               LTGR    R1,R1
               JZ      SKIPSNAP4
               STG     R6,EBW000
               SNAPC   R,000004,PREFIX=I,MSG=MSG1,LIST=LIST1
SKIPSNAP4      DS      0H
               J       RETPROGC
PROGCE4        DS      0H
               PRMSG   TEXT='PROGC: UNEXPECTED RESULT- CASE#4 FAILED'
               J       RETPROGC
               EJECT   ,
*---------------------------------------------------------------------*
*---------------------------------------------------------------------*
***                     ERROR CASES -- #5                           ***
*---------------------------------------------------------------------*
PROGC2         DS      0H
               PRMSG   TEXT='PROGC:  PROCESSING ERROR CASES'
*---------------------------------------------------------------------*
* CASE#5 -- Testing the PROGC macro                                   *
*                                                                     *
* Attributes Returned:                                                *
* ATTRIBUTE TRANSLATION:                                              *
*---------------------------------------------------------------------*
CASE5          DS      0H
               CLC     ICASE,=F'0'
               JE      RETPROGC
               CLC     ICASE,=F'5'
               JNE     RETPROGC
CASE5_DO       DS      0H
               PRMSG   TEXT='PROGC: CASE#5 ERROR CASE-NAME=ZZZZ'
               PROGC   NAME=ZZZZ,PAT=R6,ERROR=PROGCE5
               PRERR   TEXT='PROGC: EXPECTED RESULT-CASE#5 SUCCESSFUL'
               J       RETPROGC
PROGCE5        DS      0H
               PRMSG   TEXT='PROGC: UNEXPECTED RESULT- CASE#5 FAILED'
               LLGH    R1,SNAP
               LTGR    R1,R1
               JZ      SKIPSNAP5
               STG     R6,EBW000
               SNAPC   R,000005,PREFIX=I,MSG=MSG1,LIST=LIST1
SKIPSNAP5      DS      0H
               J       RETPROGC
               EJECT  1
*---------------------------------------------------------------------*
* RETURN                                                              *
*                                                                     *
*---------------------------------------------------------------------*
            SPACE  1
RETPROGC    EQU    *
            PRMSG   TEXT='COMPLETING THE PROGC MACRO TEST'
            EPLGC   RC=NONE
*---------------------------------------------------------------------*
* SNAP LIST                                                           *
*                                                                     *
*---------------------------------------------------------------------*
LIST1       LISTC   NAME=PAT,TAG=EBW000,LEN=(R1),INDIR=YES,INDSIZE=64
            LISTC   END
MSG1        DC      AL1(MSG1E-MSG1S)
MSG1S       DC      C'PAT DATA'
MSG1E       EQU     *
*
            LTORG
            FINIS   QMAC41
            END
