         PRINT NOGEN
         BEGIN NAME=QMAC42,IBM=YES,TPFISOC=YES
***********************************************************************
*          Licensed Materials - Property of IBM                       *
*          "Restricted Materials of IBM"                              *
*          5748-T15                                                   *
*          (C) Copyright IBM Corp. 2005                               *
*          All Rights Reserved                                        *
*          US Government Users Restricted Rights - Use, duplication   *
*          or disclosure restricted by GSA ADP Schedule Contract      *
*          with IBM Corp.                                             *
***********************************************************************
*  This file is provided on an "as is" basis.  There are no           *
*  warranties, express or implied, including the implied warranties   *
*  of merchantability and fitness for a particular purpose.           *
*  IBM has no obligation to provide service, defect correction, or    *
*  any maintenance for the file.  IBM has no obligation to supply     *
*  any updates or enhancements for the file to you even if such are   *
*  or later become available.                                         *
***********************************************************************
*  Change History                                                     *
*  20041001  Initial Version                                          *
*  20050309  Defect 11964                                             *
*            Update PRMSG messages to display program name and loadset*
*            name properly.                                           *
*                                                                     *
*                                                                     *
***********************************************************************
*                                                                     *
*  Segment Name:  qmac42.asm                                          *
*                                                                     *
*  Related Segments:                                                  *
*                                                                     *
*  Abstract:  member of macro driver                                  *
*                                                                     *
*                                                                     *
*  Description: This segment is part of the macro driver.             *
*               It tests the GETPC macro                              *
*                                                                     *
*                                                                     *
***********************************************************************
*                                                                     *
*  INTERFACE REQUIREMENTS:                                            *
*                                                                     *
*  Dependencies:  None                                                *
*                                                                     *
*  Restrictions:  None                                                *
*                                                                     *
* ------------------------------------------------------------------- *
*                                                                     *
*  Input:                                                             *
*                                                                     *
*  Output:                                                            *
*                                                                     *
*                                                                     *
*  ECB WORKAREA USAGE                                                 *
*                                                                     *
*                                                                     *
*                                                                     *
*                                                                     *
*---------------------------------------------------------------------*
*                                                                     *
*   INTERNAL:                                                         *
*                                                                     *
*   Register conventions:                                             *
*                                                                     *
*   R7 -- Base Register as specified by PRLGC                         *
*                                                                     *
*                                                                     *
*---------------------------------------------------------------------*
*---------------------------------------------------------------------*
         MACRO
         INPUT_PARMS
INPUT_PARMS DSECT
ICASE        DS  XL4
SNAP         DS  XL2
BSO_NAME     DS  XL4
LSET_NAME    DS  CL8
BSO          DS  XL1
CSO          DS  XL1
&SYSECT    CSECT
         MEND
         INPUT_PARMS
         SPACE
         PRLGC ENAME=getpc_macro,BASE=R7                                C64CK
         J     LETS_GO
*---------------------------------------------------------------------*
* SNAP LIST                                                           *
*                                                                     *
*---------------------------------------------------------------------*
LIST1     LISTC   NAME=PROGRAM,TAG=EBW000,LEN=(R1),INDIR=YES,INDSIZE=64
          LISTC   END
MSG1      DC      AL1(MSG1E-MSG1S)
MSG1S     DC      C'PROGRAM'
MSG1E     EQU     *
LIST2     LISTC   NAME=PROGRAM,TAG=EBW000,LEN=(R1),INDIR=YES,INDSIZE=64
          LISTC   NAME=LOADSET,TAG=EBW008,LEN=8
          LISTC   END
MSG2      DC      AL1(MSG2E-MSG2S)
MSG2S     DC      C'GETPC ADDR'
MSG2E     EQU     *
          EJECT
LETS_GO       DS    0H
              PRMSG TEXT='STARTING THE GETPC MACRO TEST'
              USING INPUT_PARMS,R3
              LG    R3,EBX008
              LGF   R0,ICASE
              CLI   EBX000,X'00'              error cases requested ?
              JNZ    GETPC2                   branch if yes             64MODE
              CHI   R0,15                     Case in this segment?
              JH    CASES_31BIT_DO            No, do 31-bit
*---------------------------------------------------------------------*
***                VALID  CASES                                     ***
*---------------------------------------------------------------------*
*
GETPC1        DS    0H
              PRMSG TEXT='GETPC:  PROCESSING VALID CASES'
***********************************************************************
*                                                                     *
*        A GETPC macro is issued to ......                            *
***********************************************************************
*
*---------------------------------------------------------------------*
***                  VALID CASES  --                                ***
*---------------------------------------------------------------------*
* CASE#1 -- Testing the GETPC macro                                   *
*                                                                     *
* Attributes Returned:                                                *
* ATTRIBUTE TRANSLATION:                                              *
*                                                                     *
*---------------------------------------------------------------------*
CASE1          DS      0H
               CHI     R0,0
               JE      CASE1_DO
               CHI     R0,1
               JNE     CASE2
CASE1_DO       DS      0H
               PRMSG   TEXT='GETPC: CASE#1-Default parms, NAME=....',  +D11964
               CHARA=BSO_NAME                                           D11964
               XGR     R5,R5
               ICM     R5,B'1111',BSO_NAME
               GETPC   NAME=(R5),ERROR=GETPCE1,                        +
               ADDR=R6
               PRMSG   TEXT='GETPC: EXPECTED RESULT- CASE#1 SUCCESSFUL'
               LLGH    R1,SNAP
               LTGR    R1,R1
               JZ      SKIPSNAP1
               STG     R6,EBW000
               SNAPC   R,000001,PREFIX=I,MSG=MSG1,LIST=LIST1
SKIPSNAP1      DS      0H
               J       CASE2
GETPCE1        DS      0H
               PRMSG   TEXT='GETPC: UNEXPECTED RESULT- CASE#1 FAILED'
               J       CASE2
               EJECT   ,
*---------------------------------------------------------------------*
* CASE#2 -- Testing the GETPC                                         *
*                                                                     *
*                                                                     *
* Attributes Returned:                                                *
* ATTRIBUTE TRANSLATION:                                              *
*                                                                     *
*---------------------------------------------------------------------*
CASE2          DS      0H
               CHI     R0,0
               JE      CASE2_DO
               CHI     R0,2
               JNE     CASE3
CASE2_DO       DS      0H
               PRMSG   TEXT='GETPC: CASE#2-NAME=....,DBI',             +D11964
               CHARA=BSO_NAME                                           D11964
               XGR     R5,R5
               ICM     R5,B'1111',BSO_NAME
               GETPC   NAME=(R5),ERROR=GETPCE2,                        +
               IDLOC=DBI,                                              +
               ADDR=R6
               PRMSG   TEXT='GETPC: EXPECTED RESULT- CASE#2 SUCCESSFUL'
               LLGH    R1,SNAP
               LTGR    R1,R1
               JZ      SKIPSNAP2
               STG     R6,EBW000
               SNAPC   R,000002,PREFIX=I,MSG=MSG1,LIST=LIST1
SKIPSNAP2      DS      0H
               J       CASE3
GETPCE2        DS      0H
               PRMSG   TEXT='GETPC: UNEXPECTED RESULT- CASE#2 FAILED'
               J       CASE3
***                  VALID CASES  -- #1 & #2                        ***
*---------------------------------------------------------------------*
* CASE#3 -- Testing the GETPC macro                                   *
*                                                                     *
* Attributes Returned:                                                *
* ATTRIBUTE TRANSLATION:                                              *
*                                                                     *
*---------------------------------------------------------------------*
CASE3          DS      0H
               CHI     R0,0
               JE      CASE3_DO
               CHI     R0,3
               JNE     CASE4
CASE3_DO       DS      0H
               PRMSG   TEXT='GETPC: CASE#3-NAME=....,PBI',             +D11964
               CHARA=BSO_NAME                                           D11964
               XGR     R5,R5
               ICM     R5,B'1111',BSO_NAME
               GETPC   NAME=(R5),ERROR=GETPCE3,                        +
               IDLOC=PBI,                                              +
               ADDR=R6
               PRMSG   TEXT='GETPC: EXPECTED RESULT- CASE#3 SUCCESSFUL'
               LLGH    R1,SNAP
               LTGR    R1,R1
               JZ      SKIPSNAP3
               STG     R6,EBW000
               SNAPC   R,000003,PREFIX=I,MSG=MSG1,LIST=LIST1
SKIPSNAP3      DS      0H
               J       CASE4
GETPCE3        DS      0H
               PRMSG   TEXT='GETPC: UNEXPECTED RESULT- CASE#3 FAILED'
               J       CASE4
               EJECT   ,
*---------------------------------------------------------------------*
* CASE#4 -- Testing the GETPC macro                                   *
*                                                                     *
* Attributes Returned:                                                *
* ATTRIBUTE TRANSLATION:                                              *
*                                                                     *
*---------------------------------------------------------------------*
CASE4          DS      0H
               CHI     R0,0
               JE      CASE4_DO
               CHI     R0,4
               JNE     CASE5
CASE4_DO       DS      0H
               PRMSG   TEXT='GETPC: CASE#4-NAME=CVZZ'
               GETPC   NAME=CVZZ,ERROR=GETPCE4,                        +
               ADDR=R6
               PRMSG   TEXT='GETPC: EXPECTED RESULT- CASE#4 SUCCESSFUL'
               LLGH    R1,SNAP
               LTGR    R1,R1
               JZ      SKIPSNAP4
               STG     R6,EBW000
               SNAPC   R,000004,PREFIX=I,MSG=MSG1,LIST=LIST1
SKIPSNAP4      DS      0H
               J       CASE5
GETPCE4        DS      0H
               PRMSG   TEXT='GETPC: UNEXPECTED RESULT- CASE#4 FAILED'
               J       CASE5
               EJECT   ,
*---------------------------------------------------------------------*
* CASE#5 -- Testing the GETPC macro                                   *
*                                                                     *
* Attributes Returned:                                                *
* ATTRIBUTE TRANSLATION:                                              *
*                                                                     *
*---------------------------------------------------------------------*
CASE5          DS      0H
               CHI     R0,0
               JE      CASE5_DO
               CHI     R0,5
               JNE     CASE6
CASE5_DO       DS      0H
               PRMSG   TEXT='GETPC: CASE#5-FETCHONLY=NO, NAME=....',   +D11964
               CHARA=BSO_NAME                                           D11964
               XGR     R5,R5
               ICM     R5,B'1111',BSO_NAME
               SPACE
               GETPC   NAME=(R5),ERROR=GETPCE5,                        +
               FETCHONLY=NO,                                           +
               ADDR=R6
               SPACE
               PRMSG   TEXT='GETPC: EXPECTED RESULT- CASE#5 SUCCESSFUL'
               LLGH    R1,SNAP
               LTGR    R1,R1
               JZ      SKIPSNAP5
               STG     R6,EBW000
               SNAPC   R,000005,PREFIX=I,MSG=MSG1,LIST=LIST1
SKIPSNAP5      DS      0H
               J       CASE6
GETPCE5        DS      0H
               PRMSG   TEXT='GETPC: UNEXPECTED RESULT- CASE#5 FAILED'
               J       CASE6
               EJECT   ,
*---------------------------------------------------------------------*
* CASE#6 -- Testing the GETPC                                         *
*                                                                     *
*                                                                     *
* Attributes Returned:                                                *
* ATTRIBUTE TRANSLATION:                                              *
*                                                                     *
*---------------------------------------------------------------------*
CASE6          DS      0H
               CHI     R0,0
               JE      CASE6_DO
               CHI     R0,6
               JNE     CASE7
CASE6_DO       DS      0H
               PRMSG   TEXT='GETPC: CASE#6-FETCHONLY=NO,NAME=....,DBI',+D11964
               CHARA=BSO_NAME                                           D11964
               XGR     R5,R5
               ICM     R5,B'1111',BSO_NAME
               SPACE
               GETPC   NAME=(R5),ERROR=GETPCE6,                        +
               FETCHONLY=NO,IDLOC=DBI,                                 +
               ADDR=R6
               SPACE
               PRMSG   TEXT='GETPC: EXPECTED RESULT- CASE#6 SUCCESSFUL'
               LLGH    R1,SNAP
               LTGR    R1,R1
               JZ      SKIPSNAP6
               STG     R6,EBW000
               SNAPC   R,000006,PREFIX=I,MSG=MSG1,LIST=LIST1
SKIPSNAP6      DS      0H
               J       CASE7
GETPCE6        DS      0H
               PRMSG   TEXT='GETPC: UNEXPECTED RESULT- CASE#6 FAILED'
               J       CASE7
*---------------------------------------------------------------------*
* CASE#7 -- Testing the GETPC macro                                   *
*                                                                     *
* Attributes Returned:                                                *
* ATTRIBUTE TRANSLATION:                                              *
*                                                                     *
*---------------------------------------------------------------------*
CASE7          DS      0H
               CHI     R0,0
               JE      CASE7_DO
               CHI     R0,7
               JNE     CASE8
CASE7_DO       DS      0H
               PRMSG   TEXT='GETPC: CASE#7-NAME=....,FETCHONLY=NO,PBI',+D11964
               CHARA=BSO_NAME                                           D11964
               XGR     R5,R5
               ICM     R5,B'1111',BSO_NAME
               SPACE
               GETPC   NAME=(R5),ERROR=GETPCE7,                        +
               FETCHONLY=NO,IDLOC=PBI,                                 +
               ADDR=R6
               SPACE
               PRMSG   TEXT='GETPC: EXPECTED RESULT- CASE#7 SUCCESSFUL'
               LLGH    R1,SNAP
               LTGR    R1,R1
               JZ      SKIPSNAP7
               STG     R6,EBW000
               SNAPC   R,000007,PREFIX=I,MSG=MSG1,LIST=LIST1
SKIPSNAP7      DS      0H
               J       CASE8
GETPCE7        DS      0H
               PRMSG   TEXT='GETPC: UNEXPECTED RESULT- CASE#7 FAILED'
               J       CASE8
               EJECT   ,
*---------------------------------------------------------------------*
* CASE#8 -- Testing the GETPC macro                                   *
*                                                                     *
* Attributes Returned:                                                *
* ATTRIBUTE TRANSLATION:                                              *
*                                                                     *
*---------------------------------------------------------------------*
CASE8          DS      0H
               CHI     R0,0
               JE      CASE8_DO
               CHI     R0,8
               JNE     CASE9
CASE8_DO       DS      0H
               PRMSG   TEXT='GETPC: CASE#8-FETCHONLY=YES, NAME=....',  +D11964
               CHARA=BSO_NAME                                           D11964
               XGR     R5,R5
               ICM     R5,B'1111',BSO_NAME
               SPACE
               GETPC   NAME=(R5),ERROR=GETPCE8,                        +
               FETCHONLY=YES,                                          +
               ADDR=R6
               SPACE
               PRMSG   TEXT='GETPC: EXPECTED RESULT- CASE#8 SUCCESSFUL'
               LLGH    R1,SNAP
               LTGR    R1,R1
               JZ      SKIPSNAP8
               STG     R6,EBW000
               SNAPC   R,000008,PREFIX=I,MSG=MSG1,LIST=LIST1
SKIPSNAP8      DS      0H
               J       CASE9
GETPCE8        DS      0H
               PRMSG   TEXT='GETPC: UNEXPECTED RESULT- CASE#8 FAILED'
               J       CASE9
               EJECT   ,
*---------------------------------------------------------------------*
* CASE#9 -- Testing the GETPC                                         *
*                                                                     *
*                                                                     *
* Attributes Returned:                                                *
* ATTRIBUTE TRANSLATION:                                              *
*                                                                     *
*---------------------------------------------------------------------*
CASE9          DS      0H
               CHI     R0,0
               JE      CASE9_DO
               CHI     R0,9
               JNE     CASE10
CASE9_DO       DS      0H
               PRMSG  TEXT='GETPC: CASE#9-FETCHONLY=YES,NAME=....,DBI',+D11964
               CHARA=BSO_NAME                                           D11964
               XGR     R5,R5
               ICM     R5,B'1111',BSO_NAME
               SPACE
               GETPC   NAME=(R5),ERROR=GETPCE9,                        +
               FETCHONLY=YES,IDLOC=DBI,                                +
               ADDR=R6
               SPACE
               PRMSG   TEXT='GETPC: EXPECTED RESULT- CASE#9 SUCCESSFUL'
               LLGH    R1,SNAP
               LTGR    R1,R1
               JZ      SKIPSNAP9
               STG     R6,EBW000
               SNAPC   R,000009,PREFIX=I,MSG=MSG1,LIST=LIST1
SKIPSNAP9      DS      0H
               J       CASE10
GETPCE9        DS      0H
               PRMSG   TEXT='GETPC: UNEXPECTED RESULT- CASE#9 FAILED'
               J       CASE10
*---------------------------------------------------------------------*
* CASE#10 -- Testing the GETPC macro                                  *
*                                                                     *
* Attributes Returned:                                                *
* ATTRIBUTE TRANSLATION:                                              *
*                                                                     *
*---------------------------------------------------------------------*
CASE10         DS      0H
               CHI     R0,0
               JE      CASE10_DO
               CHI     R0,10
               JNE     CASE11
CASE10_DO      DS      0H
               PRMSG TEXT='GETPC: CASE#10-NAME=....,FETCHONLY=YES,PBI',+D11964
               CHARA=BSO_NAME                                           D11964
               XGR     R5,R5
               ICM     R5,B'1111',BSO_NAME
               SPACE
               GETPC   NAME=(R5),ERROR=GETPCE10,                       +
               FETCHONLY=YES,IDLOC=PBI,                                +
               ADDR=R6
               SPACE
               PRMSG  TEXT='GETPC: EXPECTED RESULT- CASE#10 SUCCESSFUL'
               LLGH    R1,SNAP
               LTGR    R1,R1
               JZ      SKIPSNAP10
               STG     R6,EBW000
               SNAPC   R,000010,PREFIX=I,MSG=MSG1,LIST=LIST1
SKIPSNAP10     DS      0H
               J       CASE11
GETPCE10       DS      0H
               PRMSG   TEXT='GETPC: UNEXPECTED RESULT- CASE#10 FAILED'
               J       CASE11
               EJECT   ,
*---------------------------------------------------------------------*
* CASE#11 -- Testing the GETPC macro                                  *
*                                                                     *
* Attributes Returned:                                                *
* ATTRIBUTE TRANSLATION:                                              *
*                                                                     *
*---------------------------------------------------------------------*
CASE11         DS      0H
               CHI     R0,0
               JE      CASE11_DO
               CHI     R0,11
               JNE     CASE12
CASE11_DO      DS      0H
               PRMSG   TEXT='GETPC: CASE#11-NAME=CVZZ,FETCHONLY=YES'
               SPACE
               GETPC   NAME=CVZZ,ERROR=GETPCE11,                       +
               FETCHONLY=YES,ADDR=R6
               SPACE
               PRMSG  TEXT='GETPC: EXPECTED RESULT- CASE#11 SUCCESSFUL'
               LLGH    R1,SNAP
               LTGR    R1,R1
               JZ      SKIPSNAP11
               STG     R6,EBW000
               SNAPC   R,000011,PREFIX=I,MSG=MSG1,LIST=LIST1
SKIPSNAP11     DS      0H
               J       CASE12
GETPCE11       DS      0H
               PRMSG   TEXT='GETPC: UNEXPECTED RESULT- CASE#11 FAILED'
               J       CASE12
               EJECT   ,
*---------------------------------------------------------------------*
* CASE#12 -- Testing the GETPC macro                                  *
*                                                                     *
* Attributes Returned:                                                *
* ATTRIBUTE TRANSLATION:                                              *
*                                                                     *
*---------------------------------------------------------------------*
CASE12         DS      0H
               CHI     R0,0
               JE      CASE12_DO
               CHI     R0,12
               JNE     RETGETPC
CASE12_DO      DS      0H
               PRMSG   TEXT='GETPC: CASE#12-NAME=....,',CHARA=BSO_NAME  D11964
               PRMSG   TEXT='            LOADSET=........',            +D11964
               CHARA=LSET_NAME                                          D11964
               XGR     R5,R5
               ICM     R5,B'1111',BSO_NAME
               MVC     EBW008(L'LSET_NAME),LSET_NAME
               LA      R2,EBW008                                        C64CK
               SPACE
               GETPC   NAME=(R5),ERROR=GETPCE12,                       +
               LOADSET=R2,ADDR=R6                                       C64CK
               SPACE
               PRMSG  TEXT='GETPC: EXPECTED RESULT- CASE#12 SUCCESSFUL'
               LLGH    R1,SNAP
               LTGR    R1,R1
               JZ      SKIPSNAP12
               STG     R6,EBW000
               SNAPC   R,000012,PREFIX=I,MSG=MSG2,LIST=LIST2
SKIPSNAP12     DS      0H
               J       RETGETPC
GETPCE12       DS      0H
               PRMSG   TEXT='GETPC: UNEXPECTED RESULT- CASE#12 FAILED'
               J       RETGETPC
               EJECT   ,
*---------------------------------------------------------------------*
*---------------------------------------------------------------------*
***                     ERROR CASES --                              ***
*---------------------------------------------------------------------*
GETPC2         DS      0H
               PRMSG   TEXT='GETPC:  PROCESSING ERROR CASES'
*---------------------------------------------------------------------*
* CASE#13 -- Testing the GETPC macro, with an invalid program name    *
*                                                                     *
* Attributes Returned:                                                *
* ATTRIBUTE TRANSLATION:                                              *
*---------------------------------------------------------------------*
CASE13         DS      0H
               CHI     R0,0
               JE      CASE13_DO
               CHI     R0,13
               JNE     CASE14
CASE13_DO      DS      0H
               PRMSG   TEXT='GETPC: CASE#13 ERROR CASE-NAME=ZZZZ'
               GETPC   NAME=ZZZZ,ERROR=GETPCE13,ADDR=R6
               PRERR   TEXT='GETPC: UNEXPECTED RESULT- CASE#13 FAILED'
               J       CASE14
GETPCE13       DS      0H
               PRMSG   TEXT='GETPC: EXPECTED RESULT-CASE#13 SUCCESSFUL'
               LLGH    R1,SNAP
               LTGR    R1,R1
               JZ      SKIPSNAP13
               STG     R6,EBW000
               SNAPC   R,000013,PREFIX=I,MSG=MSG1,LIST=LIST1
SKIPSNAP13     DS      0H
               J       CASE14
               EJECT  1
*---------------------------------------------------------------------*
* CASE#14 -- Testing the GETPC macro, with an invalid loadset name    *
*                                                                     *
* Attributes Returned:                                                *
* ATTRIBUTE TRANSLATION:                                              *
*---------------------------------------------------------------------*
CASE14         DS      0H
               CHI     R0,0
               JE      CASE14_DO
               CHI     R0,14
               JNE     CASE15
CASE14_DO      DS      0H
               PRMSG  TEXT='GETPC: CASE#14 ERROR CASE-NAME=....,',     +D11964
               CHARA=BSO_NAME                                           D11964
               PRMSG  TEXT='                       LOADSET=........',  +D11964
               CHARA=BSO_NAME                                           D11964
               XGR     R5,R5
               ICM     R5,B'1111',BSO_NAME
               MVC     EBW008,BSO_NAME
               LA      R2,EBW008                                        C64CK
               GETPC   NAME=(R5),ERROR=GETPCE14,                       +
               ADDR=R6,                                                +
               LOADSET=R2                                               C64CK
               PRERR   TEXT='GETPC: UNEXPECTED RESULT- CASE#14 FAILED'
               J       CASE15
GETPCE14       DS      0H
               PRMSG   TEXT='GETPC: EXPECTED RESULT-CASE#14 SUCCESSFUL'
               LLGH    R1,SNAP
               LTGR    R1,R1
               JZ      SKIPSNAP14
               STG     R6,EBW000
               SNAPC   R,000014,PREFIX=I,MSG=MSG2,LIST=LIST2
SKIPSNAP14     DS      0H
               J       CASE15
               EJECT  1
*---------------------------------------------------------------------*
* CASE#15 -- Testing the GETPC macro, with no error path indicated,   *
*            a dump is expected.                                      *
*                                                                     *
* Attributes Returned:                                                *
* ATTRIBUTE TRANSLATION:                                              *
*---------------------------------------------------------------------*
CASE15         DS      0H
               CHI     R0,0
               JE      CASE15_DO
               CHI     R0,15
               JNE     CASES_31BIT
CASE15_DO      DS      0H
               PRMSG TEXT='GETPC: CASE#15 ERROR CASE-NAME=ZZZZ,'        D11964
             PRMSG TEXT='                       LOADSET=........ DUMP',+D11964
               CHARA=LSET_NAME                                          D11964
               MVC     EBW008(L'LSET_NAME),LSET_NAME
               LA      R2,EBW008                                        C64CK
               GETPC   NAME=ZZZZ,                                      +D11964
               ADDR=R6,                                                +
               LOADSET=R2                                               C64CK
               PRERR   TEXT='GETPC: UNEXPECTED RESULT- CASE#15 FAILED'
               J       CASES_31BIT
GETPCE15       DS      0H
               PRMSG   TEXT='GETPC: EXPECTED RESULT-CASE#15 SUCCESSFUL'
               LLGH    R1,SNAP
               LTGR    R1,R1
               JZ      SKIPSNAP15
               STG     R6,EBW000
               SNAPC   R,000015,PREFIX=I,MSG=MSG2,LIST=LIST2
SKIPSNAP15     DS      0H
               J       CASES_31BIT
               EJECT  1
*---------------------------------------------------------------------*
* 31-BIT CASES --                                                     *
*                                                                     *
* Attributes Returned:                                                *
* ATTRIBUTE TRANSLATION:                                              *
*---------------------------------------------------------------------*
CASES_31BIT    DS     0H
               CHI     R0,0
               JE      CASES_31BIT_DO
               CHI     R0,15
               JNH     RETGETPC
CASES_31BIT_DO DS      0H
               ENTRC  QMAK
               J      RETGETPC
*---------------------------------------------------------------------*
* RETURN                                                              *
*                                                                     *
*---------------------------------------------------------------------*
            SPACE  1
RETGETPC    EQU    *
            PRMSG   TEXT='COMPLETING THE GETPC MACRO TEST'
            EPLGC   RC=NONE
*
            LTORG
            FINIS   QMAC42
            END
