         PRINT NOGEN
         BEGIN NAME=QMAC50,IBM=YES,TPFISOC=YES
***********************************************************************
*          Licensed Materials - Property of IBM                       *
*          "Restricted Materials of IBM"                              *
*          5748-T15                                                   *
*          Copyright IBM Corp. 2005, 2009                             *
*          All Rights Reserved                                        *
*          US Government Users Restricted Rights - Use, duplication   *
*          or disclosure restricted by GSA ADP Schedule Contract      *
*          with IBM Corp.                                             *
***********************************************************************
*  This file is provided on an "as is" basis.  There are no           *
*  warranties, express or implied, including the implied warranties   *
*  of merchantability and fitness for a particular purpose.           *
*  IBM has no obligation to provide service, defect correction, or    *
*  any maintenance for the file.  IBM has no obligation to supply     *
*  any updates or enhancements for the file to you even if such are   *
*  or later become available.                                         *
***********************************************************************
*  Change History                                                     *
*  20041001  Initial Version                                          *
*  20090402   d18936  "*** Case Failed ***" from PNAMC                *
*                        from ZTEST API5 API-ALL                      *
*                                                                     *
*                                                                     *
***********************************************************************
         DRV51
         CLHEQ
         CZ3CP
         IEQCE2
         IEQCE3
         EV0BK
*
         PRLGC ENAME=attac_macro,BASE=R8,STACK=R13
         CLI   EBX000,X'00'  error cases requested ?
         JNE   ATT1          branch if yes
         PRMSG TEXT='attac:  Assembler driver not provided'
         J     RETATT
ATT1     EQU   *
         PRMSG TEXT='attac:  Assembler driver not provided'
RETATT   EQU   *
         J     RETATT2
*
         LTORG
RETATT2  DS    0F
         EPLGC RC=NONE
         EJECT


         PRLGC ENAME=caloc_macro,BASE=R8,STACK=R13
***********************************************************************
* this function tests the 64 bit option of the caloc macro            *
* to "self check" the caloc'd buffer is verified to ensure it is      *
* zeros and then  used for the msg to console                         *
* also self checks to ensure the registers have not been changed      *
***********************************************************************
         SGR   R1,R1         used for maloc'd buffer
         SGR   R2,R2         used for maloc'd buffer
         SGR   R3,R3         used for caloc'd buffer
         CLI   EBX000,X'00'  error cases requested ?
         JNE   CALOCERR      branch if yes
         PRMSG TEXT='caloc:  1-Executing 64 bit heap option'
* allocate buffers to save registers
         LA    R1,LEN64REG*16   get a block to save before registers
         MALOC SIZE=R1,HEAP=64BIT
         LTGR  R1,R1            address of block is zero if error
         JZ    CALOCNG
         LA    R2,LEN64REG*16   get a block to save after registers
         MALOC SIZE=R2,HEAP=64BIT
         LTGR  R2,R2            address of block is zero if error
         JZ    CALOCNG
*
         LA    R3,1            number of elements to caloc
         LA    R14,BLKSIZE     size of element to caloc
         STMG  R0,R15,0(R1)    save contents of registers before caloc
         CALOC COUNT=R3,ESIZE=R14,HEAP=64BIT
         LTGR  R3,R3           test return and save address
         JZ    CALOCNG         address of block is zero -> error
* compare registers to ensure registers not corrupted
         STMG  R0,R15,0(R2)    save contents of registers after caloc
         CLC   0(LEN64REG*3,R1),0(R2)  r0-r2 corrupted across macro ?
         JNE   CALOCNG       -> error
         CLC   LEN64REG*4(LEN64REG*6,R1),LEN64REG*4(R2)  r4-r9 ng ?
         JNE   CALOCNG       -> error
* was buffer initialized to zero ?
         LGR   R6,R3           address of caloc'd buffer
         LA    R7,BLKSIZE      size of buffer to compare to zeros
         SGR   R14,R14         set up compare to ensure buffer is zeros
         SGR   R15,R15
         CLCL  R6,R14          is buffer initialized to zeros ?
         JNE   CALOCNG         no, -> error rtn
* set caloc'd buffer to print message to console
         LGR   R6,R3
         LA    R7,BLKSIZE-1    length of move to field
         LA    R14,CALOCM01    address of move from field
         LA    R15,L'CALOCM01  length of move from field & 00 padding
         STC   R15,0(,R6)      first byte of wtopc buffer is length
         LA    R6,1(,R6)
         MVCL  R6,R14          move print message into buffer
* send message to console if caloc'd buffer above or below the bar
         LG    R6,=A(0,TWO_GIG)
         CLGR  R3,R6           is buffer address above or below the bar ?
         JL    CALOCLOW        -> if buffer below the bar
         PRMSG TEXT='caloc:  1-buf above bar ................',NUM=(R3)
         J     CALOCOK
*
CALOCLOW EQU   *
         PRMSG TEXT='caloc:  1-buf below bar ................',NUM=(R3)
CALOCOK  EQU   *
         PRMSG TEXTA=(R3)
         J     RETCALOC
*
CALOCM01 DC    C'caloc:  1-test executed successfully'
*
CALOCNG  DS    0F
         PRERR TEXT='caloc: 1-*** Case Failed ***'
         J     RETCALOC
*
CALOCERR DS    0F
         PRMSG TEXT='caloc:  Error case for Assembler not provided'
RETCALOC EQU   *
         FREEC BLOCK=R1
         FREEC BLOCK=R2
         FREEC BLOCK=R3
         EPLGC RC=NONE
         LTORG
         EJECT


         PRLGC ENAME=cfisvc_macro,BASE=R8,STACK=R13
***********************************************************************
* this function executes the cfisvc macro to test the new AMODE parm  *
***********************************************************************
* allocate buffers to save registers
         GETCC DF,L2,FILL=00    get a 1055 block to save regs in
         GETCC DE,L2,FILL=00    get a 1055 block to save regs in
         LGF   R1,CE1CRE
         LGF   R2,CE1CRF
*
         CLI   EBX000,X'00'  error cases requested ?
         JNE   CFISVERR      --> cfisvc error cases
         J     CFISV000      --> cfisvc normal cases
*
* local constants for this function
CFISVMAC DS    0H
         MONTC ,
CFISVSVC DC    C'MONTC'
*
*
CFISVERR DS    0F
         PRMSG TEXT='cfisvc:  Error case for Assembler not provided'
         J     RETCFISV
*
*
CFISVNG1 EQU   *
         PRERR TEXT='cfisvc: 1-registers corrupted'
         J     CFISVNG
*
CFISVNG2 EQU   *
         PRERR TEXT='cfisvc: 1-SVC entry not found'
         J     CFISVNG
*
CFISVNG3 EQU   *
         PRERR TEXT='cfisvc: 1-SVC entry data incorrect'
*
CFISVNG EQU   *
         PRERR TEXT='cfisvc: 1-*** Case Failed ***'
         J     RETCFISV
*
*
CFISV000 DS    0F
         ISV0SV REG=R15
*
         PRMSG TEXT='cfisvc:  1-execute using 64bit addresses'
         LARL  R6,CFISVMAC
         STMG  R0,R15,0(R1)       save contents of registers
         CFISVC SVCX=R6,REG=R15,AMODE=64
         STMG  R0,R15,0(R2)       save contents of registers
         LTGR  R15,R15            was macro found ?
         JZ    CFISVNG2           no --> error
         CLC   CFISVSVC,ISV0MAC   verify table entry is correct
         JNE   CFISVNG3           macro name doesn't match --> error
* compare registers to ensure registers not corrupted
         CLC   0(LEN64REG*14,R1),0(R2)  are regs r0-r13 corrupted ?
         JNE   CFISVNG1                 yes, -> error
         PRMSG TEXT='cfisvc:  1-test executed successfully'
*
*
RETCFISV EQU   *
         CRUSA S0=E,S1=F
         EPLGC RC=NONE
         LTORG
         EJECT
         DROP  R15


         PRLGC ENAME=corhc_macro,BASE=R8,STACK=R13
***********************************************************************
* this function executes the corhc macro using the new SIZE parameter *
***********************************************************************
* allocate buffers to save registers
         GETCC DF,L2,FILL=00    get a 1055 block to save regs in
         GETCC DE,L2,FILL=00    get a 1055 block to save regs in
         LGF   R1,CE1CRE
         LGF   R2,CE1CRF
*
         CLI   EBX000,X'00'  error cases requested ?
         JNE   CORHCERR      --> corhc error cases
         J     CORHC000      --> corhc normal cases
*
* local constants for this function
         DS    0D
CTOKEN   DC    C'apicorhc'
*
*
CORHCERR DS    0F
         PRMSG TEXT='corhc:  Error case for Assembler not provided'
         J     RETCORHC
*
*
CORHCNG1 EQU   *
         PRERR TEXT='corhc: 1-registers corrupted'
*
CORHCNG EQU   *
         PRERR TEXT='corhc: 1-*** Case Failed ***'
         J     RETCORHC
*
*
CORHC000 DS    0F
         PRMSG TEXT='corhc:  1-Executing 64 bit size option'
         STMG  R0,R15,0(R1)    save contents of registers
         CORHC CTOKEN,SIZE=64BIT
         PRMSG TEXT='corhc:  1-Resource held'
* compare registers to ensure registers not corrupted
         STMG  R0,R15,0(R2)    save contents of registers
         CLC   0(LEN64REG*10,R1),0(R2)   are regs r0-r9 corrupted ?
         JNE   CORHCNG1                 yes, -> error
         PRMSG TEXT='corhc:  1-Releasing resource'
         CORUC CTOKEN,SIZE=64BIT
         PRMSG TEXT='corhc:  1-test executed successfully'
*
*
RETCORHC EQU   *
         CRUSA S0=E,S1=F
         EPLGC RC=NONE
         LTORG
         EJECT


         PRLGC ENAME=coruc_macro,BASE=R8,STACK=R13
***********************************************************************
* this function executes the coruc macro using the new SIZE parameter *
***********************************************************************
* allocate buffers to save registers
         GETCC DF,L2,FILL=00    get a 1055 block to save regs in
         GETCC DE,L2,FILL=00    get a 1055 block to save regs in
         LGF   R1,CE1CRE
         LGF   R2,CE1CRF
*
         CLI   EBX000,X'00'  error cases requested ?
         JNE   CORUCERR      --> coruc error cases
         J     CORUC000      --> coruc normal cases
*
* local constants for this function
         DS    0D
UTOKEN   DC    C'coru'
*
*
CORUCERR DS    0F
         PRMSG TEXT='coruc:  Error case for Assembler not provided'
         J     RETCORUC
*
*
CORUCNG1 EQU   *
         PRERR TEXT='coruc: 1-registers corrupted'
*
CORUCNG EQU   *
         PRERR TEXT='coruc: 1-*** Case Failed ***'
         J     RETCORUC
*
*
CORUC000 DS    0F
         PRMSG TEXT='coruc:  1-holding resource w. 64 bit size option'
         LLGF  R14,UTOKEN      r14 contains resource id for corhc
         CORHC SIZE=64BIT
         PRMSG TEXT='coruc:  1-Resource held'
* compare registers to ensure registers not corrupted
         PRMSG TEXT='coruc:  1-Releasing resource w. 32bit size option'
         LLGF  R14,UTOKEN      r14 contains resource id for corhc
         STMG  R0,R15,0(R1)    save contents of registers
         CORUC SIZE=32BIT
         STMG  R0,R15,0(R2)    save contents of registers
         CLC   0(LEN64REG*10,R1),0(R2)   are regs r0-r9 corrupted ?
         JNE   CORUCNG1                 yes, -> error
         PRMSG TEXT='coruc:  1-test executed successfully'
*
*
RETCORUC EQU   *
         CRUSA S0=E,S1=F
         EPLGC RC=NONE
         LTORG
         EJECT


         PRLGC ENAME=cratc_macro,BASE=R8,STACK=R13
         CLI   EBX000,X'00'  error cases requested ?
         JNE   CRAT1         branch if yes
         PRMSG TEXT='cratc:  Assembler driver not provided'
         J     RETCRAT
CRAT1    DS    0F
         PRMSG TEXT='cratc:  Assembler driver not provided'
RETCRAT  EQU   *
         EPLGC RC=NONE
         LTORG

         PRLGC ENAME=flipc_macro,BASE=R8,STACK=R13
         CLI   EBX000,X'00'  error cases requested ?
         JNE   FLIPC1        branch if yes
         PRMSG TEXT='flipc:  Assembler driver not provided'
         J     RETFLIPC
FLIPC1   DS    0F
         PRMSG TEXT='flipc:  Assembler driver not provided'
RETFLIPC EQU   *
         EPLGC RC=NONE
         LTORG
         EJECT


         PRLGC ENAME=crexc_macro,BASE=R8,STACK=R13
***********************************************************************
* this function executes the crexc macro                              *
***********************************************************************
* allocate buffers to save registers
         GETCC DF,L2,FILL=00    get a 1055 block to save regs in
         GETCC DE,L2,FILL=00    get a 1055 block to save regs in
         LGF   R1,CE1CRE
         LGF   R2,CE1CRF
*
         CLI   EBX000,X'00'  error cases requested ?
         JNE   CREXCERR      --> crexc error cases
         J     CREXC000      --> crexc normal cases
*
* local constants for this function
XTOKEN   DC    C'api-crex'
*
*
CREXCERR DS    0F
         PRMSG TEXT='crexc:  Error case for Assembler not provided'
         J     RETCREXC
*
*
CREXCNG1 EQU   *
         PRERR TEXT='crexc: 1-registers corrupted'
         J     CREXCNG
*
CREXCNG2 EQU   *
         PRERR TEXT='crexc: 1-attempted to create duplicate event'
         J     CREXCNG
*
CREXCNG3 EQU   *
         PRERR TEXT='crexc: 1-event error'
         J     CREXCNG
*
CREXCNG4  EQU  *
         PRERR TEXT='crexc: 1-event not found for wait'
*
CREXCNG EQU   *
         PRERR TEXT='crexc: 1-*** Case Failed ***'
         J     RETCREXC
*
*
CREXC000 DS    0F
         LA    R6,LSWB             check available swb's in system
         NUMBC TYPE=R6
         PRMSG TEXT='crexc:  1-execute w. .... swbs available',NUM=(R6)
* ensure created ecb is created
         USING EV0BK,R3        event data
         LA    R3,LEN64REG*17(R1)  use core block, after saved regs
         LA    R6,1            creating 1 ecb
         MVC   EVNBKN,XTOKEN   event name
         STH   R6,EVNBKC1      number of posts to wait for
         EVNTC BLOCK=(R3),TYPE=CNT,NAME=Y,DUPNAM=CREXCNG2
         LA    R14,L'XTOKEN+1  r14 contains # of bytes to pass in crexc
         LA    R15,LEN64REG*17(R2)  use core block, after saved regs
         MVC   0(1,R15),EBCM01      r15 -> parameters to pass in crexc
         MVC   1(L'XTOKEN,R15),XTOKEN       verbose ind, crexc token
         STMG  R0,R15,0(R1)    save contents of registers
         CREXC QMAY            create a low priority deferred entry
         STMG  R0,R15,0(R2)    save contents of registers
         EVNWC BLOCK=(R3),TYPE=CNT,ERROR=CREXCNG3,NFOUND=CREXCNG4
* compare registers to ensure registers not corrupted
         CLC   0(LEN64REG*10,R1),0(R2)  are regs r0-r9 corrupted ?
         JNE   CREXCNG1                 yes, -> error
         PRMSG TEXT='crexc:  1-test executed successfully'
*
*
RETCREXC EQU   *
         CRUSA S0=E,S1=F
         EPLGC RC=NONE
         LTORG
         EJECT

         PRLGC ENAME=detac_macro,BASE=R8,STACK=R13
***********************************************************************
* this function tests the detac with acpdb option:                    *
*                                                                     *
* this function grabs a block off of storage and detacs it with the   *
* acpdb option.  It repeats this 260 times filling each block with    *
* "FF"s.  Then it ATTACs the blocks back on again - verifying that    *
* each block is unchanged.   This test case is performed with storage *
* attached to a datalevel and storage attached to a DECB              *
***********************************************************************
     LA    R4,260         Num of blocks attac/detac
     LA    R7,D1          Data level for getcc
DETACSTART DS 0H
     GETCC D1,L4,FILL=FF
     ST    R4,CE1FA1      Unique id for ECB in FARW
     DETAC ACPDB
     BCTG  R4,DETACSTART   Getcc/detac for R4 num of times
*
     PRMSG TEXT='DETACed 260 blocks'
     LA    R4,260
DETACAT    DS    0H
     ST    R4,CE1FA1      Control which block gets attac
     ATTAC ACPDB
     L     R6,CE1CR1      Ensure block has not changed
     CLI   0(R6),X'FF'
     BNE   DETACERR
*
DETACERB   DS    0H
     CRUSA S0=1           Release block
     BCTG  R4,DETACAT
     LA    R4,260
     PRMSG TEXT='ATTACed 260 Blocks - Test 1 Complete'

*PREP FOR NEXT TEST CASE:Set up DECB DSECT
     IDECB REG=R7,TYPE=APPL
     DECBC FUNC=CREATE,DECB=(R7),NAME=DETACOWN
*
DTCSTART DS   0H
     GETCC DECB=(R7),SIZE=4095,FILL=FF
     ST    R4,IDECFA       Unique id for DECB in FARW
     DETAC DECB=(R7),ACPDB
     BCTG  R4,DTCSTART
*
     PRMSG TEXT='DETACed 260 blocks from DECB'
     LA    R4,260
DTCAT  DS   0H
     ST    R4,IDECFA       Used to control which block bomes back
     ATTAC DECB=(R7),ACPDB
     L     R6,IDECCRW
     CLI   0(R6),X'FF'
     BNE   DTCERR2
DTCERB2   DS   0H
     CRUSA DECB=(R7)
     BCTG  R4,DTCAT
     DECBC FUNC=RELEASE,DECB=(R7)
*
     PRMSG TEXT='ATTACed 260 Blocks - Test 2 Complete'
     B     ENDDTC
*
DETACOWN  DC   CL16'DETAC-DECB'
*
DETACERR    DS    0H
     WTOPC TEXT='DETAC Error: data verify on block ....',SUB=(DEC,(R4))
     B     DETACERB
*
DTCERR2   DS    0H
     WTOPC TEXT='DETAC Error: data verify on DECB  ....',SUB=(DEC,(R4))
     B     DTCERB2
*
ENDDTC  DS  0H
         EPLGC RC=NONE
         LTORG
         EJECT

         PRLGC ENAME=ecblc_macro,BASE=R8,STACK=R13
***********************************************************************
* this function tests the ecblc macro:                                *
*                                                                     *
* this function holds a record and then creates ecb's to queue up to  *
* hold that record.  Then this function uses ECBLC to remove the      *
* iob's for those ecb's                                               *
***********************************************************************
         SGR   R3,R3
* allocate buffers to save registers
         GETCC DF,L2,FILL=00    block to hold event data
         GETCC DE,L2,FILL=00    block to hold parameters for cremc
         LGF   R1,CE1CRE
         LGF   R2,CE1CRF
*
         CLI   EBX000,X'00'  error cases requested ?
         JNE   ECBLCERR      --> ecblc error cases
         J     ECBLC000      --> ecblc normal cases
*
* local constants for this function
ETOKEN   DC    C'api-ecbl'
EOWNER   DC    C'51driver-api-ecblc_macro'
ECBLCEV1 DC    C'ECBLCEV1'
ECBLCEV2 DC    C'ECBLCEV2'
ECBLCEV3 DC    C'ECBLCEV3'
*
*
ECBLCERR DS    0F
         PRMSG TEXT='ecblc:  Error case for Assembler not provided'
         J     RETECBLC
*
*
ECBLCNG1 EQU   *
         ERRNOC FUNC=GET,VALUE=R1
         PRERR TEXT='ecblc: 1-gsysc failed - error code ....',NUM=(R1)
         J     ECBLCNGE
*
ECBLCNG2 EQU   *
         PRERR TEXT='ecblc: 1-getfc failed '
         J     ECBLCNGE
*
ECBLCNG3 EQU   *
         PRERR TEXT='ecblc: 1-attempted to create duplicate event'
         J     ECBLCNG

*
ECBLCNG4 EQU   *
         PRERR TEXT='ecblc: 1-event error'
         J     ECBLCNG
*
ECBLCNF  DS    0F              retry routine for post event
         DEFRC ,
         BCTG R6,ECBLC260
         PRERR TEXT='ecblc: 1-*** event not found for post ***'
*
ECBLCNG  EQU   *               error exit
         RELFC DD              release file address
ECBLCNGE EQU   *
         PRERR TEXT='ecblc: 1-*** Case Failed ***'
         J     RETECBLC
*
*
ECBLC000 DS    0F
         LA    R6,NUMECBS+NUMECBS  if entered multiple times
ECBLC010 EQU   *
         DEFRC ,                   give the ecbs a time to exit
         BCTG  R6,ECBLC010
         LA    R6,LSWB             check available swb's in system
         NUMBC TYPE=R6
         CGHI  R6,X'1F4'           if there are at least 500 swbs
         JH    ECBLC020            --> execute the test
         PRMSG TEXT='ecblc:  1-bypassed, not enough SWBs ....',NUM=(R6)
         J     ECBLCNGE            otherwise, bypass test
*
ECBLC020 EQU   *
         PRMSG TEXT='ecblc:  1-setting up to test ecblc'
         LA    R3,1                   request 1 1MB frames
         LA    R4,SAVEREGS(,R1)
         MVC   0(L'ETOKEN,R4),ETOKEN  set up token for gsysc
         LA    R5,L'ETOKEN(,R4)
         MVC   0(L'EOWNER,R5),EOWNER  set up owner for gysc
         GSYSC FRAMES=R3,HEAP=64BIT,TYPE=1MB,TOKEN=R4,UNIQUE=YES,      X
               OWNER=R5
         LTGR  R3,R3            address of block is zero if error
         JZ    ECBLCNG1
* send message to console if gsysc'd buffer above or below the bar
         LG    R6,=A(0,TWO_GIG)
         CLGR  R3,R6           is buffer address above or below the bar ?
         JL    ECBLCLOW        -> if buffer below the bar
         PRMSG TEXT='ecblc:  1-buf above bar ................',NUM=(R3)
         J     ECBLCONT
*
ECBLCLOW EQU   *
         PRMSG TEXT='ecblc:  1-buf below bar ................',NUM=(R3)
ECBLCONT EQU   *
         GETFC DD,ID=C'OM',RTP=0,ERROR=YES   get file address
         JO    ECBLCNG1                      cc 3 -> error
         PRMSG TEXT='ecblc:  1-got a pool address'
         ENQC  BLOCK=ETOKEN                 lock to update table
* initialize table
         USING ECBTABLE,R3
         CINFC W,CMMOPS        set protection key for gsysc'd buffer
         LGR   R6,R3
         LA    R7,8*NUMECBS+16 size of table item =hdr(16) + items
         SGR   R14,R14
         SGR   R15,R15
         MVCL  R6,R14          initialize all items in table to zero
         MVC   FILEADR,CE1FMD  move file address into table
         LA    R6,NUMECBS      number of ecbs to create
         STG   R6,NUMITEMS
         KEYRC                 restore protection key
*
         DEQC  BLOCK=ETOKEN               unlock table
         PRMSG TEXT='ecblc:  1-ecblc table initialized and unheld'
*
* create ecbs to queue up to hold the file address
         MVC   2(R1,1),EBCM01  parm 2- verbose option
         LA    R6,0            ecb activation number
         LA    R4,1            increment
         LA    R5,NUMECBS      number of ecbs to create
         PRMSG TEXT='ecblc:  1-creating ecbs to queue up'
ECBLC100 EQU   *
         BRXHG R6,R4,ECBLC105  loop to create ecbs
         LA    R14,3           pass three bytes of parms to qmay
         STH   R6,0(R1)        parm 1 - ECB activation number
         LGR   R15,R1          parameters are in blk on data level E
         CREMC QMAY
         J     ECBLC100
ECBLC105 EQU   *
*
* ensure created ecbs have processed
         USING EV0BK,R2        event data
         LA    R6,NUMECBS      number of ecbs to create
         MVC   EVNBKN,ECBLCEV1 event name
         STH   R6,EVNBKC1      number of posts to wait for
         EVNTC BLOCK=(R2),TYPE=CNT,NAME=Y,DUPNAM=ECBLCNG3
         EVNWC BLOCK=(R2),TYPE=CNT,ERROR=ECBLCNG4,NFOUND=ECBLCNG4
*
* check if all ecbs have queued up
         LA    R6,NUMECBS      number of ecbs to create
         SGR   R7,R7           item index
         ENQC  BLOCK=ETOKEN                 lock to update table
         PRMSG TEXT='ecblc:  1-finished waiting for ecbs to process'
ECBLC200 EQU   *
         LG    R5,ECBADR(R7)   R5 = sva address of ecb
         LA    R7,L'ECBADR(R7)
         LTGR  R5,R5
         JNZ   ECBLC250         -> process ECB
         PRERR TEXT='ecblc:  1-unable to process, ecb not in table'
         BCTG R6,ECBLC200      try to process rest of ecbs
         DEQC  BLOCK=ETOKEN    unlock table for exit processing
         J     ECBLCNG         not all ECBs processed successfully
ECBLC250 EQU   *
         PRMSG TEXT='ecblc:  1-executing ecblc for each ecb in table'
         ECBLC ECB=R5         remove iobs q'd to hold f/a for this ecb
         BCTG R6,ECBLC200
*
         PRMSG TEXT='ecblc:  1-all ecbs processed'
         DEQC  BLOCK=ETOKEN    unlock table so other ecbs can access
         LA    R6,3000          max number of retries to post event
ECBLC260 EQU   *
* set up for post
         XC    EVNBKN(EVNBKL),EVNBKN   reinitialize the event block
         MVC   EVNBKN,ECBLCEV2 event name
         POSTC BLOCK=(R2),TYPE=CNT,NFOUND=ECBLCNF   free 1st crem'd ecb
* wait for ECBs to clean up table
* set up for next event
         XC    EVNBKN(EVNBKL),EVNBKN   reinitialize the event block
         MVC   EVNBKN,ECBLCEV3 event name
         LA    R6,NUMECBS      number of ecbs to create
         STH   R6,EVNBKC1      reset number of posts to wait for
         EVNTC BLOCK=(R2),TYPE=CNT,NAME=Y,DUPNAM=ECBLCNG3
         EVNWC BLOCK=(R2),TYPE=CNT,ERROR=ECBLCNG4,NFOUND=ECBLCNG4
*
* check if all ecbs have been dequeued
         LA    R6,NUMECBS      number of ecbs to create
         SGR   R7,R7           item index
         ENQC  BLOCK=ETOKEN                 lock to update table
ECBLC300 EQU   *
         LG    R5,ECBADR(R7)
         LA    R7,L'ECBADR(R7)
         LTGR  R5,R5
         JZ    ECBLC350        ECB processed successfully, -> continue
         PRERR TEXT='ecblc:  1-error w. ecb ................',NUM=(R5)
         DEQC  BLOCK=ETOKEN    error occurred, unlock table
         J     ECBLCNG         -> not all ECBs processed successfully
ECBLC350 EQU   *
         BCTG  R6,ECBLC300
*
* clean up
         DEQC  BLOCK=ETOKEN    unlock table
         RELFC DD              release file address
         PRMSG TEXT='ecblc:  1-test executed successfully'
*
*
RETECBLC EQU   *
         LTGR  R3,R3
         JZ    RETECBXX
         LA    R4,ETOKEN
         RSYSC TOKEN=R4
         LTGR  R15,R15          rsysc successful
         JZ    RETECBXX         yes -> continue to exit
         ERRNOC FUNC=GET,VALUE=R1
         PRERR TEXT='ecblc: 1-rsysc failed - error code ....',NUM=(R1)
RETECBXX EQU   *
         CRUSA S0=E,S1=F
         EPLGC RC=NONE
         DROP  R2
         DROP  R3
         LTORG
         EJECT

         PRLGC ENAME=errnoc_macro,BASE=R8,STACK=R13
***********************************************************************
* this function tests the ERRNOC macro:                               *
* Executes tests in 31 and 64 bit modes.                              *
* ECB FIELDS                                                          *
* EBX000(1) - input param, 00=error cases requested                   *
* EBW050(1) - switch:  00=64bit, FF=reset to addressing mode at entry *
* reserved regs:  R1-> savearea1, R2-> savearea2, R4=loop count       *
***********************************************************************
         IERRN  ,            errno equates
         TAM                 executing in 31 bit 64 bit mode ?
         BRC   3,ERRNOC64    branch if 64 bit mode
         MVI   EBW050,X'FF'  remember entry in 31 bit
         PRMSG TEXT='errnoc:  Execute 31bit tests first'
         J     ERRNOSUP      SetUP
*
ERRNOC64 MVI   EBW050,X'00'  entry in 64 bit
         PRMSG TEXT='errnoc:  Execute 64bit tests first'
*
* SETUP:  Get a 1055 block of scratch space for checking regs
*         in the entry addressing mode
*
ERRNOSUP GETCC DF,L2,FILL=00    will always be <2G
*                               IT BETTER BE...
         LGF   R1,CE1CRF     R1->before savearea
         LGR   R2,R1
         AGHI  R2,X'FF'      R2->after savearea
         AGHI  R2,X'01'      for better alignment
         LA    R4,1          1st of 2 loops through cases
*
* Requesting error cases or good stuff?
*
ERRNCK   CLI   EBX000,X'00'  requesting error test cases...
         JNE   ERRNERR       branch to error test cases
         J     ERRNOC1       branch to non-error cases
*
* Jump here when any test case regs are not restored...
*
ERRNREG  EQU   *
         PRERR TEXT='errnoc:  registers corrupt, QUIT'
         J     ERRNOEND            try to GET OUT...
*                                  not safe to continue
* non-Error test cases...
* ERRNOC ONE
*
ERRNOC1  EQU   *
         PRMSG TEXT='errnoc:  1-SET errno ETPFGSYS_NUNQTKN (=5013)'
         LGHI  R3,ETPFGSYS_NUNQTKN  =5013
         STMG  R0,R13,0(R1)        save regs
         ERRNOC FUNC=SET,VALUE=R3  set errno from reg 3
         STMG  R0,R13,0(R2)        save regs
         CLC   0(8*14,R1),0(R2)    regs before=regs after?
         JNE   ERRNREG             NO - write error msg
         PRMSG TEXT='errnoc:  1-test executed successfully'
*
* ERRNOC TWO
*
ERRNOC2  EQU   *
         PRMSG TEXT='errnoc:  2-GET errno (=5013)'
         STMG  R0,R13,0(R1)         save regs
* Use R14 in the get so that preserved regs are untouched
         ERRNOC FUNC=GET,VALUE=R14  get errno
         STMG  R0,R13,0(R2)         save regs
         CLC   0(8*14,R1),0(R2)     regs before=regs after?
         JNE   ERRNREG              NO - write error msg
*
         CLGR  R3,R14         expected value returned?
         JNE   ERRNOE2         print error msg, continue
         PRMSG TEXT='errnoc:  2-test executed successfully'
         J     ERRNOC3             next test
*
ERRNOE2  EQU   *
         LGR   R3,R14         save returned value for PRT
*                              (PRERR changes R14)
         PRERR TEXT='errnoc:  2-FAIL: got errno=.........',NUM=(R3)
*
* ERRNOC THREE
*
ERRNOC3  EQU   *
         PRMSG TEXT='errnoc:  3-SET errno to 5501 (IBM rsvd)'
         LGF   R0,=F'5501'           documented reserved
         STMG  R0,R13,0(R1)          save regs
         ERRNOC FUNC=SET,VALUE=R0    set errno from reg 0
         STMG  R0,R13,0(R2)        save regs
         CLC   0(8*14,R1),0(R2)    regs before=regs after?
         JNE   ERRNREG             NO - write error msg
* check if errno was set ok...
         SLGR  R5,R5               assure R5 is NOT 5501
         ERRNOC FUNC=GET,VALUE=R5   get errno
         CLGR  R0,R5               expected value returned?
         JNE   ERRNOE3         print error msg, continue
         PRMSG TEXT='errnoc:  3-test executed successfully'
         J     ERRNOC4             next test
*
ERRNOE3  EQU   *
         PRERR TEXT='errnoc:  3-FAIL: got errno=.........',NUM=(R5)
*
* ERRNOC FOUR
*
ERRNOC4  EQU   *
         PRMSG TEXT='errnoc:  4-SET errno to 11000 (user rsvd)'
         LGF   R6,=F'11000'          documented reserved
         STMG  R0,R13,0(R1)          save regs
         ERRNOC FUNC=SET,VALUE=R6    set errno from reg 6
         STMG  R0,R13,0(R2)        save regs
         CLC   0(8*14,R1),0(R2)    regs before=regs after?
         JNE   ERRNREG             NO - write error msg
* check if errno was set ok...
         SLGR  R7,R7               assure R7 is NOT 11k
         ERRNOC FUNC=GET,VALUE=R7   get errno
         CLGR  R6,R7                expected value returned?
         JNE   ERRNOE4         NO-print error msg, continue
         PRMSG TEXT='errnoc:  4-test executed successfully'
         J     ERRNOC5             next test
*
ERRNOE4  EQU   *
         PRERR TEXT='errnoc: 4-FAIL: got errno=.........',NUM=(R7)
*
* ERRNOC FIVE
*
ERRNOC5  EQU   *
         PRMSG TEXT='errnoc:  5-GET/SET errno (501), swap VALUE,FUNC'
         LGHI  R7,ETPFSYSERR       =501
         STMG  R0,R13,0(R1)        save regs
         ERRNOC VALUE=R7,FUNC=SET  Set errno
         STMG  R0,R13,0(R2)        save regs
         CLC   0(8*14,R1),0(R2)    regs before=regs after?
         JNE   ERRNREG             NO - write error msg
* check if errno was set ok...
* use R14 to keep out of the saved regs
         SLGR  R14,R14             set to known value (not 501)
         STMG  R0,R13,0(R1)        save regs
         ERRNOC VALUE=R14,FUNC=GET   get errno
         STMG  R0,R13,0(R2)        save regs
         CLC   0(8*14,R1),0(R2)    regs before=regs after?
         JNE   ERRNREG             NO - write error msg
         CLGR  R7,R14              expected value returned?
         JNE   ERRNOE5         print error msg, continue
         PRMSG TEXT='errnoc:  5-test executed successfully'
         J     ERRNCD        Check if Done
*
ERRNOE5  EQU   *
         LGR   R6,R14        save for print
         PRERR TEXT='errnoc: 5-FAIL: got errno=.........',NUM=(R6)
         J     ERRNCD        Check if Done
*
* Error test cases...
*
ERRNERR  EQU   *
         LG    R3,=F'-1'      all 64 bits -- high order gets F's
         L     R3,=F'-1'      low order gets F's
*2345678901234567890123456789012345678901234567890123456789012345678901
*      PRMSG TEXT='errnoc ERROR: 1-set neg errno=................',  x
*              NUM=(R3)
         PRMSG TEXT='errnoc ERROR: 1-set errno = -1'
         STMG  R0,R13,0(R1)          save regs
         ERRNOC FUNC=SET,VALUE=R3    set errno from reg 3
         STMG  R0,R13,0(R2)        save regs
         CLC   0(8*14,R1),0(R2)    regs before=regs after?
         JNE   ERRNREG             NO - write error msg
* check if errno was set ok...
         SLGR  R6,R6           assure R6 is NOT -1
         ERRNOC FUNC=GET,VALUE=R6  get errno into R6
*
* PRMSG does not print negative numbers correctly in 31bit, so check
*  for the right answer...(64 bit prints ok (all F's), but just do
*  it this way for both modes -- there's enough code in here.
*
         CLGR  R3,R6              expected value returned?
         JNE   ERRNE1          print error msg, continue
         PRMSG TEXT='errnoc ERROR: 1-ok, ERRNOC GET returned -1'
         J     ERRNER2
*
ERRNE1   EQU   *
         PRERR TEXT='errnoc: ERR1-FAIL: got errno=................',   x
               NUM=(R6)

ERRNER2  EQU   *
*    64 bit only test...
         TAM
         BRC   1,ERRNE2T    branch if 64 bit mode to run case
         J     ERRNER3
*
* ERRNOC ERROR 2:  Set an errno > 2G (ie. < 4 bytes)...
*
ERRNE2T  EQU   *
         LGR   R3,R9        start with ECB address
         IIHL  R3,X'42'     turn on some high order bits
         PRMSG TEXT='errnoc ERROR: 2-SET errno GT 4G=................',x
               NUM=(R3)
         STMG  R0,R13,0(R1)          save regs
         ERRNOC FUNC=SET,VALUE=R3    set errno from reg 3
         STMG  R0,R13,0(R2)        save regs
         CLC   0(8*14,R1),0(R2)    regs before=regs after?
         JNE   ERRNREG             NO - write error msg
* check if errno was set ok...
         SLGR   R7,R7               start with NOT big number
         ERRNOC FUNC=GET,VALUE=R7   get errno
* Just print results, let tester decide...
         PRMSG TEXT='errnoc ERROR: 2-ok? Returned  ................ ', x
               NUM=(R7)
*
ERRNER3  EQU   *
*  Force MNOTEs...see design doc for results of these
*        ERRNOC FUNC=SET,VALUE=R8    SETs in invalid regs
*        ERRNOC FUNC=SET,VALUE=R9
*        ERRNOC FUNC=SET,VALUE=R10
*        ERRNOC FUNC=SET,VALUE=R11
*        ERRNOC FUNC=SET,VALUE=R12
*        ERRNOC FUNC=SET,VALUE=R13
*        ERRNOC FUNC=GET,VALUE=R8    GETs in invalid regs
*        ERRNOC FUNC=GET,VALUE=R9
*        ERRNOC FUNC=GET,VALUE=R10
*        ERRNOC FUNC=GET,VALUE=R11
*        ERRNOC FUNC=GET,VALUE=R12
*        ERRNOC FUNC=GET,VALUE=R13
* Force Invalid func...
*        ERRNOC FUNC=GIT,VALUE=R1
* Force bad reg msg
*        ERRNOC FUNC=GET,VALUE=EBW051
*        ERRNOC FUNC=SET,VALUE=EBW051
*
* Check if done...
*
ERRNCD   EQU   *
         LA    R5,2          2 passes through test cases
         CLR   R4,R5         second pass?
         JE    ERRNOEND      yes -- goto exit
         AGHI  R4,X'01'      next pass (loop count)
*
* switch addressing modes and re-execute test cases if required
*
         TAM                 executing in 31 or 64 bit mode ?
         BRC   1,ERRNOS31    branch if 64 bit mode to set 31
         SAM64               set addressing mode to 64
         PRMSG TEXT='errnoc:  Execute again in 64bit mode'
         CLI   EBX000,X'00'  requesting error test cases...
         JNE   ERRNERR       branch to error test cases
         J     ERRNOC1       back to test 1
ERRNOS31 SAM31               set adressing mode to 31
         PRMSG TEXT='errnoc:  Execute again in 31bit mode'
         CLI   EBX000,X'00'  requesting error test cases...
         JNE   ERRNERR       branch to error test cases
         J     ERRNOC1       back to test 1
*
* END processing -- free workarea, reset addr mode and exit
*
ERRNOEND EQU   *
         RELCC DF            give back scratch area
*
         TAM                 executing in 31 bit 64 bit mode ?
         BRC   3,RETNOC64    branch if 64 bit mode
*
RETNOC31 EQU   *             HERE -- in 31 bit mode
         CLI   EBW050,X'00'     entry was 64 bit?
         JNE   ERRNORET         no, entry was 31, just return
         SAM64                  restore addressing mode of caller
         J     ERRNORET
RETNOC64 EQU   *             HERE -- in 64 bit mode
         CLI   EBW050,X'FF'     entry was 31 bit?
         JNE   ERRNORET         no, entry was 64, just return
         SAM31                  restore addressing mode of caller
*
* Return...
*
ERRNORET EQU   *
         EPLGC RC=NONE
         DROP  R13
         LTORG
         EJECT


         PRLGC ENAME=freec_macro,BASE=R8,STACK=R13
***********************************************************************
* this function tests freec in 64 bit mode                            *
* self check ensures the registers have not been changed              *
***********************************************************************
         SGR   R1,R1         used for maloc'd buffer
         SGR   R2,R2         used for maloc'd buffer
         SGR   R3,R3         used for buffer to free
         CLI   EBX000,X'00'  error cases requested ?
         JNE   FREECERR      branch if yes
         PRMSG TEXT='freec:  1-free address of zero in 64 bit mode'
* allocate buffers to save registers
         LA    R1,LEN64REG*16   get a block to save registers in
         MALOC SIZE=R1,HEAP=64BIT
         LTGR  R1,R1            address of block is zero if error
         JZ    FREECNG
         LA    R2,LEN64REG*16
         MALOC SIZE=R2,HEAP=64BIT
         LTGR  R2,R2           address of block is zero if error
         JZ    FREECNG
*
         LGR   R14,R3          block to free may be corrupted
         STMG  R0,R15,0(R1)    save contents of registers
         FREEC BLOCK=R14       free address of zero
* compare registers to ensure registers not corrupted
         STMG  R0,R15,0(R2)    save contents of registers
         CLC   0(LEN64REG*10,R1),0(R2)  are regs corrupted ?
         JNE   FREECNG                  yes, -> error
*
         PRMSG TEXT='freec:  1-test executed successfully'
         J     RETFREEC
FREECNG  DS    0F
         PRERR TEXT='freec: 1-*** Case Failed ***'
         J     RETFREEC
*
FREECERR DS    0F
         PRMSG TEXT='freec:  Error case for Assembler not provided'
RETFREEC EQU   *
         FREEC BLOCK=R1
         FREEC BLOCK=R2
         EPLGC RC=NONE
         LTORG
         EJECT


         PRLGC ENAME=fsysc_macro,BASE=R8,STACK=R13
***********************************************************************
* this function tests the new fsysc macro                             *
***********************************************************************
         SGR   R3,R3
         CLI   EBX000,X'00'  error cases requested ?
         JNE   FSYSCERR      branch if yes
         PRMSG TEXT='fsysc:  Normal case for Assembler not provided'
         J     RETFSYSC
*
FSYSCERR EQU   *
         PRMSG TEXT='fsysc:  1-Executing gsysc 64 bit unique options'
* allocate buffers to save registers
         GETCC DF,L2,FILL=00    get a 1055 block to save regs in
         GETCC DE,L2,FILL=00    get a 1055 block to save regs in
         LGF   R1,CE1CRE
         LGF   R2,CE1CRF
*
         LA    R3,2                   request 2 1MB frames
         LA    R4,SAVEREGS(,R1)
         MVC   0(L'FTOKEN,R4),FTOKEN  set up token for gsysc
         LA    R5,L'FTOKEN(,R4)
         MVC   0(L'FOWNER,R5),FOWNER  set up owner for gysc
         GSYSC FRAMES=R3,HEAP=64BIT,TYPE=1MB,TOKEN=R4,UNIQUE=YES,      X
               OWNER=R5
         LTGR  R3,R3            address of block is zero if error
         JZ    FSYSCNG0
* send message to console if gsysc'd buffer above or below the bar
         LG    R6,=A(0,TWO_GIG)
         CLGR  R3,R6           is buffer address above or below the bar ?
         JL    FSYSCLOW        -> if buffer below the bar
         PRMSG TEXT='fsysc:  1-buf above bar ................',NUM=(R3)
         J     FSYSCONT
*
* local constants for this function
FTOKEN   DC    C'api-fsyc'
FOWNER   DC    C'51driver-api-fsysc_macro'
*
*
FSYSCNG0  DS    0F
         ERRNOC FUNC=GET,VALUE=R1
         PRERR TEXT='fsysc: 1-gsysc failed - error code ....',NUM=(R1)
         J     FSYSCNG
*
FSYSCNG1  DS    0F
         ERRNOC FUNC=GET,VALUE=R1
         PRERR TEXT='fsysc: 1-fsysc failed - error code ....',NUM=(R1)
         J     FSYSCNG
*
FSYSCNG2  DS    0F
         ERRNOC FUNC=GET,VALUE=R1
         PRERR TEXT='fsysc: 1-rsysc failed - error code ....',NUM=(R1)
*
FSYSCNG  EQU   *
         PRERR TEXT='fsysc: 1-*** Case Failed ***'
         J     RETFSYSC
*
FSYSCLOW EQU   *
         PRMSG TEXT='fsysc:  1-buf below bar ................',NUM=(R3)
FSYSCONT EQU   *
         PRMSG TEXT='fsysc:  1-finding buffer just found'
         LGR   R14,R4           set up token for fsys
         STMG  R0,R15,0(R1)     save contents of before registers
         FSYSC TOKEN=R14
* compare registers to ensure registers not corrupted
         STMG  R0,R15,0(R2)      save contents of after registers
         CLC   0(LEN64REG*10,R1),0(R2)  r0-r9 corrupted across macro ?
         JNE   FSYSCNG           -> error
         LTGR  R14,R14           was fsysc successful ?
         JZ    FSYSCNG1          -> error
* the following fsysc should fail, as the buffer was already released
         PRMSG TEXT='fsysc:  1-releasing buffer just found'
         SGR   R3,R3
         RSYSC TOKEN=R4
         LTGR  R15,R15            was rsysc successful ?
         JNZ    FSYSCNG2          -> error if rsysc unsuccessful
         PRMSG TEXT='fsysc:  1-attempt to find buffer already released'
         LGR   R14,R4           set up token for fsys
         STMG  R0,R15,0(R1)     save contents of before registers
         FSYSC TOKEN=R14
         STMG  R0,R15,0(R2)      save contents of after registers
         CLC   0(LEN64REG*10,R1),0(R2)  r0-r9 corrupted across macro ?
         JNE   FSYSCNG           -> error
         LTGR  R14,R14           was fsysc successful ?
         JNZ    FSYSCNG          -> error if fsysc returns successful
         ERRNOC FUNC=GET,VALUE=R1
         PRMSG  TEXT='fsysc: 1-expected return - errno = ....',NUM=(R1)
         PRMSG TEXT='fsysc:  1-test executed successfully'
*
RETFSYSC EQU   *
         LTGR  R3,R3
         JZ    RETFSYXX
         RSYSC TOKEN=R4
         LTGR  R15,R15          rsysc successful
         JZ    RETFSYXX         yes -> continue to exit
         ERRNOC FUNC=GET,VALUE=R1
         PRERR TEXT='fsysc: 1-rsysc failed - error code ....',NUM=(R1)
RETFSYXX EQU   *
         CRUSA S0=E,S1=F
         EPLGC RC=NONE
         LTORG
         EJECT


***********************************************************************
* Removed the gnamc_macro function that tested obsoleted GNAMC macro  * CRK7381
***********************************************************************


         PRLGC ENAME=gsvac_macro,BASE=R8,STACK=R13                      C64CK
***********************************************************************
* this function tests 8 byte addressing for the gsvac macro           *
* if it is not already running in 64 bit mode, sets the addressing    *
* mode and then resets it before returning for the caller.            *
*                                                                     *
* ECB FIELDS                                                          *
* EBW050(1) - switch:  00=64bit, FF=reset to 31bit                    *
***********************************************************************
GSVAC64  EQU   *
         SGR   R3,R3
         CRUSA S0=F,S1=E        test and release data levels e&f
* allocate buffers to save registers
         GETCC DF,L2,FILL=00    get a 1055 block to save regs in
         GETCC DE,L2,FILL=00    get a 1055 block to save regs in
         LGF   R1,CE1CRE
         LGF   R2,CE1CRF
*
         CLI   EBX000,X'00'  error cases requested ?
         JNE   GSVACERR      branch if yes
         J     GSVAC000
*
* local constants for this function
DECBADDR EQU   EBX016,8          DECB Saved Address
NUM16    DC    FD'16'
NUM64    DC    FD'64'
NUM256   DC    FD'256'
NUM1024  DC    FD'1024'
NUM4096  DC    FD'4096'
NUM4104  DC    FD'4104'
TWOGIG   DC    A(0,TWO_GIG)
STOKEN   DC    CL8'api-gsva'
SOWNER   DC    CL32'51driver-api-gsvac_macro'
GSWBCO   DC    CL32'51driver-api-gsvac_macro: test5'
MAXPARM  DS  0F
         DC  A(MAXEPRIV)      * increment max ecb private area
         DC  F'1'             * by 1MB
         DC  F'0'             * end of list
*
*
GSVACERR DS    0F
         PRMSG TEXT='gsvac:  1-Error case for Assembler not provided'
         J     RETGSV64
*
*
GSVACNG0 DS    0F
         PRERR TEXT='gsvac: 1-gsvac took the error return'
         J     GSVACNG
*
GSVACNG1 DS    0F
         ERRNOC FUNC=GET,VALUE=R1
         PRERR TEXT='gsvac: 1-gsysc failed - error code ....',NUM=(R1)
*
GSVACNG  DS    0F
         PRERR TEXT='gsvac: 1-*** Case Failed ***'
         J     RETGSVAC
*
GSVACNG3 DS    0F
         PRERR TEXT='gsvac: memory allocation failed'
         J     RETGSV64
*
GSVACNG4 DS    0F
         PRERR TEXT='gsvac: freeing up memory failed'
         J     RETGSV64
*
GSVACNG5 DS    0F
         PRERR TEXT='gsvac:  ..-comparison failed exiting',NUM=(R7)
         J     RETGSV64
*
GSVACNG6 DS    0F
         PRERR TEXT='gsvac:  02-failed to get keypoint A'
         J     RETGSV64
*
GSVAC000 DS    0F
        PRMSG TEXT='gsvac:  01-getting storage from system heap'
        LA    R3,1                   request 1 1MB frames
        LA    R4,STOKEN
        LA    R5,SOWNER
        GSYSC  FRAMES=R3,HEAP=64BIT,TYPE=1MB,TOKEN=R4,UNIQUE=YES,      X
               OWNER=R5
        LTGR  R3,R3            address of block is zero if error
        JZ    GSVACNG1
* send message to console if gsysc'd buffer above or below the bar
        LARL  R5,TWOGIG
        LG    R6,0(R5)
        CLGR  R3,R6           is buffer address above or below the bar
        JL    GSVACLOW        -> if buffer below the bar
        PRMSG TEXT='gsvac:  01-buf above bar ................',NUM=(R3)
        J     GSVACONT
*
GSVACLOW EQU   *
        PRMSG TEXT='gsvac:  01-buf below bar ................',NUM=(R3)
GSVACONT EQU   *
        LLGF  R5,CE2SVA(R11,R9)  get sva of ecb
        LGR   R6,R3              address of system heap
        STMG  R0,R15,0(R1)     save contents of before registers
        GSVAC ECB=(R5),ADDRESS=(R6),ERROR=GSVACNG0
* compare registers to ensure registers not corrupted
        STMG  R0,R15,0(R2)      save contents of after registers
        CLC   0(LEN64REG*10,R1),0(R2)  r0-r9 corrupted across macro ?
        JNE   GSVACNG           -> error
* send message if converted address is above or below the bar
        LARL  R5,TWOGIG
        LG    R14,0(R5)
*       LG    R14,=A(0,TWO_GIG)
        CLGR  R6,R14          converted addr above or below the bar ?
        JL    GSVACLO2        -> if address below the bar
        PRMSG TEXT='gsvac:  01-sva above bar ................',NUM=(R3)
        J     GSVACON2
*
GSVACLO2 EQU   *
        PRMSG TEXT='gsvac:  01-sva below bar ................',NUM=(R3)
GSVACON2 EQU   *
*
* gevac can only be called from the cp, so since we can't reconvert
* back to verify we get original results, no good way to verify address
*
        PRMSG TEXT='gsvac:  01-test executed successfully'
*
*
RETGSVAC EQU   *
        CRUSA S0=E,S1=F
        LTGR  R3,R3
        JZ    GSVAC002
        RSYSC TOKEN=R4
        LTGR  R15,R15          rsysc successful ?
        JZ    GSVAC002         yes, -->
        ERRNOC FUNC=GET,VALUE=R1
        PRERR TEXT='gsvac: 1-rsysc failed - error code ....',NUM=(R1)
**********************************************************************
*2-checking addresses > ECB heap backed by 1 Meg frames
*EVM address in EVMreg:  addresses in each of the 5 (size) buckets  of
*                        the preallocated ECB heap that are backed by
*                        1 Meg frames
**********************************************************************
GSVAC002 EQU   *
         PRMSG  TEXT='gsvac:  02-Check ECB Heap backed by 1 M Frames '
         GBLB  &BG0
         LA    R7,2                           R7 = Test Case Number
         ICM   R14,3,CE1DBI
         CEBIC DBI,S                          Save the current DBI
         CEBIC BSS                            CEBIC to BSS
         GETKC KPT=A,DATA=R5,ERROR=GSVACNG6   Get Keypoint A
         CEBIC DBI,R                          Restore the current DBI
         CK1KE
KPTA     USING CK1KE,R5                      Address It
*
BUCKET1  DS    0H
         LGH   R6,KPTA.CK1HAVSZ1       Load CK1HAVSZ1 value
         MALOC SIZE=R6,HEAP=31BIT      Alloc mem backed by 1M Frame
         LTGR  R6,R6
         JZ    GSVACNG3                Error in malloc
         CLINKC RTN=GSVACCA            Run GSVAC test
         FREEC BLOCK=R6                Free block
*
BUCKET2  DS    0H
         LGH   R6,KPTA.CK1HAVSZ2       Load CK1HAVSZ2 value
         MALOC SIZE=R6,HEAP=31BIT      Alloc mem backed by 1M Frame
         LTGR  R6,R6
         JZ    GSVACNG3                Error in malloc
         CLINKC RTN=GSVACCA            Run GSVAC test
         FREEC BLOCK=R6                Free block
*
BUCKET3  DS    0H
         LGH   R6,KPTA.CK1HAVSZ3       Load CK1HAVSZ3 value
         MALOC SIZE=R6,HEAP=31BIT      Alloc mem backed by 1M Frame
         LTGR  R6,R6
         JZ    GSVACNG3                Error in malloc
         CLINKC RTN=GSVACCA            Run GSVAC test
         FREEC BLOCK=R6                Free block
*
BUCKET4  DS    0H
         LGH   R6,KPTA.CK1HAVSZ4       Load CK1HAVSZ4 value
         MALOC SIZE=R6,HEAP=31BIT      Alloc mem backed by 1M Frame
         LTGR  R6,R6
         JZ    GSVACNG3                Error in malloc
         CLINKC RTN=GSVACCA            Run GSVAC test
         FREEC BLOCK=R6                Free block
*
BUCKET5  DS    0H
         LGH   R6,KPTA.CK1HAVSZ4       Load CK1HAVSZ4 Value
         LA    R6,8(R6)                +8 to break boundary
         MALOC SIZE=R6,HEAP=31BIT      Alloc mem backed by 1M Frame
         LTGR  R6,R6
         JZ    GSVACNG3                Error in malloc
         CLINKC RTN=GSVACCA            Run GSVAC test
         FREEC BLOCK=R6                Free block
*
BUCKET6  DS    0H
         USING CK1MCENTRY,R3
         LGH   R3,KPTA.CK1MCINUS       CURRENTLY IN USE MEM CONFIG
         MGHI  R3,CK1MCSIZE            CALCULATE THE OFFSET
         LA    R3,KPTA.CK1MCENTRY(R3)  ADJUST THE USING
         LLGF  R6,CK1MCPEH             LOAD CK1MCPEH VALUE
         SLLG  R6,R6,12(0)             Shift left 12 spaces(X4096)
         LA    R6,8(R6)                CK1CMPEH + 8

         MALOC SIZE=R6,HEAP=31BIT      Alloc mem backed by 1M Frame
         LTGR  R6,R6
         JZ    GSVACNG3                Error in malloc
         CLINKC RTN=GSVACCA            Run GSVAC test
         FREEC BLOCK=R6                Free block
*
         PRMSG  TEXT='gsvac:  02-Checking addresses past ECB Heap'
         LG    R6,NUM16                Run out of heap mem - dynamic
         MALOC SIZE=R6,HEAP=31BIT      Alloc mem backed by 1M Frame
         LTGR  R6,R6
         JZ    GSVACNG3                Error in malloc
         CLINKC RTN=GSVACCA            Run GSVAC test
         FREEC BLOCK=R6                Free block
**********************************************************************
*Checking addresses > ECB private backed by 4k frames
*get EVM address in EVMreg:
*    checking addresses beyond the preallocated ECB private
*    area (ie.  in dynamic ECB private, also dynamically modify size of
*    preallocated private, get space in new dynamic area, GSVAC that
*    dress too) that are backed by 4k frames
*In a loop for CK1MCPPA times:
*ORIGSIZE:      DECBC macro to get a DECB block
*               If not ok  PRERR error msg and J GSCLEAN
*               GETCC   L4,COMMON=NO on DECB
*               If not ok  PRERR error msg and J GSCLEAN
*               Big enough...?
*                       GETCC now beyond preallocated space
*                       If ok, test address
**********************************************************************
GSVAC003 EQU *
**********************************************************************
*GSVAC3L    Increase ECB Private size -- add 1M to field CE2EPRIV
*GSVAC3L2   Get more DECBs and 4K blocks to fill new size
*           GETCC into new dynamic area
*           If GETCC ok, test address
**********************************************************************
         LLGH  R4,CE2EPRIV(R9,R11)      Load the Max size for ECB
         LGR   R3,R4                     Private Area (in MB)
         SLLG  R3,R3,3(0)
         MALOC SIZE=R3                  Get a temp storage
         STG   R3,DECBADDR              Saved the maloc address
         PRMSG TEXT='gsvac:  03-ECB Private Area backed by 4K Frames'
*
GSVAC3L  EQU *
         DECBC FUNC=CREATE,DECB=(R2),RC=(R15)
         LTGR  R15,R15
         JNZ   GSVAC3C                  If(Error)-->Cleanup
         STG   R2,0(R3)                 Store DECB addr
         GETCC DECB=(R2),SIZE=4095,COMMON=NO
         LTGR  R14,R14
         JZ    GSVAC3C                  If(@=0)-->Cleanup
         LA    R3,8(R3)                 Get the addr for next DECB
         BCTG  R4,GSVAC3L               Get another DECB
*
         GETCC D1,L4,COMMON=NO         Allocate 1 4K inside EPA
         LTGR  R14,R14
         JZ    GSVAC3C                 If(@=0)-->Cleanup
         LGR   R6,R14
         LA    R7,3                    R7 = Test Case Num
         CLINKC RTN=GSVACCA            Run GSVAC test
         LA    R2,MAXPARM
         EBMAXC LIST=R2                Increase EPRIV by 1
         LA    R4,1                    Allocate into extended EPA
*
GSVAC3L2 EQU *
         DECBC FUNC=CREATE,DECB=(R2),RC=(R15)
         LTGR  R15,R15
         JNZ   GSVAC3C                  If(Error)-->Cleanup
         GETCC DECB=(R2),SIZE=4095,COMMON=NO
         LTGR  R14,R14
         JZ    GSVAC3C                  If(@=0)-->Cleanup
         BCTG  R4,GSVAC3L2
*
         GETCC D2,L4,COMMON=NO         Allocate 1 4K outside EPA
         LTGR  R14,R14
         JZ    GSVAC3C                  If(@=0)-->Cleanup
         LGR   R6,R14
         CLINKC RTN=GSVACCA                Run GSVAC test
**********************************************************************
*GSVAC3C:    Free all blocks allocated  RELCC for GETCC'd blocks
*                                       DECBC to free DECB block
**********************************************************************
GSVAC3C  DS  0H                         Clean up
         RELCC DECB=(R2)
         DECBC FUNC=RELEASE,DECB=(R2)   Free the last DECB block
         MONTC
         LLGH  R4,CE2EPRIV(R9,R11)
         BCTR  R4,R0
         STH   R4,CE2EPRIV(R9,R11)   Restore Private Area Value - 1M
         LMONC
         LG    R3,DECBADDR           Restore the maloc addr
GSVAC3CE LG    R2,0(R3)              Restore the DECB addr
         RELCC DECB=(R2)
         DECBC FUNC=RELEASE,DECB=(R2)   Free the DECB block
         LA    R3,8(R3)              Point to the next DECB addr
         BCTG  R4,GSVAC3CE
         LG    R3,DECBADDR           Restore the maloc addr
         FREEC BLOCK=R3
*
         CRUSA S0=1,S1=2
**********************************************************************
*Checking addresses in and beyond the preallocated stack
*INSTACK:    ALLOC in stack
*OUTSTK:     ALLOC push things onto the stack to get overflow
*            if ok   test address
*            else PRERR ALLOC failed error message
**********************************************************************
GSVAC004 DS  0H
         LA   R2,15               Size of PreAlloc Appl Stack Key A
         PRMSG  TEXT='gsvac:  04-Checking in and beyond App Stack'
*
GSVINSTK DS  0H
         ALLOC SIZE=4096,ADDR=R6  Inside Appl Stack
         BCTG  R2,GSVINSTK
         LA    R7,4                    R7 = Test Case Number
         CLINKC RTN=GSVACCA       Run GSVAC test
*
GSOUTSTK DS  0H
         ALLOC SIZE=4096,ADDR=R6  Stack overflow
         CLINKC RTN=GSVACCA                Run GSVAC test
**********************************************************************
*Checking addresses in SWB and > 4G accessible by CINFC
*SWBADDR:   GSWBC an SWB block
*           if ok test address AND RSWBC the allocated block
*           else PRERR ALLOC failed error message
*OTHERADD:  CINFC request for address of CMMTGTBL
*           if ok  test address
*           else PRERR MALOC failed error message
**********************************************************************
GSVAC005 DS  0H
         PRMSG  TEXT='gsvac:  05-Checking addresses in SWB'
         LA    R2,GSWBCO
*
SWBADDR  DS  0H
         MONTC
         GSWBC  BLOCK=R6,OWNER=R2
         LMONC
         LA    R7,5                        R7 = Test Case Number
         CLINKC RTN=GSVACCA                Run GSVAC test
         RSWBC  BLOCK=R6
         PRMSG  TEXT='gsvac:  05-Checking address using CMMTGTBL'
*
OTHERADD DS  0H
         CINFC  R,CMMTGTBL,F,REG=R6     Get address of CMMTGTBL
         CLINKC RTN=GSVACCA                Run GSVAC test
**********************************************************************
*Checking address in ECB and system from > 2G
*ECBHEAP:   MALOC HEAP=64BIT to get an address in ECB Heap above 2G
*           if ok  test address, free MALOC'd storage
*           else PRERR ALLOC failed error message
*SYSHEAP:   GSYSC  FRAMES=R1(=1),TYPE=4KB,UNIQUE=NO,HEAP=64BIT
*           else PRERR ALLOC failederror message
**********************************************************************
GSVAC006 DS    0H
         PRMSG TEXT='gsvac:  06-ECB and System Heap greater than 2G'
         LA    R6,1                    R6=1
*
ECBHEAP  DS    0H
         MALOC SIZE=R6,HEAP=64BIT      ALLOCATE address > 2G bar
         LTGR  R6,R6
         JZ    GSVACNG3                Error in malloc
         LA    R7,6                    R7 = Test Case Number
         CLINKC RTN=GSVACCA            Run GSVAC test
         FREEC BLOCK=R6                Free block
*
SYSHEAP  DS    0H
         LA    R6,1                    Allocate 1 Frame
         LA    R3,STOKEN
         GSYSC FRAMES=R6,TYPE=4KB,TOKEN=R3,UNIQUE=NO,HEAP=64BIT
         LTGR  R6,R6            address of block is zero if error
         JZ    GSVACNG3
         CLINKC RTN=GSVACCA                Run GSVAC test
         LA    R2,1                    Return 1 Frame
         RSYSC ADDRESS=R6,TOKEN=R3,FRAMES=R2
         LTGR  R15,R15
         JNZ   GSVACNG4
         J RETGSV64
**********************************************************************
* Compare Subroutine
* Get EVM address in EVMreg before entering this subroutine.
* R6 = EVM address - input parameter
* R2 = Real EVM address - internal calculation
* R3 = SVM address - internal calculation
* R4 = Real SVM address - internal calculation
* R5 = SVA of ECB - internal calculation
**********************************************************************
GSVACCA  EQU   *
         SLINKC
         LLGF  R5,CE2SVA(R11,R9)  get sva of ecb
         MONTC                    Load real needs supervisor state
         LRAG  R2,0(,R6)          LRA EVMreg to RealReg2
         LMONC
         LGR   R3,R6              Save EVM address before convert
*EVM to SVM via GSVAC
         PRINT GEN
         GSVAC ECB=(R5),ADDRESS=(R3),ERROR=RETGSV64
*Switch modes since the ECB is not required for the LRA coming up next
*Swtich it CP mode to run SWSPC macro
         MONTC
&BG0     SETB 0                 Set bit to be in CP Mode
         SWSPC GOTO=SVM
&BG0     SETB 1
         LRAG   R4,0(,R3)            LRA SVMreg to RealReg2
*SWSPC back to EVM, again ECBINR9=NO
&BG0     SETB 0
         SWSPC GOTO=EVM
&BG0     SETB 1
         LMONC
         PRINT NOGEN
*CRG RealReg1 to RealReg2
         CGR    R2,R4
         JNE    GSVACNG5          Branch to error output
         PRMSG TEXT='gsvac:  ..-Test case successful',NUM=(R7)
         ELINKC
         RLINKC                  Return to NSI
RETGSV64 EQU   *
         EPLGC RC=NONE
         LTORG
         EJECT

         PRLGC ENAME=gswbc_macro,BASE=R8,STACK=R13
***********************************************************************
* this function tests the new options of the gswbc macro:  OWNER      *
* to "self check" the gswbc'd buffer is used for the msg to console   *
***********************************************************************
         SGR   R3,R3         used for gswbc'd buffer
         CLI   EBX000,X'00'  error cases requested ?
         JNE   GSWBCERR      branch if yes
         PRMSG TEXT='gswbc:  1-Executing 64 bit heap option'
* allocate buffers to save registers
         GETCC DF,L2,FILL=00    get a 1055 block to save regs in
         GETCC DE,L2,FILL=00    get a 1055 block to save regs in
         LGF   R1,CE1CRE
         LGF   R2,CE1CRF
*
         LA    R5,SAVEREGS(,R1)
         MVC   0(L'OWNER,R5),OWNER  set up owner for gsysc
         STMG  R0,R15,0(R1)     save contents of before registers
         GSWBC BLOCK=R3,OWNER=R5
         LTGR  R3,R3            address of block is returned in R3
         JZ    GSWBCNG
* compare registers to ensure registers not corrupted
         STMG  R0,R15,0(R2)      save contents of after registers
         CLC   0(LEN64REG*3,R1),0(R2)  r0-r2 corrupted across macro ?
         JNE   GSWBCNG       -> error
         CLC   LEN64REG*4(LEN64REG*6,R1),LEN64REG*4(R2)  r4-r9 ng ?
         JNE   GSWBCNG       -> error
* set gswbc'd buffer to print message to console
         CINFC W,CMMOPS        set protection key for gswbc'd buffer
         LGR   R6,R3
         LA    R7,BLKSIZE-1    length of move to field
         LARL  R14,GSWBCM01    address of move from field
         LA    R15,L'GSWBCM01  length of move from field & 00 padding
         STC   R15,0(,R6)      first byte of wtopc buffer is length
         LA    R6,1(,R6)
         MVCL  R6,R14          move print message into buffer
         KEYRC                 restore protection key
* send message to console if gswbc'd buffer above or below the bar
         LG    R6,=A(0,TWO_GIG)
         CLGR  R3,R6           is buffer address above or below the bar ?
         JL    GSWBCLOW        -> if buffer below the bar
         PRMSG TEXT='gswbc:  1-buf above bar ................',NUM=(R3)
         J     GSWBCOK
*
GSWBCLOW EQU   *
         PRMSG TEXT='gswbc:  1-buf below bar ................',NUM=(R3)
GSWBCOK  EQU   *
         PRMSG TEXTA=(R3)
         J     RETGSWBC
*
* local constants for this function
GSWBCM01 DC    C'gswbc:  1-test executed successfully'
*
*
GSWBCNG  DS    0F
         PRERR TEXT='gswbc: 1-*** Case Failed ***'
         J     RETGSWBC
*
GSWBCERR DS    0F
         PRMSG TEXT='gswbc:  Error case for Assembler not provided'
RETGSWBC EQU   *
         LTGR  R3,R3         did we get a gswbc'd block ?
         JZ    RETGSWB2      no -->
         RSWBC BLOCK=R3      release swb
RETGSWB2 EQU   *
         CRUSA S0=E,S1=F
         EPLGC RC=NONE
         LTORG
         EJECT


         PRLGC ENAME=gsysc_macro,BASE=R8,STACK=R13
***********************************************************************
* this function tests the new options of the gsysc macro:             *
*   64BIT, 1MBS, TOKEN, UNIQUE and OWNER                              *
* to "self check" the gsysc'd buffer is used for the msg to console   *
***********************************************************************
         SGR   R3,R3         used for gsysc'd buffer
         CLI   EBX000,X'00'  error cases requested ?
         JNE   GSYSCERR      branch if yes
         PRMSG TEXT='gsysc:  1-Executing 64 bit heap option'
* allocate buffers to save registers
         GETCC DF,L2,FILL=00    get a 1055 block to save regs in
         GETCC DE,L2,FILL=00    get a 1055 block to save regs in
         LGF   R1,CE1CRE
         LGF   R2,CE1CRF
*
         LA    R3,2             request 2 1MB frames
         LA    R4,SAVEREGS(,R1)
         MVC   0(L'TOKEN,R4),TOKEN  set up token for gsysc
         LA    R5,L'TOKEN(,R4)
         MVC   0(L'OWNER,R5),OWNER  set up owner for gysc
         STMG  R0,R15,0(R1)     save contents of before registers
         GSYSC FRAMES=R3,HEAP=64BIT,TYPE=1MB,TOKEN=R4,UNIQUE=YES,      X
               OWNER=R5
         LTGR  R3,R3            address of block is zero if error
         JZ    GSYSCNG1
* compare registers to ensure registers not corrupted
         STMG  R0,R15,0(R2)      save contents of after registers
         CLC   0(LEN64REG*3,R1),0(R2)  r0-r2 corrupted across macro ?
         JNE   GSYSCNG       -> error
         CLC   LEN64REG*4(LEN64REG*6,R1),LEN64REG*4(R2)  r4-r9 ng ?
         JNE   GSYSCNG       -> error
* set gsysc'd buffer to print message to console
         CINFC W,CMMOPS        set protection key for gsysc'd buffer
         LGR   R6,R3
         LA    R7,BLKSIZE-1    length of move to field
         LARL  R14,GSYSCM01    address of move from field
         LA    R15,L'GSYSCM01  length of move from field & 00 padding
         STC   R15,0(,R6)      first byte of wtopc buffer is length
         LA    R6,1(,R6)
         MVCL  R6,R14          move print message into buffer
         KEYRC                 restore protection key
* send message to console if gsysc'd buffer above or below the bar
         LG    R6,=A(0,TWO_GIG)
         CLGR  R3,R6           is buffer address above or below the bar ?
         JL    GSYSCLOW        -> if buffer below the bar
         PRMSG TEXT='gsysc:  1-buf above bar ................',NUM=(R3)
         J     GSYSCOK
*
GSYSCLOW EQU   *
         PRMSG TEXT='gsysc:  1-buf below bar ................',NUM=(R3)
GSYSCOK  EQU   *
         PRMSG TEXTA=(R3)
         J     RETGSYSC
*
* local constants for this function
GSYSCM01 DC    C'gsysc:  1-test executed successfully'
TOKEN    DC    C'api-gsyc'
OWNER    DC    C'51driver-api-gsysc_macro'
*
*
GSYSCNG1 DS     0F
         ERRNOC FUNC=GET,VALUE=R1
         PRERR TEXT='gsysc: 1-gsysc failed - error code ....',NUM=(R1)
*
GSYSCNG  EQU   *
         PRERR TEXT='gsysc: 1-*** Case Failed ***'
         J     RETGSYSC
*
GSYSCERR DS    0F
         PRMSG TEXT='gsysc:  Error case for Assembler not provided'
RETGSYSC EQU   *
         LTGR  R3,R3         did we get a gsysc'd block ?
         JZ    RETGSYS2      no, then it's not an error
         RSYSC TOKEN=R4
         LTGR  R15,R15       was rsysc successful ?
         JZ    RETGSYS2      yes -> skip error message
         ERRNOC FUNC=GET,VALUE=R1
         PRERR TEXT='gsysc: 1-rsysc failed - error code ....',NUM=(R1)
RETGSYS2 EQU   *
         CRUSA S0=E,S1=F
         EPLGC RC=NONE
         LTORG
         EJECT

         PRLGC ENAME=linku_macro,BASE=R8,STACK=R13
***********************************************************************
* this function tests the new link utilities tools.  It uses ENTRC    *
* and PNAMC to check if the linker is using the export file correctly *
***********************************************************************
         CLI   EBX000,X'00'  error cases requested ?
         JNE   LINKUERR      branch if yes
         PRMSG TEXT='linku:  Executing ENTRC testcase 1'
         ENTRC QMAL
         PRMSG TEXT='linku:  Executing ENTRC testcase 2'
         ENTRC QMAM
         PRMSG TEXT='linku:  Executing ENTRC testcase 3'
         ENTRC QMAJ
         PRMSG TEXT='linku:  Test cases completed successfully'
         J     LINKUEND
LINKUERR DS  0H
         PRMSG TEXT='linku:  No error testcases for linku'
LINKUEND DS  0H
         EPLGC RC=NONE
         LTORG
         EJECT

         PRLGC ENAME=maloc_macro,BASE=R8,STACK=R13
***********************************************************************
* this function tests the 64 bit option of the maloc macro            *
* to "self check" the maloc'd buffer is used for the msg to console   *
***********************************************************************
         SGR   R3,R3         used for maloc'd buffer
         CLI   EBX000,X'00'  error cases requested ?
         JNE   MALOCERR      branch if yes
         PRMSG TEXT='maloc:  1-Executing 64 bit heap option'
* allocate buffers to save registers
         GETCC DF,L2,FILL=00    get a 1055 block to save regs in
         GETCC DE,L2,FILL=00    get a 1055 block to save regs in
         LGF   R1,CE1CRE
         LGF   R2,CE1CRF
*
         LA    R3,BLKSIZE
         STMG  R0,R15,0(R1)     save contents of before registers
         MALOC SIZE=R3,HEAP=64BIT
         LTGR  R3,R3            address of block is zero if error
         JZ    MALOCNG
* compare registers to ensure registers not corrupted
         STMG  R0,R15,0(R2)      save contents of after registers
         CLC   0(LEN64REG*3,R1),0(R2)  r0-r2 corrupted across macro ?
         JNE   MALOCNG       -> error
         CLC   LEN64REG*4(LEN64REG*6,R1),LEN64REG*4(R2)  r4-r9 ng ?
         JNE   MALOCNG       -> error
* set maloc'd buffer to print message to console
         LGR   R6,R3
         LA    R7,BLKSIZE-1    length of move to field
         LA    R14,MALOCM01    address of move from field
         LA    R15,L'MALOCM01  length of move from field & 00 padding
         STC   R15,0(,R6)      first byte of wtopc buffer is length
         LA    R6,1(,R6)
         MVCL  R6,R14          move print message into buffer
* send message to console if maloc'd buffer above or below the bar
         LG    R6,=A(0,TWO_GIG)
         CLGR  R3,R6           is buffer address above or below the bar ?
         JL    MALOCLOW        -> if buffer below the bar
         PRMSG TEXT='maloc:  1-buf above bar ................',NUM=(R3)
         J     MALOCOK
*
MALOCLOW EQU   *
         PRMSG TEXT='maloc:  1-buf below bar ................',NUM=(R3)
MALOCOK  EQU   *
         PRMSG TEXTA=(R3)
         J     RETMALOC
*
MALOCM01 DC    C'maloc:  1-test executed successfully'
MALOCNG  DS    0F
         PRERR TEXT='maloc: 1-*** Case Failed ***'
         J     RETMALOC
*
MALOCERR DS    0F
         PRMSG TEXT='maloc:  Error case for Assembler not provided'
RETMALOC EQU   *
         CRUSA S0=E,S1=F
         FREEC BLOCK=R3
         EPLGC RC=NONE
         LTORG
         EJECT


         PRLGC ENAME=maxbc_macro,BASE=R8,STACK=R13
***********************************************************************
* this function executes the 1MB frame option of the maxbc macro      *
* self checks ensure the registers have not been changed              *
***********************************************************************
         SGR   R1,R1         used for maloc'd buffer
         SGR   R2,R2         used for maloc'd buffer
         CLI   EBX000,X'00'  error cases requested ?
         JNE   MAXBCERR      branch if yes
*
* allocate buffers to save registers
         LA    R1,LEN64REG*16   get a block to save registers in
         MALOC SIZE=R1,HEAP=64BIT
         LTGR  R1,R1         address of block is zero if error
         JZ    MAXBCNG
         LA    R2,LEN64REG*16
         MALOC SIZE=R2,HEAP=64BIT
         LTGR  R2,R2         address of block is zero if error
         JZ    MAXBCNG
         PRMSG TEXT='maxbc:  1-querying max 1MB frames in the system'
         LA    R3,LFRM1MB    block type = 1MB frames
         STMG  R0,R15,0(R1)  save contents of registers
         MAXBC TYPE=R3
         STMG  R0,R15,0(R2)  save contents of registers
         CLC   0(LEN64REG*3,R1),0(R2)  r0-r2 corrupted across macro ?
         JNE   MAXBCNG       -> error
         CLC   LEN64REG*4(LEN64REG*6,R1),LEN64REG*4(R2)  r4-r9 ng ?
         JNE   MAXBCNG       -> error
*        CLC   LEN64REG*11(LEN64REG*5,R1),LEN64REG*11(R2)  r11-r15 ng ?
*        JNE   MAXBCNG       -> error
*convert r15 to print number and display # of blocks to the console
         PRMSG TEXT='maxbc:  1-test executed successfully'
         J     RETMAXBC
*
MAXBCNG  DS    0F
         PRERR TEXT='maxbc: 1-*** Case Failed ***'
         J     RETMAXBC
*
MAXBCERR DS    0F
         PRMSG TEXT='maxbc:  Error case for Assembler not provided'
RETMAXBC EQU   *
         FREEC BLOCK=R1
         FREEC BLOCK=R2
         EPLGC RC=NONE
         LTORG
         EJECT


         PRLGC ENAME=numbc_macro,BASE=R8,STACK=R13
***********************************************************************
* this function executes the 1MB frame option of the numbc macro      *
* self checks ensure the registers have not been changed              *
***********************************************************************
         SGR   R1,R1         used for maloc'd buffer
         SGR   R2,R2         used for maloc'd buffer
         CLI   EBX000,X'00'  error cases requested ?
         JNE   NUMBCERR      branch if yes
*
* allocate buffers to save registers
         LA    R1,LEN64REG*16
         MALOC SIZE=R1,HEAP=64BIT
         LTGR  R1,R1         address of block is zero if error
         JZ    NUMBCNG
         LA    R2,LEN64REG*16
         MALOC SIZE=R2,HEAP=64BIT
         LTGR  R2,R2         address of block is zero if error
         JZ    NUMBCNG
         STMG  R0,R15,0(R1)  save contents of registers
         PRMSG TEXT='numbc:  1-query available 1MB frames in system'
         LA    R3,LFRM1MB    block type = 1MB frames
         NUMBC TYPE=R3
         STMG  R0,R15,0(R2)  save contents of registers
         PRMSG TEXT='numbc:  1-available = ................',NUM=(R3)
         CLC   0(LEN64REG*3,R1),0(R2)  r0-r2 corrupted across macro ?
         JNE   NUMBCNG       -> error
         CLC   LEN64REG*4(LEN64REG*6,R1),LEN64REG*4(R2)  r4-r9 ng ?
         JNE   NUMBCNG       -> error
*        CLC   LEN64REG*11(LEN64REG*5,R1),LEN64REG*11(R2)  r11-r15 ng ?
*        JNE   NUMBCNG       -> error
*convert r15 to print # & display available # of blocks to the console
         PRMSG TEXT='numbc:  1-test executed successfully'
         J     RETNUMBC
*
NUMBCNG  DS    0F
         PRERR TEXT='numbc: 1-*** Case Failed ***'
         J     RETNUMBC
*
NUMBCERR DS    0F
         PRMSG TEXT='numbc:  Error case for Assembler not provided'
RETNUMBC EQU   *
         FREEC BLOCK=R1
         FREEC BLOCK=R2
         EPLGC RC=NONE
         LTORG
         EJECT


         PRLGC ENAME=phybc_macro,BASE=R8,STACK=R13
***********************************************************************
* this function executes the 1MB frame option of the phybc macro      *
* self checks ensure the registers have not been changed              *
***********************************************************************
         SGR   R1,R1         used for maloc'd buffer
         SGR   R2,R2         used for maloc'd buffer
         CLI   EBX000,X'00'  error cases requested ?
         JNE   PHYBCERR      branch if yes
*
* allocate buffers to save registers
         LA    R1,LEN64REG*16
         MALOC SIZE=R1,HEAP=64BIT
         LTGR  R1,R1         address of block is zero if error
         JZ    PHYBCNG
         LA    R2,LEN64REG*16
         MALOC SIZE=R2,HEAP=64BIT
         LTGR  R2,R2         address of block is zero if error
         JZ    PHYBCNG
         PRMSG TEXT='phybc:  1-query physical size of 1MB frame'
         LA    R3,LFRM1MB    block type = 1MB frames
         STMG  R0,R15,0(R1)  save contents of registers
         PHYBC TYPE=R3
         STMG  R0,R15,0(R2)  save contents of registers
         CLC   0(LEN64REG*3,R1),0(R2)  r0-r2 corrupted across macro ?
         JNE   PHYBCNG       -> error
         CLC   LEN64REG*4(LEN64REG*6,R1),LEN64REG*4(R2)  r4-r9 ng ?
         JNE   PHYBCNG       -> error
         CLC   LEN64REG*14(LEN64REG*2,R1),LEN64REG*14(R2)  r14-r15 ng ?
         JNE   PHYBCNG       -> error
*convert r15 to printnumber and display size of block to the console
         PRMSG TEXT='phybc:  1-test executed successfully'
         J     RETPHYBC
*
PHYBCNG  DS    0F
         PRERR TEXT='phybc: 1-*** Case Failed ***'
         J     RETPHYBC
*
PHYBCERR DS    0F
         PRMSG TEXT='phybc:  Error case for Assembler not provided'
RETPHYBC EQU   *
         FREEC BLOCK=R1
         FREEC BLOCK=R2
         EPLGC RC=NONE
         LTORG
         EJECT



         PRLGC ENAME=pnamc_macro,BASE=R8,STACK=R13
*******************************************************************
* this function runs the following testcases for the TPFISOC case *
* then ENTDC QMAX to start the testcases for the BSO case:        *
*   PNAMC FINDNAME,FIELD=NAME,NOTFOUND=PNAMC012                   *
*         PNAMC FINDNAME,FIELD=NAME,FOUND=PNAMC016                *
*         PNAMC NEWTRNAME,NAMETYPE=CALLER,FOUND=PNAMC022          *
*         PNAMC FIELD=NAME,NAMETYPE=CALLER,FOUND=PNAMC032         *
*         PNAMC NEWTRNAME,FIELD=NAME                              *
*         PNAMC NEWTRNAME,NAMETYPE=PAT                            *
*         PNAMC FIELD=NAME,NAMETYPE=TRACE                         *
*         PNAMC FIELD=NAME,NAMETYPE=PAT                           *
* PNAMC ...,NAMETYPE=PROGRAM should not be used in TPFISOC code   *
*******************************************************************
         CLI   EBX000,X'00'  error cases requested ?
         JNE   PNAMCERR      branch if yes
         USING PNAMCRET,R3
         SGR   R1,R1         used for buffers of before registers
         SGR   R2,R2         used for buffer of after registers
         SGR   R3,R3         field for returned info from pnamc
*
* allocate buffers to save registers
         LA    R1,LEN64REG*16
         MALOC SIZE=R1,HEAP=64BIT
         LTGR  R1,R1         address of block is zero if error
         JNZ   PNAMC000      no error, -> continue processing
         PRERR TEXT='QMAC: error in set up *** Case Failed ***'
         J     RETPNAMC
*
PNAMC000 DS    0H
         LA    R2,LEN64REG*16
         MALOC SIZE=R2,HEAP=64BIT
         LTGR  R2,R2         address of block is zero if error
         JNZ   PNAMC002      no error, -> continue processing
         PRERR TEXT='QMAC: error in set up *** Case Failed ***'
         J     RETPNAMC
*
PNAMC002 DS    0H
         LA    R3,L'RETBUF
         MALOC SIZE=R3,HEAP=64BIT
         LTGR  R3,R3         address of block is zero if error
         JNZ   PNAMC010      no error, -> continue processing
         PRERR TEXT='QMAC: error in set up *** Case Failed ***'
         J     RETPNAMC
*
* PNAMC FINDNAME,FIELD=,NOTFOUND testcase
* testcase #1- expected NOTFOUND
PNAMC010 DS    0H
         PRMSG TEXT='QMAC: 1-Testing PNAMC FINDNAME,FIELD=,NOTFOUND='
         LARL  R5,PNAMCNA1   load the addr of 'Q???'
         MVC   NAME,0(R5)    set the name used by FINDNAME
         STMG  R0,R15,0(R1)  save contents of registers
         PNAMC FINDNAME,FIELD=NAME,NOTFOUND=PNAMC012
         PRERR TEXT='QMAC: 1-Found error *** Case Failed ***'
         J     PNAMC015      -> next test case
PNAMC012 DS    0H
         STMG  R0,R15,0(R2)  save contents of registers
         CLC   0(LEN64REG*14,R1),0(R2)  r0-r13 corrupted across macro?
         JE    PNAMC014      no error, -> continue processing
         PRERR TEXT='QMAC: 1-Registers corrupted *** Case Failed ***'
         J     PNAMC015      -> next test case
PNAMC014 DS    0H
         PRMSG TEXT='QMAC: 1-Test executed successfully'
*
* PNAMC FINDNAME,FIELD=,FOUND testcase
* testcase #1a- expected found
PNAMC015 DS    0H
         PRMSG TEXT='QMAC: 1a-Testing PNAMC FINDNAME,FIELD=,FOUND='
         LARL  R5,PNAMCNA2   load the addr of 'QMAC'
         MVC   NAME,0(R5)    set the name used by FINDNAME
         STMG  R0,R15,0(R1)  save contents of registers
         PNAMC FINDNAME,FIELD=NAME,FOUND=PNAMC016
         PRERR TEXT='QMAC: 1a-Not found error *** Case Failed ***'
         J     PNAMC020      -> next test case
PNAMC016 DS    0H
         STMG  R0,R15,0(R2)  save contents of registers
         CLC   0(LEN64REG*14,R1),0(R2)  r0-r13 corrupted across macro?
         JE    PNAMC018      no error, -> continue processing
         PRERR TEXT='QMAC: 1a-Registers corrupted *** Case Failed ***'
         J     PNAMC020      -> next test case
PNAMC018 DS    0H
         PRMSG TEXT='QMAC: 1a-Test executed successfully'
*
* PNAMC NEWTRNAME,CALLER,FOUND testcase
* testcase #2- update CE3TRNAME with the CALLER option
*              expected notfound
PNAMC020 DS    0H
         PRMSG TEXT='QMAC: 2-Testing PNAMC NEWTRNAME,CALLER,FOUND='
         STMG  R0,R15,0(R1)  save contents of registers
         PNAMC NEWTRNAME,NAMETYPE=CALLER,FOUND=PNAMC022
         PRERR TEXT='QMAC: 2-Not found error *** Case Failed ***'
         J     PNAMC030      -> next test case
PNAMC022 DS    0H
         STMG  R0,R15,0(R2)  save contents of registers
         CLC   0(LEN64REG*14,R1),0(R2)  r0-r13 corrupted across macro?
         JE    PNAMC026      no error, -> continue processing
         PRERR TEXT='QMAC: 2-Registers corrupted *** Case Failed ***'
         J     PNAMC030      -> next test case
PNAMC026 DS    0H
         PRMSG TEXT='QMAC: 2-test executed successfully'
*
* PNAMC SAVENAME,CALLER,FOUND testcase
* testcase #3- update FIELD with the CALLER option
PNAMC030 DS    0H
         PRMSG TEXT='QMAC:  3-Testing PNAMC SAVENAME,CALLER,FOUND='
         STMG  R0,R15,0(R1)  save contents of registers
         PNAMC FIELD=NAME,NAMETYPE=CALLER,FOUND=PNAMC032
         PRERR TEXT='QMAC:  3-Not found error *** Case Failed ***'
         J     PNAMC040      -> next test case
PNAMC032 DS    0H
         STMG  R0,R15,0(R2)  save contents of registers
         CLC   0(LEN64REG*14,R1),0(R2)  r0-r13 corrupted across macro?
         JE    PNAMC036      no error, -> continue processing
         PRERR TEXT='QMAC:  3-registers corrupted *** Case Failed ***'
         J     PNAMC040      continue processing rest of tests
PNAMC036 DS    0H
         PRMSG TEXT='QMAC:  3-test executed successfully'
*
* PNAMC NEWTRNAME,FIELD= testcase
* testcase #4
PNAMC040 DS    0H
         PRMSG TEXT='QMAC:  4-Testing PNAMC NEWTRNAME,FIELD='
         LARL  R5,PNAMCNA1   load the addr of 'Q???'
         MVC   NAME,0(R5)    set new trace name
         STMG  R0,R15,0(R1)  save contents of registers
         PNAMC NEWTRNAME,FIELD=NAME
         STMG  R0,R15,0(R2)  save contents of registers
         CLC   0(LEN64REG*14,R1),0(R2)  r0-r13 corrupted across macro?
         JE    PNAMC042      no error, -> continue processing
         PRERR TEXT='QMAC: 4-registers corrupted *** Case Failed ***'
         J     PNAMC050      finished with this test case
PNAMC042 DS    0H
         LA    R4,CE3TRNAME(R12,R9)
         LARL  R5,PNAMCNA1   load the addr of 'Q???'
         CLC   0(L'CE3TRNAME,R4),0(R5) check the change is correctly
         JE    PNAMC046      no error, -> continue processing
         PRERR TEXT='QMAC: 4-change trace name *** Case Failed ***'
         J     PNAMC050      continue processing
PNAMC046 DS    0H
         PRMSG TEXT='QMAC:  4-test executed successfully'
*
* PNAMC NEWTRNAME,PAT testcase
* testcase #5
PNAMC050 DS    0H
         PRMSG TEXT='QMAC:  5-Testing PNAMC NEWTRNAME,PROGRAM'
         XC    RETBUF,RETBUF  initialize return field
         STMG  R0,R15,0(R1)  save contents of registers
         PNAMC NEWTRNAME,NAMETYPE=PAT
         STMG  R0,R15,0(R2)  save contents of registers
         CLC   0(LEN64REG*14,R1),0(R2)  r0-r13 corrupted across macro?
         JE    PNAMC052      no error, -> continue processing
         PRERR TEXT='QMAC: 5-registers corrupted *** Case Failed ***'
         J     PNAMC060      finished with this test case
PNAMC052 DS    0H
         LA    R4,CE3TRNAME(R12,R9)
         LARL  R5,PNAMCNA2   load the addr of 'QMAC'
         CLC   0(L'CE3TRNAME,R4),0(R5)
         JE    PNAMC056      no error, -> continue processing
         PRERR TEXT='QMAC: 5-Incorrect CE3TRNAME update * Case Failed*'
         J     PNAMC060      continue processing
PNAMC056 DS    0H
         PRMSG TEXT='QMAC:  5-test executed successfully'
*
* PNAMC default (ie. SAVENAME),FIELD=,TRACE testcase
* test case #6- update FIELD with the TRACE option
*               the content of the CE3TRNAME is QMAC
PNAMC060 DS    0H
         PRMSG TEXT='QMAC: 6-Testing PNAMC FIELD=,TRACE'
         STMG  R0,R15,0(R1)  save contents of registers
         PNAMC FIELD=NAME,NAMETYPE=TRACE
         STMG  R0,R15,0(R2)  save contents of registers
         CLC   0(LEN64REG*14,R1),0(R2)  r0-r13 corrupted across macro?
         JE    PNAMC062      no error, -> continue processing
         PRERR TEXT='QMAC: 6-registers corrupted *** Case Failed ***'
         J     PNAMC070      all testcases completed
PNAMC062 DS    0H
         LARL  R5,PNAMCNA2   load the addr of 'QMAC'
         CLC   NAME,0(R5)
         JE    PNAMC066      no error, -> continue processing
         PRERR TEXT='QMAC: 6-Incorrect FIELD update * Case Failed *'
         J     PNAMC070      all testcases completed
PNAMC066 DS    0H
         PRMSG TEXT='QMAC: 6-test executed successfully'
*
* PNAMC default (ie. SAVENAME),FIELD=,PAT testcase
* test case #7- update FIELD with the PAT option
*               the content of the PAT is QMAC
PNAMC070 DS    0H
         PRMSG TEXT='QMAC: 7-Testing PNAMC FIELD=,PAT'
         STMG  R0,R15,0(R1)  save contents of registers
         PNAMC FIELD=NAME,NAMETYPE=PAT
         STMG  R0,R15,0(R2)  save contents of registers
         CLC   0(LEN64REG*14,R1),0(R2)  r0-r13 corrupted across macro?
         JE    PNAMC072      no error, -> continue processing
         PRERR TEXT='QMAC: 7-registers corrupted *** Case Failed ***'
         J     PNAMC080      all testcases completed
PNAMC072 DS    0H
         LARL  R5,PNAMCNA2   load the addr of 'QMAC'
         CLC   NAME,0(R5)
         JE    PNAMC076      no error, -> continue processing
         PRERR TEXT='QMAC: 7-Incorrect FIELD update * Case Failed *'
         J     PNAMC080      all testcases completed
PNAMC076 DS    0H
         PRMSG TEXT='QMAC: 7-test executed successfully'
*
PNAMC080 DS    0H
         FREEC BLOCK=R1
         FREEC BLOCK=R2
         FREEC BLOCK=R3
         PRMSG TEXT='QMAC: CREMC QMAX to test PNAMC macro'
         LA    R14,1        Pass Verbose flag
         LA    R15,EBCM01   Set address of flag
         CREMC QMAX         Not breaking api-all option with ENTDC
         J     RETPNAMC
PNAMCNA1 DC    C'Q???'
PNAMCNA2 DC    C'QMAC'
PNAMCERR DS    0F
         PRMSG TEXT='QMAC: Error case for Assembler not provided'
RETPNAMC DS    0H
         EPLGC RC=NONE
         LTORG
         EJECT

         PRLGC ENAME=raloc_macro,BASE=R8,STACK=R13
***********************************************************************
* this function tests the 64 bit option of the raloc macro            *
* to "self check" the raloc'd buffer is checked to ensure it still    *
* contains the msg txt and if so it is used for the msg to console    *
***********************************************************************
         SGR   R3,R3         used for raloc'd buffer
         CLI   EBX000,X'00'  error cases requested ?
         JNE   RALOCERR      branch if yes
*
         PRMSG TEXT='raloc:  1-Executing 64 bit heap option'
* allocate buffers to save registers
         LA    R3,BLKSIZE
         MALOC SIZE=R3,HEAP=64BIT
         LTGR  R14,R3        address of block is zero if error
         JZ    RALOCNG
         LA    R15,BLKSIZE-1   length of move to field
         LA    R6,RALOCM01     address of move from field
         LA    R7,L'RALOCM01   length of move from field & x'00' pad
         STC   R7,0(,R14)      first byte of wtopc buffer is length
         LA    R14,1(,R14)
         MVCL  R14,R6          move print message into buffer
         LA    R6,L'RALOCM01+1
* save registers
         GETCC DF,L2,FILL=00    get a 1055 block to save regs in
         GETCC DE,L2,FILL=00    get a 1055 block to save regs in
         LGF   R1,CE1CRE
         LGF   R2,CE1CRF
         STMG  R0,R15,0(R1)     save contents of before registers
*
         RALOC BLOCK=R3,SIZE=R6,HEAP=64BIT   reallocate buffer
         LTGR  R3,R3            buffer resized ?
         JZ    RALOCNG
* compare registers to ensure registers not corrupted
         STMG  R0,R15,0(R2)     save contents of after registers
         CLC   0(LEN64REG*3,R1),0(R2)  r0-r2 corrupted across macro ?
         JNE   RALOCNG         -> error
         CLC   LEN64REG*4(LEN64REG*6,R1),LEN64REG*4(R2)  r4-r9 ng ?
         JNE   RALOCNG         -> error
*
         CLC   1(L'RALOCM01,R3),RALOCM01
         JNE   RALOCNG
         LG    R14,=A(0,TWO_GIG)
         CLGR  R3,R14           is buffer above or below the bar ?
         JL    RALOCLOW         -> if buffer below the bar
         PRMSG TEXT='raloc:  1-buf above bar ................',NUM=(R3)
         J     RALOCOK
*
RALOCLOW EQU   *
         PRMSG TEXT='raloc:  1-buf below bar ................',NUM=(R3)
RALOCOK  EQU   *
         PRMSG TEXTA=(R3)
         J     RETRALOC
*
RALOCM01 DC    C'raloc:  1-test executed successfully'
RALOCNG  DS    0F
         PRERR TEXT='raloc: 1-*** Case Failed ***'
         J     RETRALOC
*
RALOCERR DS    0F
         PRMSG TEXT='raloc:  Error case for Assembler not provided'
RETRALOC EQU   *
         FREEC BLOCK=R3
         CRUSA S0=E,S1=F
         EPLGC RC=NONE
         LTORG
         EJECT


         PRLGC ENAME=recvc_macro,BASE=R8,STACK=R13
***********************************************************************
* this function executes the recvc macro                              *
* EBW051(1) - save first byte of psw                                  *
* EBW052(1) - save first byte of psw                                  *
***********************************************************************
* allocate buffers to save registers
         GETCC DF,L2,FILL=00    get a 1055 block to save regs in
         GETCC DE,L2,FILL=00    get a 1055 block to save regs in
         LGF   R1,CE1CRE
         LGF   R2,CE1CRF
*
         CLI   EBX000,X'00'  error cases requested ?
         JNE   RECVCERR      --> recvc error cases
         J     RECVC000      --> recvc normal cases
*
*
RECVCERR DS    0F
         PRMSG TEXT='recvc:  Error case for Assembler not provided'
         J     RETRECVC
*
*
RECVCNG1 EQU   *
         PRERR TEXT='recvc: 1-registers corrupted'
*
RECVCNG EQU   *
         PRERR TEXT='recvc: 1-*** Case Failed ***'
         J     RETRECVC
*
*
RECVC000 DS    0F
         PRMSG TEXT='recvc:  1-if a dump follows this msg, test failed'
         MONTC ,             must be in supervisor state
         STMG  R0,R15,0(R1)  save contents of registers before recvc
         STNSM EBW051,X'FF'-SYS_EXT-SYS_IO       disable interrupts
         RECVC EP=RECVC100   set routine for a dump to go to
         STMG  R0,R15,0(R2)  save contents of registers after recvc
         DC    X'0000'       cause a dump
*
RECVC100 DS    0F
**  reset to normal processing
         RECVC EP=RESET      reset protection
         STOSM EBW052,SYS_EXT+SYS_IO       enable interrupts
         LMONC ,
* compare registers to ensure registers not corrupted
         CLC   0(LEN64REG*10,R1),0(R2)   are regs r0-r9 corrupted ?
         JNE   RECVCNG1                 yes, -> error
         CLC   LEN64REG*11(LEN64REG,R1),LEN64REG*11(R2)  r11 ng ?
         JNE   RECVCNG1                 yes, -> error
         CLC   LEN64REG*14(LEN64REG,R1),LEN64REG*14(R2)  r14 ng ?
         JNE   RECVCNG1                 yes, -> error
*
         PRMSG TEXT='recvc:  1-test executed successfully'
*
*
RETRECVC EQU   *
         CRUSA S0=E,S1=F
         EPLGC RC=NONE
         LTORG
         EJECT


         PRLGC ENAME=ritid_macro,BASE=R8,STACK=R13
***********************************************************************
* this function tests the amode option of the ritid macro             *
* to "self check" one case requests an id that is known to be defined *
* and the error case requests an undefined record id (0000)           *
* also self checks to ensure the registers have not been changed      *
***********************************************************************
         SGR   R1,R1               used for ritid work area
         SGR   R2,R2               used for buffer of after registers
         SGR   R3,R3               used for buffer of before registers
         SGR   R6,R6               used for error message buffer
         CLI   EBX000,X'00'        error cases requested ?
         JNE   RITIDERR            branch if yes
         PRMSG TEXT='ritid:  1-Executing amode=64 option'
* allocate and initialize error message
         LA    R6,L'RITIDM01+1     get a block for the error message
         MALOC SIZE=R6,HEAP=64BIT
         LA    R14,L'RITIDM01       length of error message
         STC   R14,0(R6)
         MVC   1(L'RITIDM01,R6),RITIDM01
* allocate buffers to save registers
         LA    R3,LEN64REG*16       get a block to save before regs
         MALOC SIZE=R3,HEAP=64BIT
         LTGR  R3,R3               address of block is zero if error
         JZ    RITIDNG
         LA    R2,LEN64REG*16      get a block to save after registers
         MALOC SIZE=R2,HEAP=64BIT
         LTGR  R2,R2               address of block is zero if error
         JZ    RITIDNG
         DCTRIT
         USING RTID,R1
         LA    R1,RITIDLN          size of item from RITID
         MALOC SIZE=R1             workarea for RITID
         MVI   RITRID,C'A'         set record id in workarea
         MVI   RITRID+1,C'A'       set record id in workarea
         STMG  R0,R15,0(R3)        save contents of registers
         RITID AMODE=64            get a RIAT entry
         STMG  R0,R15,0(R2)        save contents of registers
         CLC   0(LEN64REG*16,R3),0(R2)  r0-r15 corrupted across macro ?
         JNE   RITIDNG             yes, -> error
         LLGF  R14,RITADDR         base for RIAT item
         LTGR  R14,R14
         JZ    RITIDNG             RIAT entry not found
         PRMSG TEXT='ritid:  1-test executed successfully'
         J     RETRITID
*
* error test cases
RITIDERR DS    0F
         PRMSG TEXT='ritid:  2-amode=64 option, for undefined record'
* allocate and initialize error message
         LA    R6,L'RITIDM02+1     get a block for the error message
         MALOC SIZE=R6,HEAP=64BIT
         LA    R14,L'RITIDM02       length of error message
         STC   R14,0(R6)
         MVC   1(L'RITIDM02,R6),RITIDM02
* allocate buffers to save registers
         LA    R3,LEN64REG*16       get a block to save before regs
         MALOC SIZE=R3,HEAP=64BIT
         LTGR  R3,R3               address of block is zero if error
         JZ    RITIDNG
         LA    R2,LEN64REG*16      get a block to save after registers
         MALOC SIZE=R2,HEAP=64BIT
         LTGR  R2,R2               address of block is zero if error
         JZ    RITIDNG
         LA    R1,RITIDLN          size of item from RITID
         MALOC SIZE=R1             workarea for RITID
         XC    RITRID,RITRID       set record id to hex zeros
         STMG  R0,R15,0(R3)        save contents of registers
         RITID AMODE=64            get a RIAT entry
         STMG  R0,R15,0(R2)        save contents of registers
         CLC   0(LEN64REG*10,R3),0(R2)  r0-r9 corrupted across macro ?
         JNE   RITIDNG             yes, -> error
         LLGF  R14,RITADDR         base for RIAT item
         LTGR  R14,R14
         JNZ   RITIDNG             RIAT entry found is not expected
         PRMSG TEXT='ritid:  2-test executed successfully'
         J     RETRITID
*
RITIDNG  DS    0F
         PRERR TEXTA=(R6)
         J     RETRITID
*
RITIDM01 DC    C'ritid: 1-*** normal test Case Failed ***'
RITIDM02 DC    C'ritid: 2-*** error test Case Failed ***'
*
RETRITID DS    0F
         FREEC BLOCK=R1
         FREEC BLOCK=R2
         FREEC BLOCK=R3
         FREEC BLOCK=R6
         EPLGC RC=NONE
         LTORG
         EJECT


         PRLGC ENAME=rsysc_macro,BASE=R8,STACK=R13
***********************************************************************
* this function tests the new options of the rsysc macro: unique token*
***********************************************************************
         CLI   EBX000,X'00'  error cases requested ?
         JNE   RSYSCERR      branch if yes
         PRMSG TEXT='rsysc:  Normal case for Assembler not provided'
         J     RETRSYSC
*
RSYSCERR EQU   *
         PRMSG TEXT='rsysc:  1-Executing 64 bit heap option'
* allocate buffers to save registers
         GETCC DF,L2,FILL=00    get a 1055 block to save regs in
         GETCC DE,L2,FILL=00    get a 1055 block to save regs in
         LGF   R1,CE1CRE
         LGF   R2,CE1CRF
*
         LA    R3,2                   request 2 1MB frames
         LA    R4,SAVEREGS(,R1)
         MVC   0(L'RTOKEN,R4),RTOKEN  set up token for gsysc
         LA    R5,L'RTOKEN(,R4)
         MVC   0(L'ROWNER,R5),ROWNER  set up owner for gysc
         GSYSC FRAMES=R3,HEAP=64BIT,TYPE=1MB,TOKEN=R4,UNIQUE=YES,      X
               OWNER=R5
         LTGR  R3,R3            address of block is zero if error
         JZ    RSYSCNG1
* send message to console if gsysc'd buffer above or below the bar
         LG    R6,=A(0,TWO_GIG)
         CLGR  R3,R6           is buffer address above or below the bar ?
         JL    RSYSCLOW        -> if buffer below the bar
         PRMSG TEXT='rsysc:  1-buf above bar ................',NUM=(R3)
         J     RSYSCONT
*
* local constants for this function
RTOKEN   DC    C'api-rsyc'
ROWNER   DC    C'51driver-api-rsysc_macro'
*
*
RSYSCNG1 DS    0F
         ERRNOC FUNC=GET,VALUE=R1
         PRERR TEXT='rsysc: 1-gsysc failed - error code ....',NUM=(R1)
         J     RSYSCNG
*
RSYSCNG2 DS    0F
         ERRNOC FUNC=GET,VALUE=R1
         PRERR TEXT='rsysc: 1-rsysc failed - error code ....',NUM=(R1)
         SGR   R3,R3
*
RSYSCNG  EQU   *
         PRERR TEXT='rsysc: 1-*** Case Failed ***'
         J     RETRSYSC
*
RSYSCLOW EQU   *
         PRMSG TEXT='rsysc:  1-buf below bar ................',NUM=(R3)
RSYSCONT EQU   *
         STMG  R0,R15,0(R1)     save contents of before registers
         RSYSC TOKEN=R4
* compare registers to ensure registers not corrupted
         STMG  R0,R15,0(R2)      save contents of after registers
         LTGR  R15,R15           was rsysc successful ?
         JNZ   RSYSCNG2          -> error
         CLC   0(LEN64REG*10,R1),0(R2)  r0-r9 corrupted across macro ?
         JNE   RSYSCNG           -> error
* the following rsysc should fail, as the buffer was already released
         PRMSG TEXT='rsysc:  1-releasing buffer already released'
         STMG  R0,R15,0(R1)     save contents of before registers
         RSYSC TOKEN=R4
         STMG  R0,R15,0(R2)      save contents of after registers
         LTGR  R15,R15           was rsysc successful ?
         JZ    RSYSCNG2           -> error if rsysc returns successful
         CLC   0(LEN64REG*10,R1),0(R2)  r0-r9 corrupted across macro ?
         JNE   RSYSCNG           -> error
         PRMSG TEXT='rsysc:  1-test executed successfully'
*
RETRSYSC EQU   *
         CRUSA S0=E,S1=F
         EPLGC RC=NONE
         LTORG
         EJECT

         PRLGC ENAME=swisc_macro,BASE=R8,STACK=R13
***********************************************************************
* this function executes the swisc macro with the IMMEDIATE parm      *
* it switches to another istream to to execute the program            *
*                                                                     *
* ECB FIELDS                                                          *
* CE1CSN(1) - field that determines istream of current program        *
***********************************************************************
         J     SWISC00        define constants here, fix base reg blown
MAINIS   DC    H'1'
ISTR3    DC    H'3'
*
SWISC00  DS    0H
         LA    R3,3                     do stuff
         SWISC TYPE=IMMEDIATE,IS=R3     switch istream ret to prog
         CLC   CE1ISN,ISTR3             correct istream switch?
         BNE   SWISERR
*
         SWISC TYPE=IMMEDIATE,IS=MAIN   switch istream ret to prog
         CLC   CE1ISN,MAINIS            correct istream swtich?
         BNE   SWISERR
         PRMSG TEXT='swisc:  1-test executed successfully'
         B     SWISDONE
*
SWISERR  DS    0H
         PRMSG TEXT='swisc w/immed parm switches to wrong istream'
*
SWISDONE DS    0H
         EPLGC RC=NONE
         LTORG
         EJECT

         PRLGC ENAME=tamcc_macro,BASE=R8,STACK=R13
***********************************************************************
* this function tests the new options of the tamcc macro:             *
*   ECBPSW EXTERNAL IO MACHINE PROGRAM RESTART SVC MODE64 MODE31      *
* EBW051(1) - switch:  00=good,  FF=error                             *
***********************************************************************
         J     TAMCC00       define constants here, fix base reg blown
*
* local constants for this function
TAMCCM01 DC    C'tamcc:  1-test executed successfully'
TAMCCM02 DC    C'tamcc:  1-*** Case Failed ***'
*
*
TAMCC00  DS    0F
         CLI   EBX000,X'00'     error cases requested ?
         JNE   TAMCCERR         branch if yes
         PRMSG TEXT='tamcc:  starting assembler test cases'
* allocate buffers to save registers
         GETCC DF,L2,FILL=00    get a 1055 block to save regs in
         GETCC DE,L2,FILL=00    get a 1055 block to save regs in
         GETCC DD,L2,FILL=00    1055 block for good output msg
         GETCC DC,L2,FILL=00    1055 block fir bad output msg
         LGF   R6,CE1CRC
         LGF   R7,CE1CRD
         LGF   R1,CE1CRE
         LGF   R2,CE1CRF
         LA    R5,L'TAMCCM01     length of good output message
         STC   R5,0(,R7)         first byte of wtopc buffer is length
         LA    R5,L'TAMCCM02     length of error output message
         STC   R5,0(,R6)         first byte of wtopc buffer is length
         MVC   1(L'TAMCCM01,R7),TAMCCM01   set up good output  message
         MVC   1(L'TAMCCM02,R6),TAMCCM02   set up error output  message
*
* test case 1
         PRMSG TEXT='tamcc:  1-check PSW saved in ECB (in CE3PSW)'
         MVI   EBW051,X'00'     set error switch to good
         LARL  R5,TAMCC164      set up tamcc to branch to this address
         STMG  R0,R15,0(R1)     save contents of before registers
         TAMCC ECBPSW,MODE64=(R5),MODE31=TAMCC131
         STMG  R0,R15,0(R2)     save contents of after registers
         MVI   EBW051,X'FF'     set error switch to ng
         J     TAMCC1XA
TAMCC164 EQU   *
         STMG  R0,R15,0(R2)      save contents of after registers
         PRMSG TEXT='tamcc:  1-PSW in ECB (in CE3PSW) is 64 bit mode'
         J     TAMCC1XA
TAMCC131 EQU   *
         STMG  R0,R15,0(R2)      save contents of after registers
         PRMSG TEXT='tamcc:  1-PSW in ECB (in CE3PSW) is 31 bit mode'
* compare registers to ensure registers not corrupted
TAMCC1XA EQU   *
         CLC   0(LEN64REG*14,R1),0(R2)  r0-r13 corrupted across macro ?
         JE    TAMCC1XX                 no -->
         MVI   EBW051,X'FF'     set error switch to ng
TAMCC1XX EQU   *
         BRAS  R4,TAMCCOMG      send output message
*
* test case 2
         PRMSG TEXT='tamcc:  2-check external old PSW'
         MVI   EBW051,X'00'     set error switch to good
         LARL  R5,TAMCC264      set up tamcc to branch to this address
         MVI   9(R7),C'2'       set test case # in output msg
         MVI   9(R6),C'2'       set test case # in output msg
         STMG  R0,R15,0(R1)     save contents of before registers
         TAMCC EXTERNAL,MODE64=(R5),MODE31=TAMCC231
         STMG  R0,R15,0(R2)     save contents of after registers
         MVI   EBW051,X'FF'     set error switch to ng
         J     TAMCC2XA
TAMCC264 EQU   *
         STMG  R0,R15,0(R2)      save contents of after registers
         PRMSG TEXT='tamcc:  2-external old PSW is 64 bit mode'
         J     TAMCC2XA
TAMCC231 EQU   *
         STMG  R0,R15,0(R2)      save contents of after registers
         PRMSG TEXT='tamcc:  2-external old PSW is 31 bit mode'
* compare registers to ensure registers not corrupted
TAMCC2XA EQU   *
         CLC   0(LEN64REG*14,R1),0(R2)  r0-r13 corrupted across macro ?
         JE    TAMCC2XX                 no -->
         MVI   EBW051,X'FF'     set error switch to ng
TAMCC2XX EQU   *
         BRAS  R4,TAMCCOMG      send output message
*
* test case 3
         PRMSG TEXT='tamcc:  3-check I/O old PSW'
         MVI   EBW051,X'00'     set error switch to good
         LARL  R5,TAMCC364      set up tamcc to branch to this address
         MVI   9(R7),C'3'       set test case # in output msg
         MVI   9(R6),C'3'       set test case # in output msg
         STMG  R0,R15,0(R1)     save contents of before registers
         TAMCC IO,MODE64=(R5),MODE31=TAMCC331
         STMG  R0,R15,0(R2)     save contents of after registers
         MVI   EBW051,X'FF'     set error switch to ng
         J     TAMCC3XA
TAMCC364 EQU   *
         STMG  R0,R15,0(R2)      save contents of after registers
         PRMSG TEXT='tamcc:  3-I/O old PSW is 64 bit mode'
         J     TAMCC3XA
TAMCC331 EQU   *
         STMG  R0,R15,0(R2)      save contents of after registers
         PRMSG TEXT='tamcc:  3-I/O old PSW is 31 bit mode'
* compare registers to ensure registers not corrupted
TAMCC3XA EQU   *
         CLC   0(LEN64REG*14,R1),0(R2)  r0-r13 corrupted across macro ?
         JE    TAMCC3XX                 no -->
         MVI   EBW051,X'FF'     set error switch to ng
TAMCC3XX EQU   *
         BRAS  R4,TAMCCOMG      send output message
*
* test case 4
         PRMSG TEXT='tamcc:  4-check machine old PSW'
         MVI   EBW051,X'00'     set error switch to good
         LARL  R5,TAMCC464      set up tamcc to branch to this address
         MVI   9(R7),C'4'       set test case # in output msg
         MVI   9(R6),C'4'       set test case # in output msg
         STMG  R0,R15,0(R1)     save contents of before registers
         TAMCC MACHINE,MODE64=(R5),MODE31=TAMCC431
* if the machine check old psw is zero, then there is no psw
* otherwise the psw is invalid
         STMG  R0,R15,0(R2)     save contents of after registers
         MVI   EBW051,X'FF'     set error switch to ng
         LMG   R14,R15,352(R0)  load machine check old psw
         LTGR  R14,R14
         JNZ   TAMCC4XX         --> if 24 bit or invalid
         LTGR  R15,R15
         JNZ   TAMCC4XX         --> if 24 bit or invalid
         PRMSG TEXT='tamcc:  4-machine check old PSW does not exist'
         MVI   EBW051,X'00'     psw is not invalid if it does not exist
         J     TAMCC4XA
TAMCC464 EQU   *
         STMG  R0,R15,0(R2)      save contents of after registers
         PRMSG TEXT='tamcc:  4-machine old PSW is 64 bit mode'
         J     TAMCC4XA
TAMCC431 EQU   *
         STMG  R0,R15,0(R2)      save contents of after registers
         PRMSG TEXT='tamcc:  4-machine old PSW is 31 bit mode'
* compare registers to ensure registers not corrupted
TAMCC4XA EQU   *
         CLC   0(LEN64REG*14,R1),0(R2)  r0-r13 corrupted across macro ?
         JE    TAMCC4XX                 no -->
         MVI   EBW051,X'FF'     set error switch to ng
TAMCC4XX EQU   *
         BRAS  R4,TAMCCOMG      send output message
*
* test case 5
         PRMSG TEXT='tamcc:  5-check program old PSW'
         MVI   EBW051,X'00'     set error switch to good
         LARL  R5,TAMCC564      set up tamcc to branch to this address
         MVI   9(R7),C'5'       set test case # in output msg
         MVI   9(R6),C'5'       set test case # in output msg
         STMG  R0,R15,0(R1)     save contents of before registers
         TAMCC PROGRAM,MODE64=(R5),MODE31=TAMCC531
         STMG  R0,R15,0(R2)     save contents of after registers
         MVI   EBW051,X'FF'     set error switch to ng
         J     TAMCC5XA
TAMCC564 EQU   *
         STMG  R0,R15,0(R2)      save contents of after registers
         PRMSG TEXT='tamcc:  5-program old PSW is 64 bit mode'
         J     TAMCC5XA
TAMCC531 EQU   *
         STMG  R0,R15,0(R2)      save contents of after registers
         PRMSG TEXT='tamcc:  5-program old PSW is 31 bit mode'
* compare registers to ensure registers not corrupted
TAMCC5XA EQU   *
         CLC   0(LEN64REG*14,R1),0(R2)  r0-r13 corrupted across macro ?
         JE    TAMCC5XX                 no -->
         MVI   EBW051,X'FF'     set error switch to ng
TAMCC5XX EQU   *
         BRAS  R4,TAMCCOMG      send output message
*
* test case 6
         PRMSG TEXT='tamcc:  6-check restart old PSW'
         MVI   EBW051,X'00'     set error switch to good
         LARL  R5,TAMCC664      set up tamcc to branch to this address
         MVI   9(R7),C'6'       set test case # in output msg
         MVI   9(R6),C'6'       set test case # in output msg
         STMG  R0,R15,0(R1)     save contents of before registers
         TAMCC RESTART,MODE64=(R5),MODE31=TAMCC631
         STMG  R0,R15,0(R2)     save contents of after registers
         MVI   EBW051,X'FF'     set error switch to ng
         LMG   R14,R15,288(R0)  load restart old psw
         LTGR  R14,R14
         JNZ   TAMCC6XX         --> if 24 bit or invalid
         LTGR  R15,R15
         JNZ   TAMCC6XX         --> if 24 bit or invalid
         PRMSG TEXT='tamcc:  6-restart old PSW does not exist'
         MVI   EBW051,X'00'     psw is not invalid if it does not exist
         J     TAMCC6XA
TAMCC664 EQU   *
         STMG  R0,R15,0(R2)      save contents of after registers
         PRMSG TEXT='tamcc:  6-restart old PSW is 64 bit mode'
         J     TAMCC6XA
TAMCC631 EQU   *
         STMG  R0,R15,0(R2)      save contents of after registers
         PRMSG TEXT='tamcc:  6-restart old PSW is 31 bit mode'
* compare registers to ensure registers not corrupted
TAMCC6XA EQU   *
         CLC   0(LEN64REG*14,R1),0(R2)  r0-r13 corrupted across macro ?
         JE    TAMCC6XX                 no -->
         MVI   EBW051,X'FF'     set error switch to ng
TAMCC6XX EQU   *
         BRAS  R4,TAMCCOMG      send output message
*
* test case 7
         PRMSG TEXT='tamcc:  7-check svc old PSW'
         MVI   EBW051,X'00'     set error switch to good
         LARL  R5,TAMCC764      set up tamcc to branch to this address
         MVI   9(R7),C'7'       set test case # in output msg
         MVI   9(R6),C'7'       set test case # in output msg
         STMG  R0,R15,0(R1)     save contents of before registers
         TAMCC SVC,MODE64=(R5),MODE31=TAMCC731
         STMG  R0,R15,0(R2)     save contents of after registers
         MVI   EBW051,X'FF'     set error switch to ng
         J     TAMCC7XA
TAMCC764 EQU   *
         STMG  R0,R15,0(R2)      save contents of after registers
         PRMSG TEXT='tamcc:  7-svc old PSW is 64 bit mode'
         J     TAMCC7XA
TAMCC731 EQU   *
         STMG  R0,R15,0(R2)      save contents of after registers
         PRMSG TEXT='tamcc:  7-svc old PSW is 31 bit mode'
* compare registers to ensure registers not corrupted
TAMCC7XA EQU   *
         CLC   0(LEN64REG*14,R1),0(R2)  r0-r13 corrupted across macro ?
         JE    TAMCC7XX                 no -->
         MVI   EBW051,X'FF'     set error switch to ng
TAMCC7XX EQU   *
         BRAS  R4,TAMCCOMG      send output message
         J     RETTAMCC
*
*
* routine to send output message
TAMCCOMG EQU   *
         CLI   EBW051,X'00'     send successful message ?
         JE    TAMCCOK          yes, ->
         PRERR TEXTA=(R6)       send error message
         BCR   15,R4            return
*
TAMCCOK  EQU   *
         PRMSG TEXTA=(R7)       send successful message
         BCR   15,R4            return
*
*
TAMCCERR DS    0F
         PRMSG TEXT='tamcc:  Error case for Assembler not provided'
*
RETTAMCC EQU   *
         CRUSA S0=C,S1=D,S2=E,S3=F
         EPLGC RC=NONE
         LTORG
         EJECT


         PRLGC ENAME=uatbc_macro,BASE=R8,STACK=R13
         CLI   EBX000,X'00'  error cases requested ?
         JNE   UATBC1        branch if yes
         PRMSG TEXT='uatbc:  Assembler driver not provided'
         J     RETUATBC
UATBC1   DS    0F
         PRMSG TEXT='uatbc:  Assembler driver not provided'
RETUATBC EQU   *
         EPLGC RC=NONE
         LTORG


         PRLGC ENAME=valbc_macro,BASE=R8,STACK=R13
***********************************************************************
* this function tests the new option on the valbc macro:  LFRM1MB     *
***********************************************************************
         SGR   R3,R3
* allocate buffers to save registers
         GETCC DF,L2,FILL=00    get a 1055 block to save regs in
         GETCC DE,L2,FILL=00    get a 1055 block to save regs in
         LGF   R1,CE1CRE
         LGF   R2,CE1CRF
*
         CLI   EBX000,X'00'  error cases requested ?
         JNE   VALBCERR      branch if yes
         J     VALBC000
*
* local constants for this function
VTOKEN   DC    C'api-valb'
VOWNER   DC    C'51driver-api-valbc_macro'
*
*
VALBCNG1 DS     0F
         ERRNOC FUNC=GET,VALUE=R1
         PRERR TEXT='valbc: 1-gsysc failed - error code ....',NUM=(R1)
         J     VALBCNG
*
VALBCNG2 EQU   *
         ERRNOC FUNC=GET,VALUE=R1
         PRERR TEXT='valbc: 1-rsysc failed - error code ....',NUM=(R1)
*
VALBCNG  EQU   *
         PRERR TEXT='valbc: 1-*** Case Failed ***'
         J     RETVALBC
*
VALBC000 DS    0F
         PRMSG TEXT='valbc:  1-Executing valbc for inuse 1 meg block'
         LA    R3,1                   request 1 1MB frames
         LA    R4,SAVEREGS(,R1)
         MVC   0(L'VTOKEN,R4),VTOKEN  set up token for gsysc
         LA    R5,L'VTOKEN(,R4)
         MVC   0(L'VOWNER,R5),VOWNER  set up owner for gysc
         GSYSC FRAMES=R3,HEAP=64BIT,TYPE=1MB,TOKEN=R4,UNIQUE=YES,      X
               OWNER=R5
         LTGR  R3,R3            address of block is zero if error
         JZ    VALBCNG1
* send message to console if gsysc'd buffer above or below the bar
         LG    R6,=A(0,TWO_GIG)
         CLGR  R3,R6           is buffer address above or below the bar ?
         JL    VALBCLOW        -> if buffer below the bar
         PRMSG TEXT='valbc:  1-buf above bar ................',NUM=(R3)
         J     VALBCONT
*
VALBCLOW EQU   *
         PRMSG TEXT='valbc:  1-buf below bar ................',NUM=(R3)
VALBCONT EQU   *
**       LA    R6,LFRM1MB     set 1 Meg type for valbc
*        STMG  R0,R15,0(R1)     save contents of before registers
**       VALBC CHECKIN=EVM,BLOCK=R3,TYPE=R6
**       JNZ   VALBCNG          cc 0 means block is valid and in use
* compare registers to ensure registers not corrupted
*        STMG  R0,R15,0(R2)      save contents of after registers
*        CLC   0(LEN64REG*10,R1),0(R2)  r0-r9 corrupted across macro ?
*        JNE   VALBCNG           -> error
**       PRMSG TEXT='valbc:  1-test executed successfully'
*
         PRMSG TEXT='valbc:  2-Executing valbc for released meg block'
         SGR   R3,R3            set address of released block to zero
         RSYSC TOKEN=R4         release the 1 meg block
         LTGR  R15,R15          rsysc error ?
         JNZ   VALBCNG2
*        STMG  R0,R15,0(R1)     save contents of before registers
         VALBC CHECKIN=EVM,BLOCK=R3,TYPE=R6
         BRC   9,VALBCNG        cc 1 or 2 = block is valid & not in use
* compare registers to ensure registers not corrupted
*        STMG  R0,R15,0(R2)      save contents of after registers
*        CLC   0(LEN64REG*10,R1),0(R2)  r0-r9 corrupted across macro ?
*        JNE   VALBCNG           -> error
         PRMSG TEXT='valbc:  2-test executed successfully'
         J     RETVALBC
*
*
VALBCERR DS    0F
         PRMSG TEXT='valbc:  1-address 1 meg block, for wrong type'
*
         LA    R3,1                   request 1 1MB frames
         LA    R4,SAVEREGS(,R1)
         MVC   0(L'VTOKEN,R4),VTOKEN  set up token for gsysc
         LA    R5,L'VTOKEN(,R4)
         MVC   0(L'VOWNER,R5),VOWNER  set up owner for gysc
         GSYSC FRAMES=R3,HEAP=64BIT,TYPE=1MB,TOKEN=R4,UNIQUE=YES,      X
               OWNER=R5
         LTGR  R3,R3            address of block is zero if error
         JZ    VALBCNG1
* send message to console if gsysc'd buffer above or below the bar
         LG    R6,=A(0,TWO_GIG)
         CLGR  R3,R6           is buffer address above or below the bar ?
         JL    VALBCER2        -> if buffer below the bar
         PRMSG TEXT='valbc:  1-1MB buf > bar ................',NUM=(R3)
         J     VALBCER4
*
VALBCER2 EQU   *
         PRMSG TEXT='valbc:  1-1MB buf < bar ................',NUM=(R3)
VALBCER4 EQU   *
         LA    R6,LFRAME     set type to ecb frame
         STMG  R0,R15,0(R1)     save contents of before registers
         VALBC CHECKIN=EVM,BLOCK=R3,TYPE=R6
         JNH   VALBCNG          cc 2 = addr not in range of req type
* compare registers to ensure registers not corrupted
         STMG  R0,R15,0(R2)      save contents of after registers
         CLC   0(LEN64REG*10,R1),0(R2)  r0-r9 corrupted across macro ?
         JNE   VALBCNG           -> error
         PRMSG TEXT='valbc:  1-test executed successfully'
*
*
RETVALBC EQU   *
         LTGR  R3,R3
         JZ    RETVALXX
         RSYSC TOKEN=R4
         LTGR  R15,R15          rsysc successful
         JZ    RETVALXX         yes -> continue to exit
         ERRNOC FUNC=GET,VALUE=R1
         PRERR TEXT='valbc: 1-rsysc failed - error code ....',NUM=(R1)
RETVALXX EQU   *
         CRUSA S0=E,S1=F
         EPLGC RC=NONE
         LTORG
         EJECT

         FINIS
* local definitions for pnamc_macro
PNAMCRET DSECT
RETBUF   DS    0CL5
NAME     DS    CL4
SPARE    DS    CL1
*
ECBTABLE DSECT
NUMITEMS DS    CL8              number of items in table
         DS    CL4              spare
FILEADR  DS    CL4              file address
ECBADR   DS    CL8              svm address of ecb
NUMECBS  EQU   3                number of items in table
*
         END
