/*********************************************************************/
/*      Licensed Materials - Property of IBM                         */
/*      "Restricted Materials of IBM"                                */
/*      5748-T15                                                     */
/*      (C) Copyright IBM Corp. 2005                                 */
/*      All Rights Reserved                                          */
/*      US Government Users Restricted Rights - Use, duplication     */
/*      or dislosure restricted by GSA ADP Schedule Contract         */
/*      with IBM Corp.                                               */
/*********************************************************************/
/* This file is provided on an "as is" basis.  There are no          */
/* warranties, express or implied, including the implied warranties  */
/* of merchantability and fitness for a particular purpose.          */
/* IBM has no obligation to provide service, defect correction, or   */
/* any maintenance for the file.  IBM has no obligation to supply    */
/* any updates or enhancements for the file to you even if such are  */
/* or later become available.                                        */
/*********************************************************************/
/* Change History                                                    */
/* 20041001  Initial Version                                         */
/*                                                                   */
/*                                                                   */
/*                                                                   */
/*********************************************************************/
/*                                                                   */
/* GENERAL INFORMATION:                                              */
/*                                                                   */
/* Segment Name:  QMAF.cpp                                           */
/*                                                                   */
/* Abstract:      This program tests crosc()'s ability to pass a     */
/*                parameter list.  It modifies the data, and then    */
/*                returns double the initial value.  The calling     */
/*                program verifies the returned value.               */
/*                                                                   */
/* Description:   This program is called from the crosc_func in the  */
/*                qmac10.cpp file.                                   */
/*                                                                   */
/*********************************************************************/
#include <tpf/sysapi.h>

extern "C" long QMAF(struct TPF_regs *regs)
{
  long ans = regs->r1;         /* Assign the value in r1 to ans */
  ans *= 2;                    /* Change the value of ans       */

  return ans;
} /* end of extern "C"                                               */
