/*********************************************************************/
/*      Licensed Materials - Property of IBM                         */
/*      "Restricted Materials of IBM"                                */
/*      5748-T15                                                     */
/*      (C) Copyright IBM Corp. 2005                                 */
/*      All Rights Reserved                                          */
/*      US Government Users Restricted Rights - Use, duplication     */
/*      or dislosure restricted by GSA ADP Schedule Contract         */
/*      with IBM Corp.                                               */
/*********************************************************************/
/* This file is provided on an "as is" basis.  There are no          */
/* warranties, express or implied, including the implied warranties  */
/* of merchantability and fitness for a particular purpose.          */
/* IBM has no obligation to provide service, defect correction, or   */
/* any maintenance for the file.  IBM has no obligation to supply    */
/* any updates or enhancements for the file to you even if such are  */
/* or later become available.                                        */
/*********************************************************************/
/* Change History                                                    */
/* 20041001  Initial Version                                         */
/*                                                                   */
/*                                                                   */
/*                                                                   */
/*********************************************************************/
/*                                                                   */
/* GENERAL INFORMATION:                                              */
/*                                                                   */
/* Segment Name:  QMAG.cpp                                           */
/*                                                                   */
/* Abstract:      This program returns 2 times the number passed in  */
/*                in the first register if the 2nd register has been */
/*                passed to it correctly and contains the word       */
/*                "test"...otherwise, it returns the number 1.       */
/*                                                                   */
/* Description:   This program is called from the crosc_func in the  */
/*                qmac10.cpp file.                                   */
/*                                                                   */
/*********************************************************************/
#include <tpf/sysapi.h>
#include <string.h>

extern "C" long QMAG(struct TPF_regs *regs)
{
  long ans = regs->r1;                /* Assign r1 to ans            */
  char *letter = (char *)regs->r2;    /* Assign r2 to letter         */

  if(strcmp(letter, "test") == 0)
    ans *= 2;                         /* returns double the r1 value */
  else
    ans = 1;                          /* returns 1 in the error case */

  return ans;
} /* end of extern "C"                                               */
