         PRINT NOGEN
         BEGIN NAME=QMAK,IBM=YES
***********************************************************************
*          Licensed Materials - Property of IBM                       *
*          "Restricted Materials of IBM"                              *
*          5748-T15                                                   *
*          (C) Copyright IBM Corp. 2005                               *
*          All Rights Reserved                                        *
*          US Government Users Restricted Rights - Use, duplication   *
*          or disclosure restricted by GSA ADP Schedule Contract      *
*          with IBM Corp.                                             *
***********************************************************************
*  This file is provided on an "as is" basis.  There are no           *
*  warranties, express or implied, including the implied warranties   *
*  of merchantability and fitness for a particular purpose.           *
*  IBM has no obligation to provide service, defect correction, or    *
*  any maintenance for the file.  IBM has no obligation to supply     *
*  any updates or enhancements for the file to you even if such are   *
*  or later become available.                                         *
***********************************************************************
*  Change History                                                     *
*  20041001  Initial Version                                          *
*                                                                     *
*                                                                     *
*                                                                     *
***********************************************************************
*                                                                     *
*  Segment Name:  QMAK.asm                                            *
*                                                                     *
*  Related Segments:                                                  *
*                                                                     *
*  Abstract:  member of macro driver                                  *
*                                                                     *
*                                                                     *
*  Description: This segment is part of the macro driver.             *
*               It tests the 31-bit GETPC macro                       *
*                                                                     *
*                                                                     *
***********************************************************************
*                                                                     *
*  INTERFACE REQUIREMENTS:                                            *
*                                                                     *
*  Dependencies:  None                                                *
*                                                                     *
*  Restrictions:  None                                                *
*                                                                     *
* ------------------------------------------------------------------- *
*                                                                     *
*  Input:                                                             *
*                                                                     *
*  Output:                                                            *
*                                                                     *
*                                                                     *
*  ECB WORKAREA USAGE                                                 *
*                                                                     *
*                                                                     *
*                                                                     *
*                                                                     *
*---------------------------------------------------------------------*
*                                                                     *
*   INTERNAL:                                                         *
*                                                                     *
*   Register conventions:                                             *
*                                                                     *
*                                                                     *
*                                                                     *
*---------------------------------------------------------------------*
*---------------------------------------------------------------------*
         MACRO
         INPUT_PARMS
INPUT_PARMS DSECT
ICASE        DS  XL4
SNAP         DS  XL2
BSO_NAME     DS  XL4
LSET_NAME    DS  CL8
BSO          DS  XL1
CSO          DS  XL1
&SYSECT    CSECT
         MEND
         INPUT_PARMS
         SPACE
         B     LETS_GO
*---------------------------------------------------------------------*
* SNAP LIST                                                           *
*                                                                     *
*---------------------------------------------------------------------*
LIST1     LISTC   NAME=PROGRAM,TAG=EBW000,LEN=(R1),INDIR=YES
          LISTC   END
MSG1      DC      AL1(MSG1E-MSG1S)
MSG1S     DC      C'PROGRAM'
MSG1E     EQU     *
LIST2     LISTC   NAME=PROGRAM,TAG=EBW000,LEN=(R1),INDIR=YES
          LISTC   NAME=LOADSET,TAG=EBW008,LEN=8
          LISTC   END
MSG2      DC      AL1(MSG2E-MSG2S)
MSG2S     DC      C'GETPC ADDR'
MSG2E     EQU     *
          EJECT
LETS_GO       DS    0H
              PRMSG TEXT='STARTING THE 31-bit GETPC MACRO TEST'
              USING INPUT_PARMS,R3
              L     R3,EBX012   Load the low end of the 64 bit addr)
*                               passed from c)
              L     R0,ICASE
*---------------------------------------------------------------------*
* CASE#16-- Testing the GETPC macro error case                        *
*                                                                     *
* Attributes Returned:                                                *
* ATTRIBUTE TRANSLATION:                                              *
*                                                                     *
*---------------------------------------------------------------------*
CASE16         DS      0H
               LTR     R0,R0
               BE      CASE16_DO
               CH      R0,=H'16'
               BNE     RETGETPC
CASE16_DO      DS      0H
   PRMSG   TEXT='GETPC: ERROR CASE#16-Default parms, NAME=(Rx)'
               ICM     R5,B'1111',BSO_NAME
               GETPC   NAME=(R5),ERROR=GETPCE16,                       +
               ADDR=R6
             PRMSG TEXT='GETPC: UNEXPECTED RESULT- CASE#16 SUCCESSFUL'
               LH      R1,SNAP
               LTR     R1,R1
               BZ      SKIPSNAP16
               ST      R6,EBW000
               SNAPC   R,000001,PREFIX=I,MSG=MSG1,LIST=LIST1
SKIPSNAP16     DS      0H
               B       RETGETPC
GETPCE16       DS      0H
               PRMSG   TEXT='GETPC: EXPECTED RESULT- CASE#16 FAILED'
               B       RETGETPC
               EJECT  1
*---------------------------------------------------------------------*
* RETURN                                                              *
*                                                                     *
*---------------------------------------------------------------------*
            SPACE  1
RETGETPC    EQU    *
            PRMSG   TEXT='COMPLETING THE 31-bit GETPC MACRO TEST'
            BACKC
*
            LTORG
            FINIS   QMAK
            END
