/*********************************************************************/
/*      Licensed Materials - Property of IBM                         */
/*      "Restricted Materials of IBM"                                */
/*      5748-T15                                                     */
/*      (C) Copyright IBM Corp. 2005                                 */
/*      All Rights Reserved                                          */
/*      US Government Users Restricted Rights - Use, duplication     */
/*      or dislosure restricted by GSA ADP Schedule Contract         */
/*      with IBM Corp.                                               */
/*********************************************************************/
/* This file is provided on an "as is" basis.  There are no          */
/* warranties, express or implied, including the implied warranties  */
/* of merchantability and fitness for a particular purpose.          */
/* IBM has no obligation to provide service, defect correction, or   */
/* any maintenance for the file.  IBM has no obligation to supply    */
/* any updates or enhancements for the file to you even if such are  */
/* or later become available.                                        */
/*********************************************************************/
/* Change History                                                    */
/* 20070713  Initial Version                                         */
/*                                                                   */
/*                                                                   */
/*                                                                   */
/*********************************************************************/
/*                                                                   */
/* GENERAL INFORMATION:                                              */
/*                                                                   */
/* Segment Name:  QMAP                                               */
/*                                                                   */
/* Contents:      qmap()                                             */
/*                                                                   */
/* Abstract:      This program is used to test ZDCRT in the          */
/*                CP User Enhancements project                       */
/*                                                                   */
/* Description:   This program is cretc-ed to from drv_zdcrt_func()  */
/*                in qmac80.cpp file.  It displays the time to       */   
/*                activate the ECB after the cretc was called        */
/*                                                                   */
/*********************************************************************/

#include <tpf/sysapi.h>
#include <sys/time.h>
#include <qmac80.h>
#include <tpf/c_eb0eb.h>
#include <tpf/tpfapi.h>

extern "C" void QMAP()
{
   char msgbuffer[100];           // for printing messages
   struct timeval startTime;
   struct timeval currentTime;
   int TimeDiff = 0;
   int TimeDiffSecs = 0;
   int TimeDiffMins = 0;
   struct cretc_parms *parms;
   struct wtopc_header msg_hdr;
   char time_units[8];
   
   parms = (cretc_parms *)ecbptr()->ce1cr0;

   gettimeofday(&currentTime, NULL);
   startTime = parms->StartTime;

   if(parms->units==CRETC_SECONDS)
     sprintf(time_units,"SECONDS");

   if(parms->units==CRETC_MINUTES)
     sprintf(time_units,"MINUTES");
   
   if(((TimeDiff = (currentTime.tv_sec - startTime.tv_sec)) > 59) && (parms->units==CRETC_MINUTES))
   {
   	 TimeDiffMins = TimeDiff/60;
   	 TimeDiffSecs = TimeDiff%60;

     sprintf(msgbuffer,"QMAP ECB ACTIVATED AFTER: %d MIN %d SEC", TimeDiffMins, TimeDiffSecs);
     wtopc_insert_header(&msg_hdr, "QMAP", 1, 'I', WTOPC_SYS_TIME);
     wtopc(msgbuffer,WTOPC_EBROUT, WTOPC_CHAIN, &msg_hdr);
   }	 
   else	
   {
     sprintf(msgbuffer,"QMAP ECB ACTIVATED AFTER: %d SECONDS", TimeDiff);
     wtopc_insert_header(&msg_hdr, "QMAP", 1, 'I', WTOPC_SYS_TIME);
     wtopc(msgbuffer,WTOPC_EBROUT, WTOPC_CHAIN, &msg_hdr);
   }
 
   sprintf(msgbuffer,"                   CRETC TIME VALUE: %d %s", parms->desiredElapsedTime,time_units);
   wtopc(msgbuffer, WTOPC_EBROUT, WTOPC_CHAIN_END, WTOPC_NO_HEADER);
} // end of extern "C"
