         PRINT NOGEN
         BEGIN NAME=QMAX,IBM=YES,BASE=(R6,R7),AMODE=64,EREGSAVE=YES
***********************************************************************
*          Licensed Materials - Property of IBM                       *
*          "Restricted Materials of IBM"                              *
*          5748-T15                                                   *
*          (C) Copyright IBM Corp. 2005                               *
*          All Rights Reserved                                        *
*          US Government Users Restricted Rights - Use, duplication   *
*          or disclosure restricted by GSA ADP Schedule Contract      *
*          with IBM Corp.                                             *
***********************************************************************
*  This file is provided on an "as is" basis.  There are no           *
*  warranties, express or implied, including the implied warranties   *
*  of merchantability and fitness for a particular purpose.           *
*  IBM has no obligation to provide service, defect correction, or    *
*  any maintenance for the file.  IBM has no obligation to supply     *
*  any updates or enhancements for the file to you even if such are   *
*  or later become available.                                         *
***********************************************************************
*  Change History                                                     *
*  20041001  Initial Version                                          *
*  20110207  Rename Q111 and Q222 to QM11 and QM22 to resolve         *
*            program name conflicts with libstdc++34. Refer to        *
*            feature/defect 21558 and 21700 for more info.            *
*                                                                     *
*                                                                     *
***********************************************************************
*                                                                     *
* GENERAL INFORMATION:                                                *
* BSO name:       QMAX                                                *
* Members:        qmax.asm                                            *
* Called by:      qmac50.asm or qmac22.asm (both are members of QMAC) *
* Purpose: Test cases for PNAMC or Extended Register Save capability  *
*                                                                     *
***********************************************************************
         DRV51
         SGR   R1,R1         used for buffers of before registers
         SGR   R2,R2         used for buffer of after registers
         SGR   R3,R3         field for returned info from pnamc
*
* allocate buffers to save registers
         LA    R1,LEN64REG*16
         MALOC SIZE=R1,HEAP=64BIT
         LTGR  R1,R1         address of block is zero if error

         JNZ   PNAMC000      no error, -> continue processing
         PRERR TEXT='QMAX: error in set up *** Case Failed ***'
         J     RETPNAMC
*
PNAMC000 DS    0H
         LA    R2,LEN64REG*16
         MALOC SIZE=R2,HEAP=64BIT
         LTGR  R2,R2         address of block is zero if error
         JNZ   PNAMC010      no error, -> continue processing
         PRERR TEXT='QMAX: error in set up *** Case Failed ***'
         J     RETPNAMC
*
PNAMC010 DS    0H
         CLC   EBX020,DEFBCID Test case for DEFBC
         JE    DEFBC000       Yes
         USING PNAMCRET,R3
         MVC   EBCM01,EBW000 Set Verbose flag
         LA    R3,L'RETBUF
         MALOC SIZE=R3,HEAP=64BIT
         LTGR  R3,R3         address of block is zero if error
         JNZ   PNAMC020      no error, -> continue processing
         PRERR TEXT='QMAX: error in set up *** Case Failed ***'
         J     RETPNAMC
*
*********************************************************
* The following two testcases are in QMAX:              *
*     PNAMC NEWTRNAME CALLER NOTFOUND testcase          *
*     PNAMC (SAVENAME)CALLER NOTFOUND testcase          *
* After executing testcases, QMAX will call QM11.       *
* QMAX BSO is composed of program QMAX, QM11 and QM22   *
* The Function Nesting Area for QMAX: None              *
* CVZZ ->QMAX -------> QMAX -------> QM11 -------> QM22 *
*              ENTDC      ENTRC,TYPE=INT   ENTRC        *
*********************************************************
* PNAMC NEWTRNAME CALLER NOTFOUND testcase
* test case #1- update CE3TRNAME with the CALLER option
*               there is no caller for QMAX
PNAMC020 DS    0H
         PRMSG TEXT='QMAX: 1-Testing PNAMC NEWTRNAME,CALLER NOTFOUND'
         STMG  R0,R15,0(R1)  save contents of registers
         PNAMC NEWTRNAME,NAMETYPE=CALLER,NOTFOUND=PNAMC022
         PRERR TEXT='QMAX: 1-Found error *** Case Failed ***'
         J     PNAMC030      -> next test case
PNAMC022 DS    0H
         STMG  R0,R15,0(R2)  save contents of registers
         CLC   0(LEN64REG*14,R1),0(R2)  r0-r13 corrupted across macro?
         JE    PNAMC026      no error, -> continue processing
         PRERR TEXT='QMAX: 1-Registers corrupted *** Case Failed ***'
         J     PNAMC030      -> next test case
PNAMC026 DS    0H
         PRMSG TEXT='QMAX: 1-Test executed successfully'
*
* PNAMC (SAVENAME) CALLER NOTFOUND testcase
* test case #2- update FIELD with the CALLER option
*
PNAMC030 DS    0H
         PRMSG TEXT='QMAX: 2-Testing  PNAMC SAVENAME,CALLER NOTFOUND'
         STMG  R0,R15,0(R1)  save contents of registers
         PNAMC FIELD=NAME,NAMETYPE=CALLER,NOTFOUND=PNAMC032
         PRERR TEXT='QMAX: 2-Found error *** Case Failed ***'
         J     PNAMC040      -> next test case
PNAMC032 DS    0H
         STMG  R0,R15,0(R2)  save contents of registers
         CLC   0(LEN64REG*14,R1),0(R2)  r0-r13 corrupted across macro?
         JE    PNAMC036      no error, -> continue processing
         PRERR TEXT='QMAX: 2-Registers corrupted *** Case Failed ***'
         J     PNAMC040      continue processing rest of tests
PNAMC036 DS    0H
         PRMSG TEXT='QMAX: 2-Test executed successfully'
*
PNAMC040 DS    0H
         FREEC BLOCK=R1
         FREEC BLOCK=R2
         FREEC BLOCK=R3

         PRMSG TEXT='QMAX: ENTRC QM11'
         ENTRC QM11          use TYPE=INT will cause some cases fail
         PRMSG TEXT='QMAX:  Complete testing PNAMC macro'
RETPNAMC DS    0H
         EXITC
*****************************
* EREGSAVE/DEFBC  test case *
*****************************
*
* Check Invalid cases here:
* 1. Without EREGSAVE=YES/ENABLE in BEGIN macro, DEFBC EREGSAVE=NO/YES
*    get assemble error RC=8
* 2. Without PUSH, DEFBC POP=EREGSAVE gets assemble error RC = 8
*
DEFBC000 DS    0H
         PRMSG TEXT='QMAX: Test BEGIN ..,TPFISOC=NO,EREGSAVE=YES'
         STMG  R10,R13,0(R1)  Save contents of registers
         LA    R7,D1
         GETCC D1,L2,FILL=00
         STMG  R10,R13,0(R2)  Save contents of registers
         CLC   0(LEN64REG*4,R1),0(R2)  r10-r13 corrupted across macro?
         JE    DEFBC006      No error, -> continue processing
         PRERR TEXT='QMAX: 1-Registers corrupted  * Case Failed *'
         J     DEFBC010      -> Next test case
DEFBC006 DS    0H
         PRMSG TEXT='QMAX: 1-Call GETCC, r10-r13 saved successfully'
DEFBC010 DS    0H
*
* Call DEFBC EREGSAVE=NO
         PRMSG TEXT='QMAX: Call DEFBC EREGSAVE=NO'
         DEFBC EREGSAVE=NO
         STMG  R10,R13,0(R1)  Save contents of registers
         DETAC ACPDB
         STMG  R10,R13,0(R2)  Save contents of registers
         CLC   0(LEN64REG*4,R1),0(R2)  r10-r13 corrupted across macro?
         JNE    DEFBC026     No error -> continue processing
         PRERR TEXT='QMAX: 2-Registers did not corrupt  *Case Failed*'
         J     DEFBC040      -> Next test case
DEFBC026 DS    0H
         PRMSG TEXT='QMAX: 2-Call DETACO, r10-r13 corrupted'
DEFBC040 DS    0H
*
* Call DEFBC EREGSAVE=YES,PUSH
         PRMSG TEXT='QMAX: Call DEFBC EREGSAVE=YES,PUSH'
         DEFBC EREGSAVE=YES,PUSH
         STMG  R10,R13,0(R1)  Save contents of registers
         ATTAC ACPDB
         STMG  R10,R13,0(R2)  Save contents of registers
         CLC   0(LEN64REG*4,R1),0(R2)  r10-r13 corrupted across macro?
         JE    DEFBC046       No error -> continue processing
         PRERR TEXT='QMAX: 3-Registers corrupted  * Case Failed *'
         J     DEFBC060      -> Next test case
DEFBC046 DS    0H
         PRMSG TEXT='QMAX: 3- Call ATTAC, r10-r13 saved successfully'
DEFBC060 DS    0H
*
* Call DEFBC POP=EREGSAVE (registers should not be saved)
         PRMSG TEXT='QMAX: Call DEFBC POP=EREGSAVE'
         DEFBC POP=EREGSAVE
         STMG  R10,R13,0(R1)  Save contents of registers
         CINFC R,CMMTGTBL
         STMG  R10,R13,0(R2)  Save contents of registers
         CLC   0(LEN64REG*4,R1),0(R2)  r10-r13 corrupted across macro?
         JNE   DEFBC066      Corrupted, no error -> continue processing
         PRERR TEXT='QMAX: 4- Registers did not corrupt *Case Failed*'
         J     DEFBC070      -> Next test case
DEFBC066 DS    0H
         PRMSG TEXT='QMAX: 4- Call CINFC, r10-r13 corrupted'
DEFBC070 DS    0H
*
* Call  DEFBC EREGSAVE=YES
         PRMSG TEXT='QMAX: Call DEFBC EREGSAVE=YES'
         DEFBC EREGSAVE=YES
         STMG  R10,R13,0(R1)  Save contents of registers
         RELCC D1
         STMG  R10,R13,0(R2)  Save contents of registers
         CLC   0(LEN64REG*4,R1),0(R2)  r10-r13 corrupted across macro?
         JE    DEFBC076      Corrupted, no error -> continue processing
         PRERR TEXT='QMAX: 5- Registers did not corrupt *Case Failed*'
         J     DEFBC080      -> Next test case
DEFBC076 DS    0H
         PRMSG TEXT='QMAX: 5- Call RELCC, r10-r13 saved successfully'
DEFBC080 DS    0H
         PRMSG TEXT='QMAX: Call BACKC'
         BACKC
         SPACE 1
         LTORG
         FINIS
*
         DS    0D
CTOKEN   DC    C'apicorhc'
DEFBCID  DC    C'DEFBC'
PNAMCRET DSECT
RETBUF   DS    0CL5
NAME     DS    CL4
SPARE    DS    CL1
*
         END
