         PRINT NOGEN
         BEGIN NAME=QMAY,IBM=YES,AMODE=64
***********************************************************************
*          Licensed Materials - Property of IBM                       *
*          "Restricted Materials of IBM"                              *
*          5748-T15                                                   *
*          (C) Copyright IBM Corp. 2005                               *
*          All Rights Reserved                                        *
*          US Government Users Restricted Rights - Use, duplication   *
*          or disclosure restricted by GSA ADP Schedule Contract      *
*          with IBM Corp.                                             *
***********************************************************************
*  This file is provided on an "as is" basis.  There are no           *
*  warranties, express or implied, including the implied warranties   *
*  of merchantability and fitness for a particular purpose.           *
*  IBM has no obligation to provide service, defect correction, or    *
*  any maintenance for the file.  IBM has no obligation to supply     *
*  any updates or enhancements for the file to you even if such are   *
*  or later become available.                                         *
***********************************************************************
*  Change History                                                     *
*  20041001  Initial Version                                          *
*                                                                     *
*                                                                     *
*                                                                     *
***********************************************************************
         DRV51
         CLHEQ
         IEQCE2
         EV0BK ,
***********************************************************************
* this program handles created entries from QMAC functions            *
* 1. crexc'd from QMAC from crexc_macro                               *
* 2. cremc'd from QMAC from ecblc_macro                               *
* this function is used to create a queue of iobs so the ecblc_macro  *
* function can purge them                                             *
*                                                                     *
* parms passed in ebw000                                              *
* ebw000(2) - ECB activation number                                   *
* ebw002(1) - verbose option                                          *
*                                                                     *
* if it is not already running in 64 bit mode, sets the addressing    *
* mode and then resets it before returning for the caller.            *
* self checks ensure the registers have not been changed              *
* ECB FIELDS                                                          *
* EBW050(1) - switch:  00=64bit, FF=reset to 31bit                    *
***********************************************************************
*
         MVI   EBW050,X'00'  init switch for addressing mode to 64 bit
         TAM                 executing in 31 bit 64 bit mode ?
         BRC   1,QMAY64      branch if 64 bit mode
         SAM64               set addressing mode to 64
         MVI   EBW050,X'FF'  set switch to restore addressing mode
QMAY64   EQU   *
         CLC   EBW001(L'XTOKEN),XTOKEN    created from crexc_macro ?
         JNE   ECBLC64
***********************************************************************
* created from crexc_macro function                                   *
***********************************************************************
         MVC   EBCM01,EBW000      set print option passed from qmac
         PRMSG TEXT='crexc:qmay:  ECB created'
         GETCC DF,L2,FILL=00    block to hold post data
         LGF   R2,CE1CRF
         USING EV0BK,R2        post data
         MVC   EVNBKN,XTOKEN   event name to post
         POSTC BLOCK=(R2),TYPE=CNT,NFOUND=CREXCNG1
         PRMSG TEXT='crexc:qmay:  exiting created ECB'
         J     RETQMAY
*
*
CREXCNG1 DS    0F
         PRERR TEXT='crexc:qmay: event not found for post',NUM=(R1)
*
CREXCNG  EQU   *
         PRERR TEXT='crexc:qmay: ..-*** Case Failed ***',NUM=(R1)
         J     RETQMAY
*
*
*
***********************************************************************
* create work for ecblc_macro function                                *
***********************************************************************
ECBLC64  EQU   *
         MVC   EBCM01,EBW002      set print option passed from qmac
         LGH   R1,EBW000          activation number
         STG   R1,EBW000          convert half byte to 8 bytes
         PRMSG TEXT='ecblc:qmay:  ..-ECB created',NUM=(R1)
* set up
* ensure first activated ECB executes first
         PRMSG TEXT='ecblc:qmay: ecb # ................',NUM=(R1)
         CGHI  R1,X'1'          defer, to ensure first activated ecb
         JE    ECBLC100         executes first
         DEFRC ,
ECBLC100 EQU   *
         GETCC DF,L2,FILL=00    block to hold post data
         LGF   R2,CE1CRF
         USING EV0BK,R2        post data
         MVC   EVNBKN,ECBLCEV1 event name to post
         LA    R3,ETOKEN       token name of gsysc buffer to find
         PRMSG TEXT='ecblc:qmay: ..-finding ECBLC table',NUM=(R1)
         FSYSC TOKEN=R3      locate ECBLC table
         LTGR  R3,R3         was fsysc successful ?
         JZ    ECBLCNG       no, -> error
         PRMSG TEXT='ecblc:qmay: ..-store ECB svm adr in tbl',NUM=(R1)
         LGF   R4,CE2SVA(R11,R9)  get sva of ecb
         PRMSG TEXT='ecblc:qmay: ..-locking ECBLC table',NUM=(R1)
         ENQC  BLOCK=ETOKEN  lock to access table
         USING ECBTABLE,R3
         CINFC W,CMMOPS        set protection key to update table
         MVC   CE1FMD(L'FILEADR),FILEADR  move file address into table
* search for empty slot to store my ECB in
         LG    R6,NUMITEMS     number of ecb slots in table
         SGR   R7,R7           item index
ECBLC200 EQU   *
         LG    R14,ECBADR(R7)
         LTGR  R14,R14
         JZ    ECBLC300        found empty slot, -> update table
         LA    R7,L'ECBADR(R7) update index to next slot
         BCTG R6,ECBLC200
         PRERR TEXT='ecblc:qmay: ..-*error* ECBLC table full',NUM=(R1)
         KEYRC                 restore protection key
         DEQC  BLOCK=ETOKEN    unlock table
         J     RETECBLC        abort processing
* update table
ECBLC300 EQU   *
         STG   R4,ECBADR(R7)   store my ECB address into table
         KEYRC                 restore protection key
         PRMSG TEXT='ecblc:qmay: ..-update and unlock tbl',NUM=(R1)
         PRMSG TEXT='ecblc:qmay: ..-find and hold record',NUM=(R1)
         DEQC  BLOCK=ETOKEN               unlock table
*
         XC    CE1FAD(4),CE1FAD   avoid record id and rcc checks
         POSTC BLOCK=(R2),TYPE=CNT,NFOUND=ECBLCNG1
         CGHI  R1,X'1'          defer once again to ensure first ecb    d13334
         JE    ECBLC350         executes first                          d13334
         DEFRC ,                                                        d13334
         FIWHC DD,ECBLCNG0        hold record
ECBLC350 EQU   *
*
* ensure first activated ECB waits for qmac to issue ecblc
         CGHI  R1,X'1'          is this the first activated ecb ?
         JNE   ECBLC420         no -->                                  d13334
* set up for event
         XC    EVNBKN(EVNBKL),EVNBKN   reinitialize the event block
         STH   R1,EVNBKC1       first ecb waits for ecblcs to be issued
         MVC   EVNBKN,ECBLCEV2  event name
         EVNTC BLOCK=(R2),TYPE=CNT,NAME=Y,DUPNAM=ECBLCNG3
         EVNWC BLOCK=(R2),TYPE=CNT,ERROR=ECBLCNG2,NFOUND=ECBLCNG2
*
ECBLC420 EQU   *
* if we got here, we assume qmac has purged our iobs
         ENQC  BLOCK=ETOKEN    lock to access table
         PRMSG TEXT='ecblc:qmay: ..-iob purged, reset table',NUM=(R1)
         CINFC W,CMMOPS        set protection key to update table
         SGR   R14,R14         clear ecb from table to indicate
         STG   R14,ECBADR(R7)  the hold was cleared
         KEYRC                 restore protection key
         PRMSG TEXT='ecblc:qmay: ..-tbl slot cleared - post',NUM=(R1)
         DEQC  BLOCK=ETOKEN    unlock table
         LA    R6,3000         max number retries to post event
ECBLC450 EQU   *
* set up to post
         XC    EVNBKN(EVNBKL),EVNBKN   reinitialize the event block
         MVC   EVNBKN,ECBLCEV3 event name
         POSTC BLOCK=(R2),TYPE=CNT,NFOUND=ECBLCNF
         PRMSG TEXT='ecblc:qmay: ..-exiting ECB',NUM=(R1)
*
RETECBLC EQU   *
         CLI   CE1HLD,X'00'  if record still held, unhold it
         JZ    RETQMAY
         UNFRC DD
*
*
RETQMAY  EQU   *
         CRUSA S0=D,S1=F
         CLI   EBW050,X'00'  restore addressing mode ?
         JE    RETQMA64      no, -> return
         SAM31               restore addressing mode of caller
RETQMA64 EQU   *
         EXITC
*
*
ECBLCNG0 DS    0F
         TM    CE1SUD+13,CXSGDLK  check detail err ind for data level D
         JO    ECBLC350      dead lock detected --> normal processing
         PRERR TEXT='ecblc:qmay: ..-fiwhc returned an error',NUM=(R1)
         J     ECBLCNG
*
ECBLCNG1 DS    0F
         PRERR TEXT='ecblc:qmay: ..-event not found for post',NUM=(R1)
         J     ECBLCNG
*
ECBLCNG2 DS    0F
         PRERR TEXT='ecblc:qmay: ..-event error',NUM=(R1)
         J     ECBLCNG
*
ECBLCNG3 DS    0F
         PRERR TEXT='ecblc:qmay: ..-create duplicate event',NUM=(R1)
         J     ECBLCNG
*
ECBLCNF  DS    0F              retry routine for post event
         CLI   CE1HLD,X'00'  if record still held, unhold it
         JZ    ECBLCNF1
         UNFRC DD
ECBLCNF1 EQU   *
         DEFRC ,
         BCTG R6,ECBLC450
         PRERR TEXT='ecblc:qmay: ..-event not found for post',NUM=(R1)
*
ECBLCNG  DS    0F
         PRERR TEXT='ecblc:qmay: ..-*** Case Failed ***',NUM=(R1)
         J     RETECBLC
*
* local constants for this function
ETOKEN   DC    C'api-ecbl'        post name for ecblc function
XTOKEN   DC    C'api-crex'        post name for crexc function
ECBLCEV1 DC    C'ECBLCEV1'
ECBLCEV2 DC    C'ECBLCEV2'
ECBLCEV3 DC    C'ECBLCEV3'

*
         LTORG
         FINIS
*
ECBTABLE DSECT
NUMITEMS DS    CL8              number of items in table
         DS    CL4              spare
FILEADR  DS    CL4              file address
ECBADR   DS    CL8              svm address of ecb
*
         END
